SystemOrganization addCategory: #'NativeBoost-Core'!
SystemOrganization addCategory: #'NativeBoost-Core-Errors'!
SystemOrganization addCategory: #'NativeBoost-Core-FFI'!
SystemOrganization addCategory: #'NativeBoost-Core-Heap'!
SystemOrganization addCategory: #'NativeBoost-Core-Objects'!
SystemOrganization addCategory: #'NativeBoost-Core-Types'!

Trait named: #TNBMemoryAccessors
	uses: {}
	category: 'NativeBoost-Core-Objects'!

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:32'!
nbFloat32AtOffset: zeroBasedOffset
	"Read 32-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(float32 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			add: asm EAX with: asm ECX;
			fld: asm EAX ptr32. "load a floating point value from memory, at base address, held in EAX register into fp(0) register,
				we are using #ptr32, to indicate that memory operand size is 32bits long"
	] ! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:34'!
nbFloat32AtOffset: zeroBasedOffset put: value
	"Store 32-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, float32 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX;
			mov: asm EDX to: asm EAX ptr + asm ECX
	] ! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:50'!
nbFloat64AtOffset: zeroBasedOffset
	"Read 64-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(float64 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			add: asm EAX with: asm ECX;
			fld: asm EAX ptr64. "load a floating point value from memory, at base address, held in EAX register into fp(0) register,
				we are using #ptr64, to indicate that memory operand size is 64bits long"
	] ! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:50'!
nbFloat64AtOffset: zeroBasedOffset put: value
	"Store 64-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, float64 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			add: asm EAX with: asm ECX;
			
			mov: asm ESP ptr to: asm ECX;
			mov: asm ECX to: asm EAX ptr;

			mov: asm ESP ptr +4 to: asm ECX;
			mov: asm ECX to: asm EAX ptr +4 
	] ! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:50'!
nbInt16AtOffset: zeroBasedOffset
	
	"Reads signed 16-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int16 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr16 + asm ECX to: asm AX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:59'!
nbInt16AtOffset: zeroBasedOffset  put: value
	
	"Store signed 16-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int16 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DX to: asm EAX ptr16 + asm ECX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:59'!
nbInt32AtOffset: zeroBasedOffset
	
	"Reads signed 32-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int32 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr32 + asm ECX to: asm EAX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:59'!
nbInt32AtOffset: zeroBasedOffset  put: value
	
	"Store signed 32-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int32 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm EDX to: asm EAX ptr32 + asm ECX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 16:59'!
nbInt64AtOffset: zeroBasedOffset
	
	"Reads signed 64-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int64 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr + asm ECX + 4 to: asm EDX;
			mov: asm EAX ptr + asm ECX to: asm EAX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:00'!
nbInt64AtOffset: zeroBasedOffset  put: value
	
	"Store signed 64-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int64 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value low word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX;
			pop: asm EDX; "value high word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX + 4
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:00'!
nbInt8AtOffset: zeroBasedOffset
	
	"Reads signed 8-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int8 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr8 + asm ECX to: asm AL
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:00'!
nbInt8AtOffset: zeroBasedOffset  put: value
	
	"Store signed 8-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int8 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DL to: asm EAX ptr8 + asm ECX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:00'!
nbUInt16AtOffset: zeroBasedOffset
	
	"Reads unsigned 16-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint16 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr16 + asm ECX to: asm AX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:01'!
nbUInt16AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 16-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, uint16 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DX to: asm EAX ptr16 + asm ECX
	] ! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:01'!
nbUInt32AtOffset: zeroBasedOffset
	
	"Reads unsigned 32-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint32 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr32 + asm ECX to: asm EAX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:01'!
nbUInt32AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 32-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, uint32 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm EDX to: asm EAX ptr32 + asm ECX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:01'!
nbUInt64AtOffset: zeroBasedOffset
	
	"Reads unsigned 64-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint64 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr + asm ECX + 4 to: asm EDX;
			mov: asm EAX ptr + asm ECX to: asm EAX
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:02'!
nbUInt64AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 64-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function:  #(void (self, ulong zeroBasedOffset, uint64 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value low word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX;
			pop: asm EDX; "value high word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX + 4
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:02'!
nbUInt8AtOffset: zeroBasedOffset
	
	"Reads unsigned 8-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint8 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr8 + asm ECX to: asm AL
	]
! !

!TNBMemoryAccessors methodsFor: 'memory access +' stamp: 'IgorStasenko 11/24/2012 17:02'!
nbUInt8AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 8-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, uint8 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DL to: asm EAX ptr8 + asm ECX
	] ! !

!CompiledMethod methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/9/2012 04:13'!
forceJIT
	<primitive: 'primitiveForceJIT' module: '' error: errorCode >
	^ self primitiveFailed! !

!CompiledMethod methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 08:20'!
hasNativeCode
	^ self trailerKind == #NativeCodeTrailer! !

!CompiledMethod methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 08:19'!
trailerKind
	"a shortcut accessor to check the trailer kind, without instantiating the trailer"
	| flagByte index |
	flagByte := self at: self size.
	index := flagByte >> 2 + 1.
	^ CompiledMethodTrailer trailerKinds at: index.
! !

!ByteArray class methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 8/3/2011 19:55'!
asNBExternalType: gen

	^ NBByteArrayPtr new! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:03'!
nbFloat32AtOffset: zeroBasedOffset
	"Read 32-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(float32 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			add: asm EAX with: asm ECX;
			fld: asm EAX ptr32. "load a floating point value from memory, at base address, held in EAX register into fp(0) register,
				we are using #ptr32, to indicate that memory operand size is 32bits long"
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:03'!
nbFloat32AtOffset: zeroBasedOffset put: value
	"Store 32-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function:#(void (self, ulong zeroBasedOffset, float32 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX;
			mov: asm EDX to: asm EAX ptr + asm ECX
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:04'!
nbFloat64AtOffset: zeroBasedOffset
	"Read 64-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCallout function: #(float64 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			add: asm EAX with: asm ECX;
			fld: asm EAX ptr64. "load a floating point value from memory, at base address, held in EAX register into fp(0) register,
				we are using #ptr64, to indicate that memory operand size is 64bits long"
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:04'!
nbFloat64AtOffset: zeroBasedOffset put: value
	"Store 64-bit float at ZERO-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCallout function: #(void (self, ulong zeroBasedOffset, float64 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			add: asm EAX with: asm ECX;
			
			mov: asm ESP ptr to: asm ECX;
			mov: asm ECX to: asm EAX ptr;

			mov: asm ESP ptr +4 to: asm ECX;
			mov: asm ECX to: asm EAX ptr +4 
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:04'!
nbInt16AtOffset: zeroBasedOffset
	
	"Reads signed 16-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int16 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr16 + asm ECX to: asm AX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:04'!
nbInt16AtOffset: zeroBasedOffset  put: value
	
	"Store signed 16-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int16 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DX to: asm EAX ptr16 + asm ECX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:04'!
nbInt32AtOffset: zeroBasedOffset
	
	"Reads signed 32-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int32 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr32 + asm ECX to: asm EAX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:05'!
nbInt32AtOffset: zeroBasedOffset  put: value
	
	"Store signed 32-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int32 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm EDX to: asm EAX ptr32 + asm ECX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:05'!
nbInt64AtOffset: zeroBasedOffset
	
	"Reads signed 64-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int64 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr + asm ECX + 4 to: asm EDX;
			mov: asm EAX ptr + asm ECX to: asm EAX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:05'!
nbInt64AtOffset: zeroBasedOffset  put: value
	
	"Store signed 64-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int64 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value low word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX;
			pop: asm EDX; "value high word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX + 4
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:05'!
nbInt8AtOffset: zeroBasedOffset
	
	"Reads signed 8-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(int8 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr8 + asm ECX to: asm AL
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:05'!
nbInt8AtOffset: zeroBasedOffset  put: value
	
	"Store signed 8-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, int8 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DL to: asm EAX ptr8 + asm ECX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:06'!
nbLongAt: index
	"Read signed long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		options: #( optCheckFailOnEveryArgument );
		function: #(long (self, ulong index)) emit: [:gen |
			| asm |
			
			asm := gen asm.
			asm 
				pop: asm EAX;  "pointer to receiver's first byte"
				pop: asm ECX; "index"
				mov: asm EAX ptr + asm ECX -1 to: asm EAX.
		] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:06'!
nbLongAt: index put: value
	"Store signed long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong index, long value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			add: asm EAX with: asm ECX;
			pop: asm ECX; "value"
			mov: asm ECX to: asm EAX ptr -1
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:07'!
nbUInt16AtOffset: zeroBasedOffset
	
	"Reads unsigned 16-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint16 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr16 + asm ECX to: asm AX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:07'!
nbUInt16AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 16-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^self nbCallout function: #(void (self, ulong zeroBasedOffset, uint16 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DX to: asm EAX ptr16 + asm ECX
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:07'!
nbUInt32AtOffset: zeroBasedOffset
	
	"Reads unsigned 32-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint32 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr32 + asm ECX to: asm EAX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:07'!
nbUInt32AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 32-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, uint32 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm EDX to: asm EAX ptr32 + asm ECX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:07'!
nbUInt64AtOffset: zeroBasedOffset
	
	"Reads unsigned 64-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint64 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr + asm ECX + 4 to: asm EDX;
			mov: asm EAX ptr + asm ECX to: asm EAX
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:07'!
nbUInt64AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 64-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, uint64 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value low word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX;
			pop: asm EDX; "value high word"
			mov: asm EDX to: asm EAX ptr32 + asm ECX + 4
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:08'!
nbUInt8AtOffset: zeroBasedOffset
	
	"Reads unsigned 8-bit integer from memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(uint8 (self, ulong zeroBasedOffset)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			mov: asm EAX ptr8 + asm ECX to: asm AL
	]
! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:08'!
nbUInt8AtOffset: zeroBasedOffset  put: value
	
	"Store unsigned 8-bit integer into memory at (receiver's address + ZERO-based offset) using native byte order.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(void (self, ulong zeroBasedOffset, uint8 value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "offset"
			pop: asm EDX; "value"
			mov: asm DL to: asm EAX ptr8 + asm ECX
	] ! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:08'!
nbUlongAt: index
	"Read unsigned long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout 
		options: #( optCheckFailOnEveryArgument );
	
		function: #(ulong (self, ulong index)) emit: [:gen |
			| asm |
			
			asm := gen asm.
			asm 
				pop: asm EAX;  "pointer to receiver's first byte"
				pop: asm ECX; "index"
				mov: asm EAX ptr + asm ECX -1 to: asm EAX. ]! !

!ByteArray methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 11/23/2012 18:09'!
nbUlongAt: index put: value
	"Store unsigned long at one-based index.
	Note, there is no range checking "

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^  self nbCallout function: #(void (self, ulong index, ulong value)) emit: [:gen |
		| asm |
		
		asm := gen asm.
		asm 
			pop: asm EAX;  "pointer to receiver's first byte"
			pop: asm ECX; "index"
			add: asm EAX with: asm ECX;
			pop: asm ECX; "value"
			mov: asm ECX to: asm EAX ptr -1
	] ! !

Error subclass: #NBCodeGenRecursion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Errors'!

!NBCodeGenRecursion commentStamp: '<historical>' prior: 0!
I am used to SIGNAL recursion error during code generation..

Do not confuse me with NBRecursionDetect  notification,
which is used to detect recursion.

A recursion usually happens when generating code for some method requires generating code for very same method, and so it enters infinite loop!

!Behavior methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 9/28/2010 08:03'!
externalTypeAlias: aTypeName
	"override, if you want to introduce type aliases.
	Answering nil means no type alias for given type name exists"
	^ nil! !

!Behavior methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/18/2010 13:02'!
nbBindingOf: aName
	"answer a binding for a type name,
	by default use smalltalk name bindings"
	^ self bindingOf: aName! !

!Behavior methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/30/2010 12:34'!
nbFnArgument: argName generator: gen

	"Load the instance variable with given name" 

	(self allInstVarNames includes: argName) ifFalse: [ ^ nil ].
	^ NBSTIvarArgument new receiverClass: self; ivarName: argName! !

!Integer methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/28/2010 12:19'!
asNBExternalType: gen
	"integer value in callout argument description aray are pushed directly on stack
	
	#( 100 )  - an integer value argument = 100
	"
	^ NBFFIConst value: (self )! !

!String class methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/28/2010 16:56'!
asNBExternalType: gen

	^ gen resolveType: #NBExternalString! !

!String methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/19/2010 13:19'!
asNBExternalString

	^ NBExternalAddress fromString: self! !

!String methodsFor: '*NativeBoost-Core' stamp: 'IgorStasenko 12/20/2011 14:53'!
asNBExternalType: gen
	"a string or symbol in argument description array defines a type i.e.
	
	#( long argument )  - whereas 'long'  is type name
	"
	^ gen resolveType: self! !

Error subclass: #NBNativeCodeError
	instanceVariableNames: 'errorCode'
	classVariableNames: ''
	poolDictionaries: 'NativeBoostConstants'
	category: 'NativeBoost-Core-Errors'!

NBNativeCodeError subclass: #NBFFICalloutError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Errors'!

!NBFFICalloutError commentStamp: 'IgorStasenko 2/20/2012 13:52' prior: 0!
My instances indicating an error during execution of FFI callout.
To get a description, i look up in NBFFICallout for custom error messages , in addition to my superclass.
!

!NBFFICalloutError methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/20/2012 13:47'!
description

	^ NBErrorDescriptions at: errorCode ifAbsent: [
		(NBFFICallout messageForCode: errorCode) ifNil: [
		'Error during FFI call: ' , errorCode asString]].
	
! !

!NBNativeCodeError class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/6/2011 17:48'!
signalError: error
	^ self new signalError: error! !

!NBNativeCodeError methodsFor: 'accessing' stamp: 'IgorStasenko 2/20/2012 13:46'!
description

	^ NBErrorDescriptions at: errorCode ifAbsent: [
		'Error during execution of native code: ' , errorCode asString].
	
! !

!NBNativeCodeError methodsFor: 'accessing' stamp: 'IgorStasenko 8/6/2011 18:17'!
errorCode
	^ errorCode! !

!NBNativeCodeError methodsFor: 'accessing' stamp: 'IgorStasenko 2/20/2012 13:04'!
signalError: error
	"set error/code and signal it"
	(errorCode := error) isSymbol 
		ifTrue: [
			" some errors produced by VM translated to symbols. we unifying it here to draw better description from our pool (see
			NativeBoostConstants class>> #initErrorDescriptions )"
			errorCode := ((Smalltalk specialObjectsArray at: 52) indexOf: error ifAbsent: [ ^self signal: self description ]) -1
		].
	
	^ self signal: self description! !

!AJImmediate methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/18/2012 16:49'!
asNBExternalType: gen
	 
	^ NBFFIConst value: self! !

!Boolean methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 4/28/2010 12:19'!
asNBExternalType: gen
	"boolean value in argument description array defines a simple 0 or 1 constant
	
	#( true false )  - turned into a 1 and 0
	"
	^ NBFFIConst value: (self ifTrue: [1] ifFalse:[0])! !

WeakFinalizerItem weakSubclass: #NBWeakFinalizerItem
	instanceVariableNames: 'index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBWeakFinalizerItem methodsFor: 'public API' stamp: 'IgorStasenko 6/2/2012 15:23'!
doNotFinalize
	"send this message to avoid triggering finalization, once weakly-referenced object is dead"
	
	executor := nil.! !

!NBWeakFinalizerItem methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 03:15'!
index
	^ index! !

!NBWeakFinalizerItem methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 03:15'!
index: aNumber
	index := aNumber! !

!NBWeakFinalizerItem methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 03:56'!
list: aList index: i freeIndex: nextFreeIndex

	list := aList.
	index := i.
	next := nextFreeIndex ! !

!NBWeakFinalizerItem methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 03:49'!
markAsFree: oldFreeIndex
	next := oldFreeIndex.
	executor := nil.
	"to make sure"
	self basicAt: 1 put: nil.! !

!NBWeakFinalizerItem methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 03:48'!
nextFreeIndex
	^ next! !

!NBWeakFinalizerItem methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 04:00'!
object: anObject executor: ex

	executor := ex.
	self basicAt: 1 put: anObject! !

!ArrayedCollection methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 5/2/2010 20:32'!
hexDump
	"Utility method, for inspecting the native code"
	^ String streamContents: [:str |
		
		self do: [:each |
			str nextPutAll: (each printStringBase: 16) ] separatedBy: [ str space ] ]! !

ArrayedCollection subclass: #NBExternalArray
	instanceVariableNames: 'data size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

NBExternalArray class
	instanceVariableNames: 'elementType elementSize valueType valueSize'!

!NBExternalArray commentStamp: '<historical>' prior: 0!
I am abstract class which provides a convenient interface to work with arrays which elements are values of some external (C) type.
In order to use me with concrete element type, you must create a subclass of me and initialize element type properly.

Subclassing using public subclass:
 - if you want to create a public subclass of me, then you should make sure that in class-side #initialize method,
you add self-send #initElementType:  and specify the element type name to use. (And of course, initialize the class before attempting to create any instances).

Subclassing with anonymous subclass:
To create an anonymous subclass of me,  use #ofType: protocol, i.e.:

floatArrayClass := NBExternalArray ofType: 'float'.

Please note that separate #at: / #at:put: methods will be automatically added in each and every subclass. 
Never remove them, despite they looking identical to superclass methods!!
!!!!CAUTION!!!! Currently those methods do not perform any range checking for index. So, please make sure you using sane index values (1<= index <= size). 

Also, note, that class instance variables: elementType and elementSize, once initialized, is considered read-only. 
Changing them, once you created at least a single instance of your class may lead to funny consequences.

Arrays in external memory vs object memory:

My instances can work either with data held in object memory or in external memory. The difference is only at instantiation time: 

To create a new array in object memory, just use #new: protocol: 

	myArray := floatArrayClass new:  10.   "create a new array with 10 floats".

To allocate a new array in external memory, use #externalNew: protocol:   

	myArray := floatArrayClass externalNew:  10.  
	..
	myArray free.  "and sure thing, do not forget to free external memory after use".

To check whether array uses object memory or external memory , use #isExternal protocol.

Also, you can convert any external address into NBExternalArray subclass instance, i.e. suppose some external function returns a pointer (instance of NBExternalAddress):

	pointer := self callSomeFunc: 1. 
	
So, in order to access memory at given address as array of 100 elements of type 'int', you can use following: 

	myArray := (NBExternalArray ofType: 'int') onAddress: pointer size: 100.
	myArray at: 1.  "read first element"
	myArray at: 2 put: 50.  "write second element" 
	myArray do: [:each | ...  ] ... etc
			 
(sure thing, in the above example, the "NBExternalArray ofType: 'int' " expression is just to demonstrate the intent. It should be replaced with some variable, which you initialize only once and use many times, because creating an anonymous subclass each time would be highly ineffective )

Supported protocols: 
  	Since NBExternalTypeArray inherits from ArrayedCollection, you're free to use any protocols defined there as well as in its superclasses.
	There's only few additions comparing to ArrayedCollection, like #isExternal and #free .

Copying:
	a #copy behavior is special for external arrays: A copy will always use object memory, even if original used external memory.
!

NBExternalArray class
	instanceVariableNames: 'elementType elementSize valueType valueSize'!

!NBExternalArray class methodsFor: 'private' stamp: 'CiprianTeodorov 12/16/2012 15:49'!
anonymousSubclassInitElementType: aTypeName
	"create and initialize the anonymous subclass of me"

	| newSubclass |
	newSubclass := ClassBuilder new
		newSubclassOf: NBExternalArray
		type: NBExternalArray typeOfClass
		instanceVariables: ''
		from: nil.	"we're not using 'self' to avoid wrong subclassing from anonymous subclass "
	newSubclass initElementType: aTypeName.
	^ newSubclass! !

!NBExternalArray class methodsFor: 'accessing' stamp: 'IgorStasenko 12/7/2012 16:45'!
elementSize
	^ elementSize! !

!NBExternalArray class methodsFor: 'accessing' stamp: 'IgorStasenko 12/7/2012 16:45'!
elementType
	^ elementType! !

!NBExternalArray class methodsFor: 'instance creation' stamp: 'IgorStasenko 12/7/2012 16:45'!
externalNew: numberOfElements
	"answer a fresh instance of receiver, allocated on external memory "
	
	^ self onAddress: (NativeBoost allocate: elementSize * numberOfElements) size: numberOfElements! !

!NBExternalArray class methodsFor: 'class initialization' stamp: 'IgorStasenko 12/7/2012 16:46'!
initElementType:  aTypeName
	"Initialize the element type and size.
	
	If you want to use a public subclass of me, then make sure you call this method
	in your class #initialize method.
	" 

	elementType := aTypeName.
	elementSize := (NBFFICallout new requestor: self; resolveType: elementType) valueSize .
	self installAccessors.! !

!NBExternalArray class methodsFor: 'private' stamp: 'IgorStasenko 12/7/2012 16:08'!
installAccessors
	"Copy superclass methods, which serve as a template where generated code will be installed.
	Each subclass of NBExternalArray should implement (override) these key methods "
	self basicAddSelector: #at: withMethod: (NBExternalArray >> #at: ) copy.
	self basicAddSelector: #at:put: withMethod: (NBExternalArray >> #at:put: ) copy.
	! !

!NBExternalArray class methodsFor: 'instance creation' stamp: 'IgorStasenko 12/7/2012 16:45'!
new: numberOfElements

	^ self basicNew initializeWithSize: numberOfElements! !

!NBExternalArray class methodsFor: 'class factory' stamp: 'CiprianTeodorov 12/16/2012 15:50'!
ofType: aTypeName
	"Answer an anonymous subclass of receiver, ready for use for creating array(s) with given element type."

	^ self anonymousSubclassInitElementType: aTypeName! !

!NBExternalArray class methodsFor: 'instance creation' stamp: 'IgorStasenko 12/7/2012 16:45'!
onAddress: anNBExternalAddress size: desiredSize
	
	^ self basicNew initializeWithAddress: anNBExternalAddress Size: desiredSize
! !

!NBExternalArray methodsFor: 'accessing' stamp: 'IgorStasenko 12/7/2012 16:42'!
address
	"For external memory arrays, sometimes we may need to get an address"
	^ data! !

!NBExternalArray methodsFor: 'accessing' stamp: 'IgorStasenko 12/7/2012 16:42'!
at: index
	"Answer an element using 1-based index.
	Note, this method used as a template for my anonymous subclasses. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self emitRead! !

!NBExternalArray methodsFor: 'accessing' stamp: 'IgorStasenko 12/7/2012 16:42'!
at: index put: value
	"Set value at 1-based index.
	Note, this method used as a template for my anonymous subclasses. "
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self emitWrite ! !

!NBExternalArray methodsFor: 'private (code generation)' stamp: 'IgorStasenko 12/7/2012 16:44'!
emitCopy: asm 
	"Emit code to copy elementSize bytes from ESP ptr -> EAX ptr "
	| toCopy offset |
	
	toCopy := self class elementSize.
	
	toCopy > 8 ifTrue: [ ^ self emitCopyUsingLoop: asm ].
	
	offset := 0.
	[ toCopy >= 4 ] whileTrue: [
		asm 
			mov: asm ESP ptr + offset to: asm ECX;
			mov: asm ECX to: asm EAX ptr + offset.
			toCopy := toCopy - 4.
			offset := offset + 4.
	].

	toCopy >= 2  ifTrue: [
		asm 
			mov: asm ESP ptr16 + offset to: asm CX;
			mov: asm CX to: asm EAX ptr16 + offset.
		toCopy := toCopy - 2.
		offset := offset + 2.
	].

	toCopy > 0  ifTrue: [
		" last byte "
		asm 
			mov: asm ESP ptr8 + offset to: asm CL;
			mov: asm CL to: asm EAX ptr8 + offset.
	].
! !

!NBExternalArray methodsFor: 'private (code generation)' stamp: 'IgorStasenko 12/7/2012 16:44'!
emitCopyUsingLoop: asm
	| ssi sdi |
	"copy the value using loop "
	ssi := asm reserveTemp.
	sdi := asm reserveTemp.
	asm 
		mov: asm ESI to: ssi;
		mov: asm EDI to: sdi;
		cld;
		mov: asm ESP to: asm ESI;
		mov: asm EAX to: asm EDI;
		mov: self class elementSize to: asm ECX;
		rep;movsb;
		mov: ssi to: asm ESI;
		mov: sdi to: asm EDI;
		releaseTemps: 2.
! !

!NBExternalArray methodsFor: 'private (code generation)' stamp: 'IgorStasenko 12/7/2012 16:44'!
emitRead
	"
	This method generates a native code for #at: method
	the primitive will read a single element at given index in array.
	the value type (elementType) and its size (elementSize) controlled by class side.
	
	Note, data (instance variable) can hold either variable-byte object (holding data in object memory), or
	instance of NBExternalAddress s
	
	!!!!!!Note: no range checking for index!!!!!!
	"
	^ (self nbCalloutIn: thisContext sender) 
		function: 'oop ( uint32 index , void * data )'
		emit: [:gen :proxy :asm |

			" index "
			asm 
				pop: asm EAX;
				dec: asm EAX;
				mov: self class elementSize to: asm ECX;
				mul: asm ECX;
				
				pop: asm ECX; "pointer to array first element -> ECX " 
				add: asm EAX with: asm ECX.  
							
			" EAX <- @data + (elementSize * (index - 1 ) ) "
				
			"Emit code to read a value from given address and return oop"
			(gen resolveType: self class elementType) readOop: asm EAX ptr generator: gen.
		]
! !

!NBExternalArray methodsFor: 'private (code generation)' stamp: 'IgorStasenko 12/7/2012 16:44'!
emitWrite
	"
	This method generates a native code for #at:put: method.
	The primitive will store a single value at given index in array.
	The value type (elementType) and its size (elementSize) controlled by class side.
	
	Note, data can be either variable-byte object (holding data in object memory), or
	instance of NBExternalAddress (holding data in external memory).
	
	To conform with common #at:put: behavior for collections, answer the value we're just put. 
	
	!!!!!!Note: no range checking for index!!!!!!
	
	"
	
	^ (self nbCalloutIn: thisContext sender)
		function: ' oop ( oop value , uint32 index , void * data , ' , self class elementType , ' value )'
		emit: [:gen :proxy :asm | | oop |
			
			oop := gen reserveTemp.
			"save value oop into temp to answer it when we done"
			asm pop: asm EAX;
				mov: asm EAX to: oop.
				
			" index "
			asm 
				pop: asm EAX;
				dec: asm EAX;
				mov: self class elementSize to: asm ECX;
				mul: asm ECX;
				
				pop: asm ECX; "pointer to array first element " 
				add: asm EAX with: asm ECX.  							

			" EAX now = @data + (elementSize * (index - 1 ) ) "
				
			self emitCopy: asm.

			"and finally, return original object "
			asm mov: oop to: asm EAX .
		].
	
! !

!NBExternalArray methodsFor: 'initialize-release' stamp: 'IgorStasenko 12/7/2012 16:43'!
free
	"A convenience method, to explicitly free external memory, symmetrical when using
	#externalNew: protocol for creating receiver.
	Do nothing if receiver is not external array. 
	" 
	self isExternal ifTrue: [
		data free.
	].! !

!NBExternalArray methodsFor: 'initialize-release' stamp: 'IgorStasenko 12/7/2012 16:43'!
initializeWithAddress: anExternalAddress Size: aSize
	"initialize an instance of receiver with data held in external memory"
	size := aSize.
	data := anExternalAddress.
	

	! !

!NBExternalArray methodsFor: 'initialize-release' stamp: 'IgorStasenko 12/7/2012 16:43'!
initializeWithSize: aSize
	"initialize an instance of receiver with data held in object memory heap "
	size := aSize.
	data := ByteArray new: size * self class elementSize.
	

	! !

!NBExternalArray methodsFor: 'testing' stamp: 'IgorStasenko 12/7/2012 16:44'!
isExternal
	"answer true if data referenced by receiver located in external heap, or just in object memory "
	^ data class ~= ByteArray ! !

!NBExternalArray methodsFor: 'copying' stamp: 'IgorStasenko 12/7/2012 16:43'!
postCopy
	
	self isExternal ifTrue: [
		"copy the data from external memory into newly allocated byte array "
		| newData sz |
		sz := self class elementSize * size.
		newData := ByteArray new: sz.
		NativeBoost memCopy: data to: newData size: sz.
		data := newData.
	] ifFalse: [
		data := data copy.
	]! !

!NBExternalArray methodsFor: 'accessing' stamp: 'IgorStasenko 12/7/2012 16:42'!
size
	^ size! !

Announcement subclass: #NBSessionChangeAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

Notification subclass: #NBRecursionDetect
	instanceVariableNames: 'method'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Errors'!

!NBRecursionDetect commentStamp: '<historical>' prior: 0!
i am used to detect recursion during code generation..

use me like following:

NBRecursionDetect in: someMethod during: [
	... some block ..
	].

if recursion is detected, while evaluating the block, then NBCodeGenRecursion error will be signaled.

A recursion usually happens when generating code for some method requires generating code for very same method, and so it enters infinite loop!

!NBRecursionDetect class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 07:02'!
in: aMethod during: aBlock

	(self signalForMethod: aMethod) ifTrue: [
		^ NBCodeGenRecursion signal: aMethod printString
		].

	^ aBlock on: self do: [:ex | ex check: aMethod ].! !

!NBRecursionDetect class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 05:41'!
signalForMethod: aMethod
	^ self new signalForMethod: aMethod
! !

!NBRecursionDetect methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 06:46'!
check: aMethod
	method == aMethod 
		ifTrue: [
			self resume: true "recursion detected"
			  ] 
		ifFalse: [ self pass ]! !

!NBRecursionDetect methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 06:01'!
defaultAction 
	^ false "false indicate no recursion"! !

!NBRecursionDetect methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 05:40'!
method
	^ method! !

!NBRecursionDetect methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/28/2012 05:35'!
signalForMethod: aMethod
	method := aMethod.
	^ self signal! !

!Metaclass methodsFor: '*NativeBoost-Core' stamp: 'Igor.Stasenko 9/28/2010 08:00'!
externalTypeAlias: aName
	"redirect request to my instance side"
	^ self instanceSide externalTypeAlias: aName! !

Object subclass: #NBCallbackCodeGen
	instanceVariableNames: 'gen asm proxy savedEBX savedESI savedEDI savedCStackPointer savedCFramePointer cbIndex savedReenterInterpreter'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core-Objects'!

!NBCallbackCodeGen commentStamp: '<historical>' prior: 0!
The generated callback code does following:

1. Trunk
1.0. Each callback instance has unique trunk code, which is installed into external memory during callback initialization.
1.1. An external function makes a call to trunk address.
1.2. Trunk code sets the globally registered callback index to ECX register and jumps to callback entry code.

2. Entering callback 

2.1. saves the VM's execution state (stack/frame pointers, reenterInterpreter jump buffer). See #saveExecutionState.
2.2. fetching the callback oop for index passed from trunk.
2.3. coercing the callback function arguments to their smalltalk equivalent and creates an array with them. See #emitArgumentsCoercion.
2.4. synthesizes a fresh method context which is an activation of #pvtEnter:stackPointer:primitiveMethod: 
	and swaps the active context with synthesized context. See #activateCallbackContext: .

2.5. increments a global callback counter value. See #incrementCallbackCounter.
2.6. enters an interpreter loop by calling VM's #enterSmalltalkExecutiveImplementation function.

3. Leaving callback.

3.1. A leave procedure starts from method: #primLeave:stackPtr:contextOop:returnValue:primitiveMethod: , which
simply jumps to provided leave address, a code, generated for leaving from given callback.

3.2. Coerce the return value from smalltalk object to it's C equivalent. See #generateCallbackLeaveCodeFor:leaveAddr:.
3.3. Swaps a currently active context with one which were before entering callback
3.4. jumps to #returnToC label in callback entry code
3.5. sets the current C stack frame back to callback enter procedure.
3.6. restores the VM execution state (an opposite to 2.1) , see #restoreExecutionState.
3.7. decrements global callback counter.
3.8. returns to external function
!

!NBCallbackCodeGen methodsFor: 'global addresses' stamp: 'EstebanLorenzano 2/13/2013 16:27'!
CFramePointerAddress

	^ NativeBoost loadSymbol: 'CFramePointer' fromModule: NativeBoost VMModule! !

!NBCallbackCodeGen methodsFor: 'global addresses' stamp: 'IgorStasenko 5/7/2012 12:36'!
CStackPointerAddress

	^ NativeBoost loadSymbol: 'CStackPointer' fromModule: NativeBoost VMModule! !

!NBCallbackCodeGen methodsFor: 'callback entry code' stamp: 'IgorStasenko 9/15/2012 14:36'!
activateCallbackContext: callbackClass

	"Activate a callback context, which is a 
	
	MethodContext sender: s receiver: r method: m arguments: args 
	"

		| ctx method fld |
		
		method := callbackClass callbackEnterMethod.
		ctx := gen reserveTemp.
		fld := gen reserveTemp.
		
		proxy positive32BitIntegerFor: EBP.		
		proxy pushRemappableOop: EAX.  "push EBP -> remappable oops stack"
	
		proxy createInstanceOf: MethodContext size: method frameSize.
		asm mov: EAX to: ctx.
		
		"Fill the context state, which is #('sender' 'pc' 'stackp' 'method' 'closureOrNil' 'receiver')"
	
		proxy integerObjectOf: method initialPC.
		asm mov: ctx to: ECX;
			mov: EAX to: ECX ptr + (proxy ivar: #pc in: MethodContext).
	
		proxy integerObjectOf: method numTemps.
		asm mov: ctx to: ECX;
			mov: EAX to: ECX ptr + (proxy ivar: #stackp in: MethodContext).
		
		NativeBoost extraRootsRegistry emitFetchCallback: cbIndex generator: gen.
		"EAX - callback oop"
	
		asm mov: ctx to: ECX;
			mov: EAX to: ECX ptr + (proxy ivar: #receiver in: MethodContext);
			mov: EAX ptr + (proxy ivar: #enterMethod in: NBFFICallback) to: EDX;
			mov: EDX to: ECX ptr + (proxy ivar: #method in: MethodContext).
			
		

		proxy firstIndexableField: ECX.
		asm mov: EAX to: fld.

		proxy popRemappableOop. "pop EBP from remappable oops stack"
		asm mov: fld to: ECX;
		mov: EAX to: ECX ptr + proxy oopSize. "put stackp as 1st method argument"

		proxy popRemappableOop. "saved arguments array (see #emitArgumentsCoercion)"
		asm mov: fld to: ECX;
		mov: EAX to: ECX ptr.
		
		proxy primitiveMethod.
		asm mov: fld to: ECX;
		mov: EAX to: ECX ptr + (2*proxy oopSize). "save current primitive method oop"


		"Now we swapping the currently active VM context with the context we're just created"		 
		proxy pushRemappableOop: ctx.
		proxy swapActiveContext: [ ctx ] restoreMethod: [ 0 ]. " EAX <- activeContext"
		asm mov: EAX to: ctx.
		proxy popRemappableOop.
		
		"set a sender in new context to be the old context
		ctx - old context, EAX - new context"
		asm mov: ctx to: ECX.
		asm mov: ECX to: EAX ptr + (proxy ivar: #sender in: MethodContext).
! !

!NBCallbackCodeGen methodsFor: 'callback leave code' stamp: 'IgorStasenko 5/7/2012 12:48'!
decrementCallbackCounter

	"increment callback counter value"
	asm mov: NativeBoost forCurrentPlatform callbackCounterAddress asUImm32 to: EAX.
	asm dec: EAX ptr32.
	! !

!NBCallbackCodeGen methodsFor: 'callback entry code' stamp: 'IgorStasenko 9/15/2012 19:53'!
emitArgumentsCoercion
	" input - none,
	output - an arguments array in remmappable oops stack top"
	| args argOop i |
	args := gen reserveTemp.
	argOop := gen reserveTemp.
	
	asm decorateWith:  'emitArgumentsCoercion' during: [
	
		proxy createInstanceOf: Array size: (gen fnSpec arguments size).
		proxy pushRemappableOop: EAX.
	
		i := 0.
		gen fnSpec arguments do: [:arg |
			arg type readOop: (EBP ptr + arg offset) generator: gen.
			asm mov: EAX to: argOop.
			proxy popRemappableOop.
			asm mov: EAX to: args.
			proxy storePointer: i ofObject: args withValue: argOop.
			i := i+1.
			proxy pushRemappableOop: args.
		].

		gen releaseTemps: 2.
	]! !

!NBCallbackCodeGen methodsFor: 'callback entry code' stamp: 'IgorStasenko 5/7/2012 18:29'!
enterSmalltalkExecutiveImplementation

	"call #enterSmalltalkExecutiveImplementation"
	
	| addr |
	
	addr := NativeBoost loadSymbol: 'enterSmalltalkExecutiveImplementation' fromModule: NativeBoost VMModule.
	
	asm cdeclCall: [:callInfo |
		asm 
			mov: addr asUImm32 to: EAX;
			call: EAX. 
	] alignment: NativeBoost forCurrentPlatform stackAlignment ! !

!NBCallbackCodeGen methodsFor: 'callback entry code' stamp: 'IgorStasenko 5/8/2012 16:48'!
generateCallbackEnterCodeFor: callbackClass

	gen := (NBNativeFunctionGen new
		callType: callbackClass callType;
		fnSpec: callbackClass fnSpec;
		yourself).

	callbackClass numArgs: gen fnSpec arguments size.
	
	"optUseStackPointer should be turned off!!!!!!"
	gen parseOptions: #( + optProxyLabels - optUseStackPointer +optReserveCallgateSpace  "+optDebug" ).
			
	^ gen generate: [:g |  
			
		asm := gen asm.
		proxy := gen proxy.

		"
		Callback entry , jumped directly from trunk.
		ECX == callback index
		"
		cbIndex := gen reserveTemp.
		asm 
			mov: ECX to: cbIndex. 


		self 
			saveExecutionState;
			emitArgumentsCoercion;
			activateCallbackContext: callbackClass. 
		
		"increment callback counter value"
		self incrementCallbackCounter.					
	
		asm label: #safetyLoop.
		self enterSmalltalkExecutiveImplementation.
		" we never reach here"
		asm jmp: #safetyLoop.
"========================================================"

"Callback return entry point. We jump here from 
#generateCallbackLeaveCodeFor:leaveAddr:
 
The stack must contain:
  - saved EBP
  - EAX
  - EDX
"

		asm label: #returnToC;
			pop: EBP.

		self restoreExecutionState.
		self decrementCallbackCounter.
		
		asm
			pop: EAX;
			pop: EDX.

	].! !

!NBCallbackCodeGen methodsFor: 'callback leave code' stamp: 'CiprianTeodorov 12/11/2012 19:00'!
generateCallbackLeaveCodeFor: callbackClass leaveAddr: leaveAddress

	gen := (NBNativeFunctionGen new
		callType: callbackClass callType;
		fnSpec: callbackClass fnSpec;
		yourself).

	callbackClass numArgs: gen fnSpec arguments size.
	
	"optUseStackPointer should be turned off!!!!!!"
	gen parseOptions: #( + optProxyLabels - optUseStackPointer +optReserveCallgateSpace  "+optDebug" ).
			
	^ gen generate: [:g |
			
		asm := gen asm.
		proxy := gen proxy.

"see #primLeave:stackPtr:contextOop:returnValue:primitiveMethod: 
for arguments stack order
"
		"coerce the oop to return type"
		proxy stackValue: 1.

"******** currently only return types returned via EAX supported *********"
		gen fnSpec returnType coerceOopToOperand: gen ifFailedJumpTo: #failed.

	"keep return value(s) on stack"
		asm
			push: EDX; 
			push: EAX.

		proxy stackValue: 3. "saved EBP"
		proxy positive32BitValueOf: EAX.

		asm push: EAX.
		proxy ifFailedJumpTo: #failed.

		proxy swapActiveContext: [ proxy stackValue: 2 ] restoreMethod: [ proxy stackValue: 0 ].
	
		"swapactivecontext returns 0 on failure"
		asm 
			cmp: EAX with: 0;
			je: #failed. 
			
		asm 
			mov: leaveAddress asUImm to: EAX;
			jmp: EAX. "jump to callback leave-to-C code. see #generateCallbackEnterCodeFor:  " 
				
	asm label: #failed.
"asm int3."		
		proxy primitiveFail.
		
		asm 
			leave;
			leave;  " on failure, we do leave twice, because 
		#primLeave:stackPtr:contextOop:returnValue:primitiveMethod:
		creates own stack frame, and jumps to callback leave entry point
		but we want to return straight to VM" 
			ret.
	].

! !

!NBCallbackCodeGen methodsFor: 'misc' stamp: 'IgorStasenko 5/7/2012 22:31'!
generator: agen
	gen := agen.
	asm := gen asm.
	proxy := gen proxy.! !

!NBCallbackCodeGen methodsFor: 'callback entry code' stamp: 'IgorStasenko 5/7/2012 12:48'!
incrementCallbackCounter

	"increment callback counter value"
	asm mov: NativeBoost forCurrentPlatform callbackCounterAddress asUImm32 to: EAX.
	asm inc: EAX ptr32.
	! !

!NBCallbackCodeGen methodsFor: 'misc' stamp: 'IgorStasenko 9/10/2012 13:26'!
memCopy: src to: dst size: sz

	asm 
		mov: src to: asm ESI;
		mov: dst to: asm EDI;
		mov: sz to: asm ECX;
		rep;
		movsb! !

!NBCallbackCodeGen methodsFor: 'primitives' stamp: 'IgorStasenko 9/10/2012 12:23'!
primJumpBufSize
	<primitive: #primJumpBufSize module: #NativeBoostPlugin>
	
	self error: 'a primitive failed. (seems like you using outdated VM)'! !

!NBCallbackCodeGen methodsFor: 'global addresses' stamp: 'IgorStasenko 9/10/2012 12:49'!
reenterInterpreterAddress

	^ (NativeBoost loadSymbol: 'reenterInterpreter' fromModule: NativeBoost VMModule) value asUImm32 ! !

!NBCallbackCodeGen methodsFor: 'callback leave code' stamp: 'IgorStasenko 9/15/2012 19:54'!
restoreExecutionState

	"emit code to restore execution state"
	
	asm decorateWith: 'restoreExecutionState' during: [

	"restore registers & other , see corresponding #saveExecutionState"
	self memCopy: savedReenterInterpreter to: self reenterInterpreterAddress  size: self primJumpBufSize.

	asm 
		mov: savedEBX to: EBX;
		mov: savedESI to: ESI;
		mov: savedEDI to: EDI;

		mov: savedCStackPointer to: EAX;
		mov: EAX to: self CStackPointerAddress asUImm ptr;
		
		
		mov: savedCFramePointer to: EAX;
		mov: EAX to: self CFramePointerAddress asUImm ptr.
		
	]! !

!NBCallbackCodeGen methodsFor: 'callback entry code' stamp: 'IgorStasenko 9/15/2012 19:50'!
saveExecutionState

	"emit code to save execution state"
	
	asm decorateWith: 'saveExecutionState' during: [

	"save registers"
	savedEBX := gen reserveTemp.
	savedESI := gen reserveTemp.
	savedEDI := gen reserveTemp.
	savedCStackPointer := gen reserveTemp.
	savedCFramePointer := gen reserveTemp.
	savedReenterInterpreter := gen reserveTemp.
	
	asm 
		mov: EBX to: savedEBX;
		mov: ESI to: savedESI;
		mov: EDI to: savedEDI;

		mov: self CStackPointerAddress asUImm ptr to: EAX;
		mov: EAX to: savedCStackPointer;
		mov: self CFramePointerAddress asUImm ptr to: EAX;
		mov: EAX to: savedCFramePointer;
		
		sub: asm ESP with: self primJumpBufSize;
		mov: ESP to: savedReenterInterpreter.
	
		self memCopy: self reenterInterpreterAddress to: savedReenterInterpreter  size: self primJumpBufSize
	]! !

Object subclass: #NBExternalEnumeration
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

NBExternalEnumeration class
	instanceVariableNames: 'representationType'!

!NBExternalEnumeration commentStamp: 'CiprianTeodorov 12/12/2012 23:03' prior: 0!
NBExternalEnumerationType reifies the enum declarations in C and offers a nice interface (especially in terms of debug/inspect).
To use it just subclass the NBExternalEnumeration and add an #enumDecl method to the class side such as:

NBExternalEnumeration subclass: #NBTestEnumeration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Tests'

NBTestEnumeration class>>enumDecl
	^ {(#AAA -> 1).
	(#BBB -> 2).
	(#CCC -> 3).
	(#DDD -> 2400)} asDictionary 

DO NOT FORGET to call the #initialize method on your class. The rest is automatically done ;)

You can use your new enum in two ways:
	- add it to a client class poolDictionaries list (see  #NBExternalEnumTests for an example), 
		and then just write CCC in your code -- CCC here is an item of your enum
	- send the name of an item to your class --- NBTestEnumeration DDD

The NBExternalEnumeration implements  (instance and class) some more API methods like:
	#itemAt: retrieves the item having a specific value  --- NBTestEnumeration itemAt: 2
	#includes: checks the existence of a specific item in the enum --- NBTestEnumeration includes: #AAA!

NBExternalEnumeration class
	instanceVariableNames: 'representationType'!

!NBExternalEnumeration class methodsFor: 'converting' stamp: 'CiprianTeodorov 2/6/2013 21:34'!
asNBExternalType: aTypeName
	^ NBExternalEnumerationType objectClass: self representationType: self representationType! !

!NBExternalEnumeration class methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/10/2012 20:20'!
at: anItem
	^ self classPool at: anItem ifAbsent: [ nil ]! !

!NBExternalEnumeration class methodsFor: 'error handling' stamp: 'CiprianTeodorov 12/10/2012 20:01'!
doesNotUnderstand: aMessage
	| v |
	^ (v := self at: aMessage selector) ifNil: [ super doesNotUnderstand: aMessage ] ifNotNil: [ v ]! !

!NBExternalEnumeration class methodsFor: 'enum declaration' stamp: 'CiprianTeodorov 12/15/2012 15:19'!
enumDecl
	^#()! !

!NBExternalEnumeration class methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/13/2012 19:57'!
fromInteger: anIntegerValue
	| theItem |
	theItem := self itemAt: anIntegerValue.
	theItem ifNil: [ self error: 'Invalid value for ' , self name , ' enumeration' ].
	^ self at: theItem! !

!NBExternalEnumeration class methodsFor: 'testing' stamp: 'CiprianTeodorov 12/10/2012 19:47'!
includes: aSymbol
	^self classPool includesKey: aSymbol ! !

!NBExternalEnumeration class methodsFor: 'class initialization' stamp: 'CiprianTeodorov 2/6/2013 21:33'!
initialize
	| unsigned |
	unsigned := true.
	self
		classPool:
			(self initializeEnum associations
				collect: [ :assoc | 
					(unsigned and: [ assoc value < 0 ])
						ifTrue: [ unsigned := false ].
					assoc key -> (self basicNew value: assoc value) ]) asDictionary.
	representationType := unsigned
		ifTrue: [ NBUInt32 new ]
		ifFalse: [ NBInt32 new ]! !

!NBExternalEnumeration class methodsFor: 'class initialization' stamp: 'CiprianTeodorov 12/13/2012 08:20'!
initializeEnum
	| decl |
	decl := self enumDecl.
	decl isDictionary
		ifTrue: [ ^ decl ].
	decl := Dictionary newFromPairs: decl.
	^ decl! !

!NBExternalEnumeration class methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/10/2012 20:17'!
itemAt: aValue
	^ self itemAt: aValue ifAbsent: [ nil ]! !

!NBExternalEnumeration class methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/10/2012 20:17'!
itemAt: aValue ifAbsent: exceptionBlock
	self classPool
		associationsDo: [ :assoc | 
			aValue = assoc value value
				ifTrue: [ ^ assoc key ] ].
	^ exceptionBlock value! !

!NBExternalEnumeration class methodsFor: 'instance creation' stamp: 'CiprianTeodorov 12/10/2012 19:59'!
new
	^self shouldNotImplement ! !

!NBExternalEnumeration class methodsFor: 'accessing' stamp: 'CiprianTeodorov 2/6/2013 21:34'!
representationType
	^representationType! !

!NBExternalEnumeration methodsFor: 'comparing' stamp: 'CamilloBruni 2/23/2013 13:05'!
= anEnumInst

	^ self class == anEnumInst class and: [ self value = anEnumInst value ]! !

!NBExternalEnumeration methodsFor: 'accessing' stamp: 'CamilloBruni 2/23/2013 13:05'!
item

	^ self class itemAt: value! !

!NBExternalEnumeration methodsFor: 'printing' stamp: 'CamilloBruni 2/23/2013 13:06'!
printOn: stream
	super printOn: stream.

	stream nextPut: $(;
		 nextPutAll: self item printString;
		 nextPut: $)! !

!NBExternalEnumeration methodsFor: 'accessing' stamp: 'CamilloBruni 2/23/2013 13:06'!
value

	^value! !

!NBExternalEnumeration methodsFor: 'accessing' stamp: 'CamilloBruni 2/23/2013 13:06'!
value: anObject

	value := anObject ! !

Object variableByteSubclass: #NBExternalHandle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalHandle commentStamp: 'IgorStasenko 2/24/2012 17:37' prior: 0!
Usually, my instances representing an opaque object handle returned by external function. There's little what we can do with it, except from passing as argument to another function(s).

I hold a byte array of a pointer size (typicaly 4 or 8 bytes). You can set the raw handle value with #value: and read it with #value.


Note, do not subclass from me directly. If you want to represent some opaque C  data structure (handle, stucture, pointer to structure etc),
subclass from NBExternalObject instead. Otherwise, if you insist, override #asNBExternalType: method on class side in own subclass to provide own marshalling 
for instances of your subclass(es) (but it makes even less sense since once you define own #asNBExternalType:, you free to use any base class for your subclasses,
unless of course you want to reuse some of my methods)!

NBExternalHandle variableByteSubclass: #NBExternalAddress
	uses: TNBMemoryAccessors @ {#byteAt:->#nbInt8AtOffset:. #byteAt:put:->#nbInt8AtOffset:put:. #longAt:->#nbInt32AtOffset:. #longAt:put:->#nbInt32AtOffset:put:. #ulongAt:->#nbUInt32AtOffset:. #ulongAt:put:->#nbUInt32AtOffset:put:}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalAddress commentStamp: 'IgorStasenko 2/24/2012 17:10' prior: 0!
My primary function is to represent a pointer (address) to memory, in cases, when a kind of data under given address does not having any special structure,
which can be reflected more nicely in language. 
Usually i can be used to hold pointer(s) to buffers (void*), or to allocated memory region etc.
I providing some basic interface for reading/writing data into memory where i pointing to, as well as some convenience methods.!

NBExternalAddress class
	uses: TNBMemoryAccessors classTrait
	instanceVariableNames: ''!

!NBExternalAddress class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/4/2010 01:15'!
asNBExternalType: gen

	^ NBExternalAddressType new ! !

!NBExternalAddress class methodsFor: 'finalization' stamp: 'CamilloBruni 8/3/2012 15:32'!
finalizeResourceData: anExternalAddressValue
	"We use an intermediate interger for address value, 
	otherwise we would hold on to the NBExternalAddress forever"
	(self value: anExternalAddressValue) free! !

!NBExternalAddress class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/17/2010 14:53'!
fromString: aString
	
	| result |
	
	result := NativeBoost allocate: aString size + 1.
	(self assert: result notNil).
	result writeString: aString.
	^ result! !

!NBExternalAddress class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/18/2010 00:33'!
null
	^ self new! !

!NBExternalAddress methodsFor: 'comparing' stamp: 'IgorStasenko 8/4/2011 08:25'!
= anObject
	^ anObject class == self class and: [ anObject value = self value]! !

!NBExternalAddress methodsFor: 'finalization' stamp: 'CamilloBruni 8/3/2012 15:27'!
finalize
	self free! !

!NBExternalAddress methodsFor: 'finalization' stamp: 'CamilloBruni 8/3/2012 15:27'!
free

	NativeBoost free: self! !

!NBExternalAddress methodsFor: 'finalization' stamp: 'CamilloBruni 8/3/2012 15:30'!
freeAfterUse
	"add ourselves to finalization registry"
	NBExternalResourceManager 
		addResource: self 
		data: self value.
! !

!NBExternalAddress methodsFor: 'testing' stamp: 'IgorStasenko 8/4/2011 07:06'!
notNull
	^ self value ~= 0! !

!NBExternalAddress methodsFor: 'string access' stamp: 'IgorStasenko 11/24/2012 17:04'!
readString
	"sometimes we're just a pointer to string"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout function: #(String (self)) emit: [:gen |
		gen asm pop: gen asm EAX ] ! !

!NBExternalAddress methodsFor: 'string access' stamp: 'Igor.Stasenko 5/24/2010 16:09'!
writeString: aString
	"write a null-terminated byte string to receiver's address"
	
	| str |
	str := aString copyWith: (Character value: 0).
	NativeBoost memCopy: str to: self size: str size.
! !

!NBExternalHandle class methodsFor: 'instance creation' stamp: 'IgorStasenko 2/24/2012 17:02'!
asNBExternalType: gen

	self error: 'use NBExternalObject instead'.
	
	"Note, do not subclass from me directly. If you want to represent any opaque C structure (stucture, pointer to structure etc),
	subclass from NBExternalObject instead. Otherwise, if you insist, override this method in own subclass to provide own marshalling 
	for instances of your object(s)"! !

!NBExternalHandle class methodsFor: 'fields description' stamp: 'IgorStasenko 5/26/2012 14:57'!
instanceSize 

	^ NBExternalType pointerSize ! !

!NBExternalHandle class methodsFor: 'instance creation' stamp: 'IgorStasenko 5/26/2012 14:55'!
new
	^ self basicNew: self instanceSize ! !

!NBExternalHandle class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/2/2010 14:08'!
value: aValue
	^ self new value: aValue! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 13:25'!
asUImm
	^ self asUnsignedLong asUImm! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 13:32'!
asUImm32
	^ self asUnsignedLong asUImm32! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 02:41'!
asUnsignedLong
	"slow version"
	^ (self at: 1)
	+ ((self at: 2) << 8)
	+ ((self at: 3) <<16)
	+ ((self at: 4) << 24)! !

!NBExternalHandle methodsFor: 'testing' stamp: 'IgorStasenko 6/2/2012 14:38'!
isNull
	^ self value = 0! !

!NBExternalHandle methodsFor: 'printing' stamp: 'Igor.Stasenko 4/29/2010 12:28'!
printOn: aStream

	aStream nextPutAll: '@ 16r';
		nextPutAll: (self value printStringBase: 16)

! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'IgorStasenko 11/24/2012 16:20'!
value
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCallout function: #(size_t () ) emit: [:gen :proxy :asm | 
		proxy receiver.
		proxy varBytesFirstFieldOf: asm EAX.
		
		self class instanceSize = 4 ifTrue: [
			asm mov: asm EAX ptr to: asm EAX.

		] ifFalse: [	
			"not implemented yet, sorry"
			self notYetImplemented.
		].
	] 
! !

!NBExternalHandle methodsFor: 'accessing' stamp: 'IgorStasenko 11/24/2012 16:20'!
value: aPositiveInteger
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>
	
	^ self nbCallout function: #(oop (size_t aPositiveInteger)) emit: [:gen :proxy :asm |
		
		self class instanceSize = 4 ifTrue: [ | temp |

			proxy receiver.
			proxy varBytesFirstFieldOf: asm EAX.
			
			asm  
				mov: asm ESP ptr to: asm EDX;
				mov: asm EDX to: asm EAX ptr.
					
		] ifFalse: [	
			"not implemented yet, sorry"
			self notYetImplemented.
		].
	
		proxy receiver 
	]
! !

Object subclass: #NBExternalHeapManager
	instanceVariableNames: 'pages freeBlocks reservedBlocks sema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Heap'!

!NBExternalHeapManager commentStamp: 'Igor.Stasenko 9/25/2010 10:04' prior: 0!
This is a simplistic implementation of external heap manager.

Using it , you can allocate or free external memory.

- should not throw any exceptions.

If allocation fails, should simply answer nil/0 !

!NBExternalHeapManager methodsFor: 'callbacks' stamp: 'Igor.Stasenko 9/25/2010 00:48'!
addFreeBlock: aMemoryBlock

	"Check if free block covers entire page.
	and if it is, then free the page"
	
	(self checkForFreePage: aMemoryBlock) ifFalse: [
		freeBlocks add: aMemoryBlock
		]
! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:18'!
alignToPageSize: requestedSize

	" pages is 4kb wide"
	| u align |
	align := self pageAlignment.
	
	^ (u := requestedSize \\ align) > 0 
		ifTrue: [ requestedSize + align - u ] 
		ifFalse: [ requestedSize ]! !

!NBExternalHeapManager methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/25/2010 00:45'!
allocate: numBytes
	"Allocate a numBytes on heap, answer an address to first byte of allocated memory"
	
	
	^ sema critical: [ 	| freeBlock page |

		"yes, the free space search is implemented naively, by now"
		freeBlock := freeBlocks 
			detect: [:block | block length >= numBytes]
			ifNone: [ page := self allocatePage: numBytes.  page firstBlock ].

		freeBlock reserve: numBytes for: self.
		reservedBlocks at: freeBlock address put: freeBlock.
		freeBlock address
	]
! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:11'!
allocatePage: requestedSize

	| bytesToAllocate addr page |
	
	bytesToAllocate := self alignToPageSize: (self minimumPageSize max: requestedSize).

	addr := self primAllocatePage: bytesToAllocate.
	
	page := NBMemoryPage address: addr length: bytesToAllocate.
	pages at: addr put: page.
	^ page
 ! !

!NBExternalHeapManager methodsFor: 'callbacks' stamp: 'Igor.Stasenko 9/25/2010 00:47'!
checkForFreePage: aMemoryBlock

	"Check if free block covers entire page.
	and if it is, then free the page"
	
	pages at: aMemoryBlock address ifPresent: [:page |
		page length = aMemoryBlock length ifTrue: [ self freePage: page. ^ true]
		].
	
	^ false! !

!NBExternalHeapManager methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/24/2010 23:44'!
free: address


	sema critical: [	| block |
		block := reservedBlocks removeKey: address ifAbsent: [
			self error: 'Unable to find a memory block with given address' ].
	
		block makeFreeFor: self ]
	! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:50'!
freePage: aMemoryPage
	pages removeKey: aMemoryPage address.
	freeBlocks remove: aMemoryPage firstBlock ifAbsent: [].
	
	^ self primFreePage: aMemoryPage
 ! !

!NBExternalHeapManager methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 23:57'!
initialize
	sema := Semaphore forMutualExclusion.
	pages := Dictionary new.
	freeBlocks := IdentitySet new.
	reservedBlocks := Dictionary new.! !

!NBExternalHeapManager methodsFor: 'testing' stamp: 'Igor.Stasenko 9/24/2010 23:51'!
isValidAddress: anAddress

	^ self isValidAddress: anAddress size: 1! !

!NBExternalHeapManager methodsFor: 'testing' stamp: 'Igor.Stasenko 9/25/2010 00:20'!
isValidAddress: anAddress size: numBytes
	"check, if given memory range (at given address and numBytes size)
	 is valid (currently allocated) using this heap manager "
	^ sema critical: [
		reservedBlocks anySatisfy: [:blk |
			blk address <= anAddress and: [blk address + blk length >= (anAddress + numBytes)]]
	]! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:35'!
minimumPageSize
	" lets grab minimum 32kb pages"
	
	^ 32768! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:36'!
numAllocatedBlocks
	^ reservedBlocks size! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:22'!
numBlocks
	^ freeBlocks size + reservedBlocks size! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:36'!
numFreeBlocks
	^ freeBlocks size! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:22'!
numPages
	^ pages size! !

!NBExternalHeapManager methodsFor: 'memory pages' stamp: 'Igor.Stasenko 9/25/2010 00:06'!
pageAlignment
	" x86 4kb pages"
	
	^ 4096! !

!NBExternalHeapManager methodsFor: 'abstract' stamp: 'Igor.Stasenko 9/25/2010 00:19'!
primAllocatePage: numBytes
	self subclassResponsibility ! !

!NBExternalHeapManager methodsFor: 'abstract' stamp: 'Igor.Stasenko 9/25/2010 00:19'!
primFreePage: aMemoryPage

	self subclassResponsibility
 ! !

!NBExternalHeapManager methodsFor: 'callbacks' stamp: 'Igor.Stasenko 9/24/2010 23:43'!
removeFreeBlock: aMemoryBlock

	freeBlocks remove: aMemoryBlock ifAbsent: []! !

!NBExternalHeapManager methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 23:31'!
totalAllocatedMemory
	| total |
	
	total := 0.
	sema critical: [
		reservedBlocks valuesDo: [:blk | total := total + blk length ]].
	^ total! !

Object subclass: #NBExternalLibraryWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBExternalLibraryWrapper class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:23'!
createArrayedMethodFor: aSpec


	^ String streamContents: [:str |
		str 
			nextPutAll: aSpec asMethodSelectorAndArrayOfArguments ;
			crtab;
			nextPutAll: '<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>';
			cr;
			crtab;
			nextPutAll: 'argsArray size = ', aSpec arguments size printString, ' ifFalse:[^Error signal: ''Incorrect number of arguments''].';
			crtab;
			nextPutAll: '^ self call: ';
			nextPutAll: aSpec asArraySpecArrayedArgs ;
			cr
	].


		
! !

!NBExternalLibraryWrapper class methodsFor: 'as yet unclassified' stamp: 'cipt 10/21/2012 20:14'!
createMethodFor: aCFunctionDefinition
	"find the function name"

	| typeAndName spec source cat |
	"the parameter list follows the fn name "
	spec := NBFnSpec namedFunctionFrom: aCFunctionDefinition.
	spec arguments size > 15
		ifTrue: [ 
			source := self createArrayedMethodFor: spec.
			cat := 'automatically generated arrayed' ]
		ifFalse: [ 
			source := self createSimpleMethodFor: spec.
			cat := 'automatically generated' ].
	self compile: source classified: cat! !

!NBExternalLibraryWrapper class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 16:23'!
createSimpleMethodFor: aSpec
	^ String
		streamContents: [ :str | 
			str
				nextPutAll: aSpec asMethodSelectorAndArguments;
				crtab;
				nextPutAll: '<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode>';
				cr;
				crtab;
				nextPutAll: '^ self call: ';
				nextPutAll: aSpec asArraySpec;
				cr ]! !

!NBExternalLibraryWrapper methodsFor: 'utils' stamp: 'IgorStasenko 11/24/2012 16:22'!
call: fnSpec
	" you can override this method if you need to"

	^ (self nbCalloutIn: thisContext sender)
		cdecl;	
		function: fnSpec module: self libraryNameOrHandle
! !

!NBExternalLibraryWrapper methodsFor: 'utils' stamp: 'IgorStasenko 8/20/2011 13:27'!
libraryNameOrHandle

	"provide a handle to the receiver's library"
	self subclassResponsibility 	! !

Object subclass: #NBExternalObject
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalObject commentStamp: 'IgorStasenko 2/24/2012 17:40' prior: 0!
I representing an external object of one kind, provided by some external library/function.

My instance holds a handle, which is used to identify the external object when i am passed as an argument, or when i'm used as a return type in function signature.
A typical usage of me is to create a subclass, and then use that subclass name directly in function signatures:

NBExternalObject subclass: #MyExternalObject

newObj := MyExternalObject newObject.

MyExternalObject class>>newObject
  <primitive: #primitiveNativeCall ...>
 ^ self nbCall: #(MyExternalObject someExternalFunction() )

here, assume that someExternalFunction() returns some handle (or pointer) to some opaque external structure. By putting NBExternalObject subclass (MyExternalObject) as a return type
into the function signature, we are telling the code generator to automatically convert the return value into an instance of a given class and initialize its handle to the value returned by the function.

When used as argument type, the value, which is used to pass to the external function is value held in my handle instance variable:

MyExternalObject>>compareWith: anotherExternalObject
  <primitive: #primitiveNativeCall ...>
   ^ self nbCall: #( void compare ( self , MyExternalObject anotherExternalObject))

The main advantage of using NBExternalObject subclass as a type name for arguments is that it provides type safety by checking the incoming argument, that it
is an instance of your class, and nothing else. If not, the primitive will fail without calling the external function.
!

!NBExternalObject class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 4/29/2010 09:18'!
asNBExternalType: gen

	^ NBExternalObjectType objectClass: self! !

!NBExternalObject class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/17/2010 14:29'!
null
	^ self new! !

!NBExternalObject methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 05:03'!
handle
	^ handle value! !

!NBExternalObject methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 05:03'!
handle: aUint
	handle value: aUint! !

!NBExternalObject methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 4/29/2010 12:25'!
initialize
	handle := NBExternalHandle new! !

!NBExternalObject methodsFor: 'testing' stamp: 'Igor.Stasenko 5/17/2010 14:33'!
isNull
	^ handle value = 0! !

!NBExternalObject methodsFor: 'printing' stamp: 'Igor.Stasenko 4/29/2010 10:21'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: '( 0x';
		nextPutAll: (handle value printStringBase: 16);
		space;
		nextPut: $)! !

!NBExternalObject methodsFor: 'external resource management' stamp: 'IgorStasenko 6/11/2012 05:36'!
registerAsExternalResource
	"Note, subclasses should implement #resourceData
	and #finalizeResourceData: on class side"
	NBExternalResourceManager addResource: self.
	! !

NBExternalObject subclass: #NBNativeFunction
	instanceVariableNames: 'fnSpec annotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBNativeFunction class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/3/2012 16:18'!
cdecl: fnSpec emit: aFunctionBodyBlock
	^ (NBNativeFunctionGen cdecl: fnSpec emit: aFunctionBodyBlock) install.! !

!NBNativeFunction class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/3/2012 16:18'!
cdecl: fnSpec emit: aFunctionBodyBlock options: anOptionArray
	^ (NBNativeFunctionGen cdecl: fnSpec emit: aFunctionBodyBlock options: anOptionArray) install.! !

!NBNativeFunction class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/3/2012 15:53'!
code: code fnSpec: fnSpec
	
	^ self basicNew
		initializeWithCode: code fnSpec: fnSpec! !

!NBNativeFunction class methodsFor: 'finalization' stamp: 'CamilloBruni 8/3/2012 15:24'!
finalizeResourceData: anExternalAddress
	anExternalAddress free! !

!NBNativeFunction class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/3/2012 16:18'!
stdCall: fnSpec emit: aFunctionBodyBlock
	^ (NBNativeFunctionGen stdCall: fnSpec emit: aFunctionBodyBlock) install.! !

!NBNativeFunction class methodsFor: 'instance creation' stamp: 'CamilloBruni 8/3/2012 16:18'!
stdCall: fnSpec emit: aFunctionBodyBlock options: anOptionArray
	^ (NBNativeFunctionGen stdCall: fnSpec emit: aFunctionBodyBlock options: anOptionArray) install.! !

!NBNativeFunction methodsFor: 'accessing' stamp: 'IgorStasenko 8/23/2012 18:16'!
address
	^ handle! !

!NBNativeFunction methodsFor: 'accessing' stamp: 'CamilloBruni 10/3/2012 14:41'!
annotation
	^ annotation! !

!NBNativeFunction methodsFor: 'accessing' stamp: 'CamilloBruni 10/3/2012 14:41'!
annotation: anObject
	annotation := anObject! !

!NBNativeFunction methodsFor: 'code generation' stamp: 'CamilloBruni 10/4/2012 19:32'!
emitCall: asm
	" emit the asm code for calling myself "
	asm mov: (handle asUImm32 annotation: self annotation) to: asm EAX.
	asm call: asm EAX.! !

!NBNativeFunction methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/3/2012 15:53'!
initializeWithCode: code fnSpec: aFnSpec
	
	| bytes |
	super initialize.
	
	fnSpec := aFnSpec.
	bytes := code bytes.
	handle := NativeBoost allocate: bytes size.
	NativeBoost 
		memCopy: bytes 
		to: handle 
		size: bytes size.! !

!NBNativeFunction methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2012 15:22'!
resourceData
	^ handle! !

!NBNativeFunction methodsFor: 'accessing' stamp: 'IgorStasenko 8/23/2012 18:30'!
uninstall
	handle ifNotNil: [
		NativeBoost free: handle.
		handle := nil.
		]! !

!NBNativeFunction methodsFor: 'code generation' stamp: 'CamilloBruni 8/3/2012 16:17'!
valueWithArguments: anArray
	"call this native function with the given arguments"
	self shouldBeImplemented.! !

Object subclass: #NBExternalResourceExecutor
	instanceVariableNames: 'session data resourceClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalResourceExecutor commentStamp: '<historical>' prior: 0!
i am responsible for finalizing an external resource,
registered using external resource manager.

When object, registered as external resource being garbage collected,
i telling an object's class to finalize it's associated data (by passing an object,
received from #resourceData message sent to an object at registration time).

I automatically keep tracking for session change (image save/boot), and ignore finalization of resources of old sessions (since they are not longer valid,
and cannot be freed since session changed).

Like that, a users of NBExternalResourceManager don't need to implement a session checking logic, and need only to:

a) register object as external resource:
     NBExternalResourceManager addResource: anObject.

an object should understand the #resourceData message, which is remembered at registration point (it can be any external resource like, id, handle or memory pointer).

Then, when object is garbage collected, its class will receive a message to finalize the resource data in #finalizeResourceData:
The passed data is exactly same as previously returned by #resourceData method.

An example:

Imagine that you want to represent an external resource by keeping its handle.

Object subclass: #MyExternalObject
 	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XYZ'
	

To let your object(s) to be managed by external resource manager, you need to register it.
Usually you do it after successfully claiming an external resource:

MyExternalObject>>initialize

	handle := self createNewExternalResource.  "claim resource"
	self assert: self handleIsValid. "etc..."
	
	"Now, register receiver as external resource" 
	NBExternalResourceManager addResource: self 
"Another form of use is: 
	NBExternalResourceManager addResource: self data: handle.
"

----  
If you used #addResource: method for registration, you should provide an implementation of #resourceData method:

MyExternalObject>>resourceData
	^ handle "since we need only handle to identify external resource"

----	
Now, for properly finalizing the external resource we should implement:

MyExternalObject class>> finalizeResourceData: aHandle
	^ self destroyHandle: aHandle. "do whatever is needed to destroy the handle"

Note that in #finalizeResourceData: you cannot access any other properties of your instance, since it is already garbage collected. You also don't need to do a session checking, since it is done automatically by resource manager. 

!

!NBExternalResourceExecutor methodsFor: 'finalizing' stamp: 'IgorStasenko 5/28/2012 03:54'!
finalize 
	(NativeBoost sessionChanged: session) ifFalse: [
		resourceClass finalizeResourceData: data
	]! !

!NBExternalResourceExecutor methodsFor: 'initialize' stamp: 'IgorStasenko 3/23/2012 13:06'!
initialize 
	session := NativeBoost uniqueSessionObject ! !

!NBExternalResourceExecutor methodsFor: 'initialize-release' stamp: 'IgorStasenko 3/23/2012 13:04'!
resourceClass: aResourceClass data: aData

	resourceClass := aResourceClass.
	data := aData! !

Object subclass: #NBExternalResourceManager
	instanceVariableNames: 'registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

NBExternalResourceManager class
	instanceVariableNames: 'soleInstance'!

!NBExternalResourceManager commentStamp: '<historical>' prior: 0!
i am responsible for managing a finalization of external resources.

When object, registered as external resource being garbage collected,
i telling an object's class to finalize it's associated data (by passing an object,
received from #resourceData message sent to an object at registration time).

I automatically keep tracking for session change (image save/boot), and ignore finalization of resources of old sessions (since they are not longer valid,
and cannot be freed since session changed).

Like that, a users of NBExternalResourceManager don't need to implement a session checking logic, and need only to:

a) register object as external resource:
     NBExternalResourceManager addResource: anObject.

b) an object should understand the #resourceData message, which is remembered at registration point (it can be any external resource like, id, handle or memory pointer).

Then, when object is garbage collected, its class will receive a message to finalize the resource data in #finalizeResourceData:
The passed data is exactly same as previously returned by #resourceData method.

An example:

Imagine that you want to represent an external resource by keeping its handle.

Object subclass: #MyExternalObject
 	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XYZ'
	

To let your object(s) to be managed by external resource manager, you need to register it.
Usually you do it after successfully claiming an external resource:

MyExternalObject>>initialize

	handle := self createNewExternalResource.  "claim resource"
	self assert: self handleIsValid. "etc..."
	
	"Now, register receiver as external resource" 
	NBExternalResourceManager addResource: self 
"Another form of use is: 
	NBExternalResourceManager addResource: self data: handle.
"

----  
If you used #addResource: method for registration, you should provide an implementation of #resourceData method:

MyExternalObject>>resourceData
	^ handle "since we need only handle to identify external resource"

----	
Now, for properly finalizing the external resource we should implement:

MyExternalObject class>> finalizeResourceData: aHandle
	^ self destroyHandle: aHandle. "do whatever is needed to destroy the handle"

Note that in #finalizeResourceData: you cannot access any other properties of your instance, since it is already garbage collected. You also don't need to do a session checking, since it is done automatically by resource manager. 

!

NBExternalResourceManager class
	instanceVariableNames: 'soleInstance'!

!NBExternalResourceManager class methodsFor: 'resource management' stamp: 'IgorStasenko 3/23/2012 13:13'!
addResource: anObject 
	self soleInstance addResource: anObject ! !

!NBExternalResourceManager class methodsFor: 'resource management' stamp: 'IgorStasenko 3/28/2012 18:42'!
addResource: anObject data: aData
	self soleInstance addResource: anObject data: aData! !

!NBExternalResourceManager class methodsFor: 'instance creation' stamp: 'IgorStasenko 6/2/2012 14:37'!
reset
	soleInstance := self new.! !

!NBExternalResourceManager class methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2012 13:08'!
soleInstance 
	^ soleInstance ifNil: [ soleInstance  := self new ]! !

!NBExternalResourceManager methodsFor: 'external resource management' stamp: 'IgorStasenko 3/27/2012 19:11'!
addResource: anObject 

	^ self addResource: anObject data: anObject resourceData
! !

!NBExternalResourceManager methodsFor: 'external resource management' stamp: 'IgorStasenko 3/27/2012 19:11'!
addResource: anObject data: resourceData

	registry add: anObject executor: 
		(NBExternalResourceExecutor new resourceClass: anObject class data: resourceData)! !

!NBExternalResourceManager methodsFor: 'initialize-release' stamp: 'IgorStasenko 6/2/2012 14:43'!
initialize 
	registry := NBFinalizationRegistry new! !

Object variableByteSubclass: #NBExternalStructure
	instanceVariableNames: ''
	classVariableNames: 'Printing'
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

NBExternalStructure class
	instanceVariableNames: 'initialized currentFields'!

!NBExternalStructure commentStamp: 'JavierPimas 2/3/2012 22:35' prior: 0!
I am used for transparent structures: that is, a structure is transparent if you know its fields and can modify them. This is in contrast of opaque structures, which you never manipulate directly but through functions.

For each struct type, you define a subclass of me, and implement the fieldsDesc class method. After that you do a initializeAccessors for that class and voila, field accessors are generated automatically.


Class Instance Variables:
	initialized	<Boolean>
	currentFields	<NBExternalStructureFields>!

NBExternalStructure class
	instanceVariableNames: 'initialized currentFields'!

!NBExternalStructure class methodsFor: 'testing' stamp: 'Igor.Stasenko 4/29/2010 04:13'!
allocateOnCHeap
	^ false! !

!NBExternalStructure class methodsFor: 'testing' stamp: 'Igor.Stasenko 4/29/2010 04:14'!
allocateOnObjectMemory
	^ self allocateOnCHeap not! !

!NBExternalStructure class methodsFor: 'ffi type' stamp: 'Igor.Stasenko 5/17/2010 18:44'!
asNBExternalType: gen
	^ NBExternalStructureType objectClass: self! !

!NBExternalStructure class methodsFor: 'alignment' stamp: 'IgorStasenko 5/26/2012 17:45'!
byteAlignment
	
	"default "
	^ NativeBoost forCurrentPlatform pointerSize
! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 5/22/2010 12:04'!
createAccessorsFor: fieldName 
	"Define read/write accessors for the given field"
	| code |

	code := fieldName,'
	"This method was automatically generated"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self fieldAt: ' , fieldName printString.
	self compile: code classified: '*auto-accessing'.
	
	code := fieldName,': anObject
	"This method was automatically generated"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self fieldAt: ' , fieldName printString , ' put: anObject'.
	self compile: code classified: '*auto-accessing'.
! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 08:45'!
fields

	^ currentFields ifNil: [
		self rebuildFieldAccessors.
		currentFields
	].! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'CiprianTeodorov 1/19/2013 17:14'!
fieldsClass
	^NBExternalStructureFields ! !

!NBExternalStructure class methodsFor: 'fields description' stamp: 'Igor.Stasenko 5/19/2010 09:01'!
fieldsDesc
	"override this method in a subclass to get an automatically generated
	field accessors.
	
	The field description format is following:
	
	#( 
 		type1 name1;
		type2 name2;
		....
	)
	"
	^ #()! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 4/29/2010 04:44'!
flushNativeFieldAccessors

	methodDict do: [:method |
		NBNativeCodeGen removeNativeCodeFrom: method ]! !

!NBExternalStructure class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/4/2011 05:53'!
fromPointer: externalAddress
	| inst |
	
	inst:= self new.
	NativeBoost memCopy: externalAddress to: inst size: self instanceSize.
	^ inst! !

!NBExternalStructure class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/5/2011 12:02'!
initializeAccessors
	initialized := true.
	self rebuildFieldAccessors.! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 08:56'!
instanceSize 
	
	^ self fields totalSize

	
! !

!NBExternalStructure class methodsFor: 'testing' stamp: 'IgorStasenko 8/5/2011 12:00'!
isInitialized
	^ initialized == true! !

!NBExternalStructure class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/19/2010 08:56'!
new

	^ (self basicNew: self fields totalSize) initialize! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'IgorStasenko 8/3/2011 19:15'!
noteCompilationOf: aSelector meta: isMeta
	initialized == true ifFalse: [ ^ self ].

	isMeta ifTrue: [ 
		"Compilation on a class side , lets get rid of native methods on instance side"
		(aSelector == #fieldsDesc or: [ aSelector == #byteAlignment ]) ifTrue: [ 
			self flushNativeFieldAccessors.
			self rebuildFieldAccessors ].
	].
! !

!NBExternalStructure class methodsFor: 'accessing' stamp: 'IgorStasenko 2/2/2012 18:53'!
offsetOf: aFieldName
	^ self fields offsetOf: aFieldName! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'CiprianTeodorov 1/19/2013 17:14'!
rebuildFieldAccessors

	currentFields ifNotNil: [
		currentFields fieldNamesDo: [:field |
			self removeAccessor: field.
			self removeAccessor: field asMutator ]].

	currentFields := self fieldsClass new 
		parseFields: self fieldsDesc byteAlignment: self byteAlignment structure: self.
	self fields fieldNamesDo: [:fldName | self createAccessorsFor: fldName ].

	^ currentFields! !

!NBExternalStructure class methodsFor: 'managing accessors' stamp: 'Igor.Stasenko 5/2/2010 13:30'!
removeAccessor: aSelector
	methodDict at: aSelector ifAbsent: [ ^ self ].
	self removeSelector: aSelector.
	

	! !

!NBExternalStructure methodsFor: 'dnu' stamp: 'IgorStasenko 8/5/2011 12:01'!
doesNotUnderstand: aMessage

	self class isInitialized ifFalse: [
		"retry send after initialization"
		self class initializeAccessors.
		^ aMessage sentTo: self
	].

	^ super doesNotUnderstand: aMessage! !

!NBExternalStructure methodsFor: 'private' stamp: 'Igor.Stasenko 5/19/2010 09:08'!
emitRead: aFieldName generator: gen
	| offset type asm mem |
			
	gen requestor: self class.
	type := self class fields typeOf: aFieldName.
	offset := self class fields offsetOf: aFieldName.

	asm := gen asm.
			
	gen proxy stackValue: 0.  "receiver oop"
	gen proxy firstIndexableField: asm EAX.

	"load the value"
	mem := asm EAX ptr + offset.
	
	"read a value from given location and return oop"
	type readOop: mem generator: gen.

	gen epilogue.
	gen emitFailureHandler.
	
	^ gen! !

!NBExternalStructure methodsFor: 'private' stamp: 'IgorStasenko 5/26/2012 17:30'!
emitWrite: aFieldName generator: gen
	| offset type asm size rcvr fieldAddr |
			
	gen requestor: self class.
	type := self class fields typeOf: aFieldName.
	offset := self class fields offsetOf: aFieldName.
	rcvr := gen reserveTemp.
	fieldAddr := gen reserveTemp.

	asm := gen asm.
	type loader: (NBSTMethodArgument new stackIndex: 0).
	type emitPush: gen. "push value on stack"
		
	gen proxy stackValue: 1.  "receiver oop"
	asm mov: asm EAX to: rcvr.
	gen proxy firstIndexableField: asm EAX.
	offset > 0 ifTrue: [
	 	asm add: asm EAX with: offset ].
	
	asm mov: asm EAX to: fieldAddr.

	gen emitFailureTest. "important to check if everything ok, before we write value to receiver"
	
	size := type typeSize.
	
	"just copy the value from stack to the struct field"
	
	asm 
		mov: fieldAddr to: asm EAX.	
	offset := 0.
	[ size >= 4 ] whileTrue: [
		asm 
			mov: asm ESP ptr + offset to: asm ECX;
			mov: asm ECX to: asm EAX ptr + offset.
		size := size - 4.
		offset := offset + 4.
	].

	size >= 2  ifTrue: [
		asm 
			mov: asm ESP ptr16 + offset to: asm CX;
			mov: asm CX to: asm EAX ptr16 + offset.
		size := size - 2.
		offset := offset + 2.
	].

	size > 0  ifTrue: [
		" last byte "
		asm 
			mov: asm ESP ptr8 + offset to: asm CL;
			mov: asm CL to: asm EAX ptr8 + offset.
	].

	"answer the receiver"
	asm mov: rcvr to: asm EAX.
	gen epilogue.
	gen emitFailureHandler.
	
	^ gen
	! !

!NBExternalStructure methodsFor: 'private' stamp: 'IgorStasenko 5/22/2012 18:06'!
fieldAt: aFieldName
	
	^ NBFFICallout handleFailureIn: thisContext sender
		nativeCode: [:gen | self emitRead: aFieldName generator: gen. gen bytes ]
! !

!NBExternalStructure methodsFor: 'private' stamp: 'Igor.Stasenko 4/28/2010 19:11'!
fieldAt: aFieldName put: value

	^ NBFFICallout handleFailureIn: thisContext sender
		nativeCode: [:gen | self emitWrite: aFieldName generator: gen. gen bytes ]
! !

!NBExternalStructure methodsFor: 'printing' stamp: 'IgorStasenko 5/27/2012 03:15'!
printOn: aStream 
	"Append to the argument, aStream, the names and values of all the record's variables."

	Printing == true ifTrue: [ 
		"since we use field accessors for printing values,
		debugging the code with not-yet nativised accessors leads to infinite loop"
		^ aStream nextPutAll: self class name; nextPutAll: '(...)'.	
		].
	
	Printing := true.
	[ 
		aStream nextPutAll: self class name; nextPutAll: ' ( '; cr.
		self class fields namesInDeclarationOrder do: [ :field |
			aStream nextPutAll: field; nextPut: $:; space; tab.
				(self perform: field ) printOn: aStream.
				] separatedBy: [ aStream cr ].
		aStream cr; nextPut: $). ]
	ensure: [	Printing := false ].
	! !

NBExternalStructure variableByteSubclass: #NBExternalTypeValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

NBExternalTypeValue class
	instanceVariableNames: 'valueType'!

!NBExternalTypeValue commentStamp: '<historical>' prior: 0!
I am a generic meta class for creating a subclasses, which instances will hold a single value of specified C type.
To create a new class for some concrete C type use:

myClass := NBExternalTypeValue getClassForType: 'float'.

Then you can use instances of given anonymous class(es) as a value holders for
type you specified:

float := myClass new.
...

float value:  1.5
float value

etc..

By combining this with class/pool variables we have a convenient way of defining a values, which are passed by pointer to a function.

For instance, imagine that we need to create a binding to a function:

void getFoo( SomeType * value) 

which is not an unusual situation, when C function using pointer arguments for storing it's output there.

And this is what NBExternalTypeValue is done for:
To define a binding to this function you can:
  - declare a pool/class variable, named SomeType
  - initialize it: 
        SomeType := NBExternalTypeValue ofType: 'SomeType'

and then use it in function signature:

getFoo: value
   <primitive .. >
  ^ self nbcall: #(void getFoo ( SomeType *  value ))

---
and call it like: 

var := SomeType new.
self getFoo: var.

var value -> will read the value 
!

NBExternalTypeValue class
	instanceVariableNames: 'valueType'!

!NBExternalTypeValue class methodsFor: 'fields description' stamp: 'IgorStasenko 7/25/2012 02:28'!
fieldsDesc 
 	valueType ifNil: [ ^ #() ].
	
	^ { valueType. #value }! !

!NBExternalTypeValue class methodsFor: 'class factory' stamp: 'CiprianTeodorov 12/16/2012 15:47'!
getClassForType: aTypeName
	"Do not confuse.!! This method answers an anonymous class,  a subclass of NBExternalTypeValue,
	which can be used for instantiation later i.e:
	
	floatTypeClass := NBExternalTypeValue ofType: 'float'.
	
	float  := floatTypeClass new.
	float value: 1.5.
	float value.
	
	"

	| newSubclass |
	newSubclass := ClassBuilder new
		newSubclassOf: NBExternalTypeValue
		type: NBExternalTypeValue typeOfClass
		instanceVariables: ''
		from: nil.	"we're not using 'self' to avoid wrong subclassing from anonymous subclass "
	newSubclass valueType: aTypeName.
	^ newSubclass! !

!NBExternalTypeValue class methodsFor: 'class factory' stamp: 'IgorStasenko 7/25/2012 02:49'!
ofType: aTypeName
	^ self getClassForType: aTypeName
! !

!NBExternalTypeValue class methodsFor: 'accessing' stamp: 'IgorStasenko 7/25/2012 02:58'!
valueType
	^ valueType! !

!NBExternalTypeValue class methodsFor: 'private' stamp: 'IgorStasenko 7/25/2012 03:33'!
valueType: aTypeName
	valueType := aTypeName.
	self rebuildFieldAccessors! !

!NBExternalTypeValue methodsFor: 'printing' stamp: 'IgorStasenko 7/25/2012 02:59'!
printOn: aStream 
	"Append to the argument, aStream, the names and values of all the record's variables."

	Printing == true ifTrue: [ 
		"since we use field accessors for printing values,
		debugging the code with not-yet nativised accessors leads to infinite loop"
		^ aStream nextPutAll: self class name; nextPutAll: '(...)'.	
		].
	
	Printing := true.
	[ 
		aStream 
			nextPutAll: self class name; 
			nextPutAll: ' ( '; 
			nextPutAll: self class valueType;
			nextPutAll: ') (';
		 cr.
		self value printOn: aStream.
		aStream cr; nextPut: $). ]
	ensure: [ Printing := false ].
	! !

NBExternalStructure variableByteSubclass: #NBExternalUnion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalUnion class methodsFor: 'accessing' stamp: 'CiprianTeodorov 1/19/2013 17:15'!
fieldsClass
	^ NBExternalUnionFields! !

Object subclass: #NBExternalStructureFields
	instanceVariableNames: 'fields totalSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalStructureFields methodsFor: 'parsing spec' stamp: 'CiprianTeodorov 1/19/2013 17:18'!
addField: aName type: aType
	fields
		at: aName
		put:
			{aType.
			(totalSize - aType typeSize)}! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:15'!
fieldNames

	^ fields keys! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:16'!
fieldNamesDo: aBlock

	^ fields keysDo: [:name | aBlock value: name ]! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 09:20'!
namesInDeclarationOrder

	| result |
	
	result := SortedCollection sortBlock: [:a :b | a value second < b value second ].

	fields associationsDo: [:each  | result add: each ].
		
	^ result collect: [:each | each key ]! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:16'!
offsetOf: fieldName

	^ (fields at: fieldName) at: 2! !

!NBExternalStructureFields methodsFor: 'parsing spec' stamp: 'CiprianTeodorov 1/19/2013 17:19'!
parseFields: fieldSpec byteAlignment: byteAlign structure: structClass

	| stream type name gen align |
	stream := fieldSpec readStream.
	gen := NBFFICallout new requestor: structClass.
	
	fields := Dictionary new.
	totalSize := 0.
	[ stream atEnd ] whileFalse: [ | arity |
		type := gen resolveType: stream next. 
		arity := 0.
		[stream peek = #* ] whileTrue: [
			arity := arity + 1.
			stream next
		].
		type pointerArity: arity.
		
		name := stream next.
		name isSymbol ifFalse: [ self error: 'invalid field name'].
		fields at: name ifPresent: [ self error: 'duplicate field name' ].

		align := type typeSize min: byteAlign. "if byte align == 1, struct is packed"
		"add padding between fields, if needed"
		self sizeAlignedTo: align with: type. 

		self addField: name type: type. 
	
		stream peek == #';' ifTrue: [ stream next ].
	].
! !

!NBExternalStructureFields methodsFor: 'parsing spec' stamp: 'CiprianTeodorov 1/19/2013 17:18'!
sizeAlignedTo: anAlign with: aType
	totalSize := (totalSize alignedTo: anAlign) + aType typeSize! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 06:41'!
totalSize
	^ totalSize! !

!NBExternalStructureFields methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/19/2010 07:16'!
typeOf: fieldName

	^ (fields at: fieldName) at: 1! !

NBExternalStructureFields subclass: #NBExternalUnionFields
	instanceVariableNames: 'nbFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBExternalUnionFields methodsFor: 'parsing spec' stamp: 'CiprianTeodorov 1/19/2013 17:05'!
addField: aName type: aType
	fields
		at: aName
		put:
			{aType.
			(nbFields := nbFields + 1)}! !

!NBExternalUnionFields methodsFor: 'initialize-release' stamp: 'CiprianTeodorov 1/19/2013 17:05'!
initialize
	super initialize.
	
	nbFields := 0.! !

!NBExternalUnionFields methodsFor: 'accessing' stamp: 'CiprianTeodorov 1/19/2013 16:55'!
offsetOf: fieldName
	^ 0! !

!NBExternalUnionFields methodsFor: 'parsing spec' stamp: 'CiprianTeodorov 1/19/2013 16:59'!
sizeAlignedTo: anAlign with: aType

	totalSize := (totalSize alignedTo: anAlign ) max: (aType typeSize alignedTo: anAlign)! !

!NBExternalUnionFields methodsFor: 'accessing' stamp: 'CiprianTeodorov 1/19/2013 16:55'!
typeOf: fieldName
	^ (fields at: fieldName) at: 1! !

Object subclass: #NBExternalType
	instanceVariableNames: 'pointerArity loader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalType commentStamp: 'IgorStasenko 2/15/2012 19:41' prior: 0!
I am an abstract class that primarily serves for generating a machine code which converting arguments and return types
between Smalltalk and C worlds. 

My subclasses implementing a marshalling for concrete type, which is then used by FFI. 

Instance Variables:
	pointerArity	<Integer>
	
	loader	<NBVariableLoader>: an instance of argument loader, which emits code to load the smalltalk argument into register.	
		When generating the marshalling code to push a variable, my instances need this helper which, depending on where the object is (inst var, method arg, etc) gets the object in question into a register.!

NBExternalType subclass: #NBBool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBBool methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 16:10'!
coerceReturnValue: gen
	"convert C Bool to true or false"
	| proxy asm lfalse done |
	proxy := gen proxy.
	asm := gen asm.
	lfalse := asm uniqueLabelName: 'false'.
	done := asm uniqueLabelName: 'done'.
	asm 
		or: asm EAX with: asm EAX;
		je: lfalse.
	proxy trueObject.
	asm jmp: done.
	asm label: lfalse.
	proxy falseObject.
	asm label: done.! !

!NBBool methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen

	gen asm push: (gen proxy booleanValueOf: (loader emitLoad: gen)).
! !

!NBBool methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 17:05'!
valueSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	^ 1! !

NBExternalType subclass: #NBBootstrapUlong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBBootstrapUlong commentStamp: 'Igor.Stasenko 5/14/2010 18:01' prior: 0!
A special hacky type, 
which storing a ulong function return value into existing byte array instance.
A method, which using this type in callout should have an argument , named 'returnValueBuffer'
and pass a byte array instance, big enough to store ulong there.

This is essentially used during NativeBoost bootstrap, to generate & install the
gall gate function, without calling any of interpreterProxy function which may cause GC.!

!NBBootstrapUlong methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/3/2010 01:29'!
coerceReturnValue: gen
	| args result asm proxy |
	asm := gen asm.
	proxy := gen proxy.
	args := gen methodArgs.
	
	result := gen reserveTemp.
	asm mov: asm EAX to: result.
	
	"load a returnValueBuffer method argument oop"
	(NBSTMethodArgument new stackIndex: (args size - (args indexOf: #returnValueBuffer)))
		emitLoad: gen.
	proxy firstIndexableField: asm EAX.  "EAX - address , where to store result "
	asm mov: result to: asm ECX.
	asm mov: asm ECX to: asm EAX ptr.
	
	"primitive will return nil"
	proxy nilObject
! !

!NBBootstrapUlong methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 17:05'!
valueSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	^ 4! !

NBExternalType subclass: #NBByteArrayPtr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBByteArrayPtr methodsFor: 'emitting code' stamp: 'IgorStasenko 8/3/2011 19:47'!
pushAsPointer: gen

	self error: 'ByteArrayPtr is already pointer'! !

!NBByteArrayPtr methodsFor: 'emitting code' stamp: 'CamilloBruni 7/23/2012 13:29'!
pushAsValue: gen

	"push a pointer to first indexable field of ByteArray, 
	which is always oop + BaseHeaderSize  
	"
	| asm proxy |
	asm := gen asm.
	proxy := gen proxy.
	loader emitLoad: gen.

	asm decorateWith: 'NBByteArrayPtr>>pushAsValue:' during: [  	
		asm 
			add: asm EAX with: proxy objectFormat varBytesFirstField;
			push: asm EAX ]! !

!NBByteArrayPtr methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 17:04'!
valueSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	^ self pointerSize ! !

NBExternalType subclass: #NBByteArraySize
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBByteArraySize commentStamp: 'Igor.Stasenko 5/3/2010 13:56' prior: 0!
A helper type, which takes a byte array argument and pushing its size!

!NBByteArraySize methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/3/2010 14:00'!
coerceReturn: gen

	self error: 'Can''t use this type as a return value'! !

!NBByteArraySize methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/3/2010 22:44'!
pushAsPointer: gen
	self shouldNotImplement ! !

!NBByteArraySize methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/3/2010 22:40'!
pushAsValue: gen
	" push the array size "
	gen proxy slotSizeOf: (loader emitLoad: gen).
	gen asm push: gen asm EAX! !

!NBByteArraySize methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 17:04'!
valueSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	^ 4! !

NBExternalType subclass: #NBCharacterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBCharacterType commentStamp: '<historical>' prior: 0!
Character type.
 Represented as single byte on C side.

Accepts Character/Smallint as argument, 
converts return value to Character instance!

!NBCharacterType methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:34'!
coerceReturnValue: gen
	| asm proxy val |
	"convert unsigned Char to ST Character"
	asm := gen asm.
	proxy := gen proxy.
	
	val := gen reserveTemp.
	asm movzx: asm EAX with: asm AL.
	asm mov: asm EAX to: val.
	
	proxy fetchPointer: val ofObject: (proxy characterTable).
	
	gen releaseTemps: 1! !

!NBCharacterType methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:34'!
pushAsValue: gen

	"oop is a Character or smallint"
	| asm oop classChar reg proxy notSmi done |
	
	asm := gen asm.
	proxy := gen proxy.

	notSmi := asm uniqueLabelName: 'notSmi'.
	done := asm uniqueLabelName: 'done'.
	
	oop := gen reserveTemp.
	classChar := gen reserveTemp.

	reg := loader emitLoad: gen.
	asm mov: reg to: oop.
	
	reg := proxy isIntegerObject: reg.
	
	asm or: reg with: reg;
		je: notSmi.
	
	asm push: (proxy integerValueOf: oop);
		jmp: done.
	asm label: notSmi.

	reg := proxy classCharacter.
	asm mov: reg to: classChar.

	reg := proxy fetchClassOf: oop.
	asm 
		cmp: reg with: classChar;
		jne: gen failedLabel.

	reg := proxy fetchInteger: 0 ofObject: oop.
	asm push: reg;
	label: done.
	
	gen releaseTemps: 2
! !

!NBCharacterType methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 23:34'!
valueSize
	^ 1! !

NBExternalType subclass: #NBExternalAddressType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalAddressType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/19/2010 12:15'!
coerceReturnValue: gen

	"input: address is in EAX. 
	output: ExternalAddress instance oop in EAX
	creates an instance of NBExternalAddress and store the address there"

	| asm proxy result |
	
	proxy := gen proxy.
	asm := gen asm.
	result := gen reserveTemp.
	
	asm mov: asm EAX to: result.
	proxy createInstanceOf: NBExternalAddress size: NBExternalType pointerSize.
	asm mov: result to: asm ECX.
	proxy storePointer: asm ECX intoVarbytes: asm EAX at: 0.

	"return the oop in EAX"
	
	gen releaseTemps: 1.
	! !

!NBExternalAddressType methodsFor: 'emitting code' stamp: 'CamilloBruni 7/23/2012 13:29'!
pushAsPointer: gen

	"push a pointer to external address first indexable field (where address value held)"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.

	"we can skip class verification, if loader loads receiver, since nothing to fear there"
	loader isReceiver ifFalse: [
		self verifyClassOf: oop is: NBExternalAddress generator: gen.
	].

	asm decorateWith: 'NBExternalAddressType>>pushAsPointer:' during: [  	
		proxy varBytesFirstFieldOf: oop.
		asm 
			push: asm EAX ].
	
	gen releaseTemps: 1.
! !

!NBExternalAddressType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/28/2012 07:13'!
pushAsValue: gen
	"push handle value"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	"we can skip class verification, if loader loads receiver, since nothing to fear there"
	loader isReceiver ifFalse: [
		self verifyClassOf: oop is: NBExternalAddress generator: gen.
	].

	proxy varBytesFirstFieldOf: oop.
	
	self valueSize = 4 ifTrue: [
		asm push: asm EAX ptr.
	] ifFalse: [ self notYetImplemented ].

	gen releaseTemps: 1.
! !

!NBExternalAddressType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/4/2010 00:56'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBExternalEnumerationType
	instanceVariableNames: 'representationType objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalEnumerationType class methodsFor: 'instance creation' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
objectClass: aClass
	^ self objectClass: aClass representationType: NBUInt32 new! !

!NBExternalEnumerationType class methodsFor: 'instance creation' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
objectClass: aClass representationType: anIntegerType
	^ self new
		objectClass: aClass;
		representationType: anIntegerType! !

!NBExternalEnumerationType methodsFor: 'emitting code' stamp: 'CiprianTeodorov 2/6/2013 21:51'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel
	"coerce a object - oop , provided by loader and then put a result into an appropriate 
	operand (memory/register), answer that operand"

	| asm proxy oop class |
	self assert: pointerArity = 0.
	asm := gen asm.
	proxy := gen proxy.
	oop := gen reserveTemp.
	class := gen reserveTemp.
	asm mov: asm EAX to: oop.
	gen proxy fetchClassOf: oop.
	asm mov: asm EAX to: class.
	gen emitFetchClass: self objectClass.
	asm
		cmp: asm EAX with: class;
		jne: aLabel.
	proxy fetchPointer: self valueIvarIndex ofObject: oop.	"value ivar"
	self representationType coerceOopToOperand: gen ifFailedJumpTo: aLabel.
	asm push: asm EAX.
	gen releaseTemps: 2! !

!NBExternalEnumerationType methodsFor: 'emitting code' stamp: 'CiprianTeodorov 2/6/2013 21:38'!
coerceReturnValue: gen

	"value is in EAX, get a ST Integer and place it in the value ivar"

	| asm proxy  valueOop oop done |
	
	proxy := gen proxy.
	asm := gen asm.
	valueOop := gen reserveTemp.
	oop := gen reserveTemp.

	self representationType coerceReturnValue: gen.
	asm mov: asm EAX to: valueOop.
	proxy pushRemappableOop: valueOop.
	
	gen emitFetchClass: objectClass.
	
	proxy instantiateClass: asm EAX indexableSize: 0.
	"EAX <- our instance "
	asm mov: asm EAX to: oop.
	proxy popRemappableOop.
	asm mov: asm EAX to: valueOop.
	
	proxy storePointer: self valueIvarIndex ofObject: oop  withValue: valueOop.
	asm mov: oop to: asm EAX.  "return the oop"

	gen releaseTemps: 2.! !

!NBExternalEnumerationType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
objectClass
	^ objectClass! !

!NBExternalEnumerationType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
objectClass: anObject
	objectClass := anObject! !

!NBExternalEnumerationType methodsFor: 'printing' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
printOn: aStream

	aStream nextPutAll: 'External enum(' , objectClass name , ')'
! !

!NBExternalEnumerationType methodsFor: 'emitting code' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
pushAsPointer: gen
	"push a pointer to handle value"
	| asm proxy oop |
	
	self assert: (pointerArity = 1).
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	self verifyClassOf: oop is: objectClass generator: gen.
	
	proxy fetchPointer: (self valueIvarIndex) ofObject: oop. "value ivar"
	proxy firstIndexableField: asm EAX. "value ptr"
	asm push: asm EAX.
	
	gen releaseTemps: 1.! !

!NBExternalEnumerationType methodsFor: 'emitting code' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
pushAsValue: gen

	"push value"
	|asm proxy oop|
	proxy := gen proxy.
	asm := gen asm.
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	"Special case: do not emit type checking if argument is receiver"
	(loader isReceiver and: [  gen requestor  includesBehavior: objectClass ])
	ifFalse: [
		self verifyClassOf: oop is: objectClass generator: gen.
	].

	proxy fetchPointer: (self valueIvarIndex) ofObject: oop. "value ivar"
	proxy integerValueOf: asm EAX. "handle value"
	asm push: asm EAX.
	
	gen releaseTemps: 1.
! !

!NBExternalEnumerationType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/11/2012 19:19'!
representationType
	^ representationType! !

!NBExternalEnumerationType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/11/2012 19:19'!
representationType: anObject
	representationType := anObject! !

!NBExternalEnumerationType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/25/2012 13:29'!
valueIvarIndex
	" return a zero-based index "
	^ ( objectClass instVarIndexFor: #value ifAbsent: [ self error: ' should not happen ' ] ) - 1
! !

!NBExternalEnumerationType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/11/2012 21:45'!
valueSize
	^4! !

NBExternalType subclass: #NBExternalObjectType
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalObjectType commentStamp: 'Igor.Stasenko 4/29/2010 09:17' prior: 0!
I providing coercions for
NBExternalObject and its subclasses!

!NBExternalObjectType class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 4/29/2010 09:16'!
objectClass: aClass
	^ self new objectClass: aClass! !

!NBExternalObjectType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/29/2010 09:15'!
coerceReturnPointer: gen

	
	self error: 'returning pointer to handle ?'

	"super coerceReturnPointer: gen"! !

!NBExternalObjectType methodsFor: 'emitting code' stamp: 'IgorStasenko 8/29/2012 14:54'!
coerceReturnValue: gen

	"handle is in EAX. 
	first, create an instance of NBExternalHandle. Place the handle there ,
	then create an instance of receiver and place handle oop in its handle ivar"

	| asm proxy result handleOop oop done |
	
	proxy := gen proxy.
	asm := gen asm.
	result := gen reserveTemp.
	handleOop := gen reserveTemp.
	oop := gen reserveTemp.
	done := asm uniqueLabelName: 'done'.
	
	asm mov: asm EAX to: result.

	gen optReturnNullAsNil ifTrue: [ | notnil |
		notnil := asm uniqueLabelName: 'notNil'.
		
		asm 
			or: asm EAX with: asm EAX;
			jne: notnil.
		proxy nilObject.
		asm jmp: done.
		asm label: notnil.
	].	
	gen emitFetchClass: NBExternalHandle.
	
	proxy instantiateClass: asm EAX indexableSize: 4.
	asm mov: asm EAX to: handleOop.

	proxy firstIndexableField: asm EAX.
	asm mov: result to: asm ECX;
		mov: asm ECX to: asm EAX ptr.
	
	proxy pushRemappableOop: handleOop.
	
	gen emitFetchClass: objectClass.
	
	proxy instantiateClass: asm EAX indexableSize: 0.
	"EAX <- our instance "
	asm mov: asm EAX to: oop.
	proxy popRemappableOop.
	asm mov: asm EAX to: handleOop.
	
	proxy storePointer: self handleIvarIndex ofObject: oop  withValue: handleOop.
	
	asm mov: oop to: asm EAX.  "return the oop"

	gen releaseTemps: 3.
	asm label: done.
	! !

!NBExternalObjectType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 09:22'!
handleIvarIndex
	" return a zero-based index "
	^ ( objectClass instVarIndexFor: #handle ifAbsent: [ self error: ' should not happen ' ] ) - 1! !

!NBExternalObjectType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 09:18'!
objectClass
	^ objectClass! !

!NBExternalObjectType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 09:18'!
objectClass: aClass
	objectClass := aClass! !

!NBExternalObjectType methodsFor: 'printing' stamp: 'Igor.Stasenko 5/18/2010 01:25'!
printOn: aStream

	aStream nextPutAll: 'External Object(' , objectClass name , ')'! !

!NBExternalObjectType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/18/2010 02:46'!
pushAsPointer: gen
	"push a pointer to handle value"
	| asm proxy oop |
	
	self assert: (pointerArity = 1).
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	self verifyClassOf: oop is: objectClass generator: gen.
	
	proxy fetchPointer: (self handleIvarIndex) ofObject: oop. "handle ivar"
	proxy firstIndexableField: asm EAX. "handle value ptr"
	asm push: asm EAX.
	
	gen releaseTemps: 1.
! !

!NBExternalObjectType methodsFor: 'emitting code' stamp: 'JavierPimas 11/14/2011 15:17'!
pushAsValue: gen
	"push handle value"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.
	loader emitLoad: gen to: oop.
	
	"Special case: do not emit type checking if argument is receiver"
	(loader isReceiver and: [  gen requestor  includesBehavior: objectClass ])
	ifFalse: [
		self verifyClassOf: oop is: objectClass generator: gen.
	].

	proxy fetchPointer: (self handleIvarIndex) ofObject: oop. "handle ivar"
	proxy firstIndexableField: asm EAX. "handle value ptr"
	asm mov: asm EAX ptr to: asm EAX. "handle value"
	asm push: asm EAX.
	
	gen releaseTemps: 1.

	! !

!NBExternalObjectType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 13:52'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBExternalString
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core-Types'!

!NBExternalString commentStamp: 'IgorStasenko 8/10/2011 18:46' prior: 0!
NBExternalString type can be used to coerce squeak's String to char* back and forth.

Use #String or #NBExternalString as type name.

Some functions may accept null as a valid argument (if string is optional).
You can set #optStringOrNull in callout options in that case.

If type is used as return value type, then C string (char *) converted to ByteString instance.
If return value is null, a nil will be answered instead.!

!NBExternalString methodsFor: 'emitting code' stamp: 'IgorStasenko 8/10/2011 18:41'!
coerceReturnValue: gen
	"
	Copy a null-terminated C string into a newly created instance of ByteString
	input - char* string in EAX
	output - String oop in EAX "
	
	| cPtr strLen oop asm proxy notNull done |

	asm := gen asm.
	proxy := gen proxy.
	
	cPtr := gen reserveTemp.
	strLen := gen reserveTemp.
	oop := gen reserveTemp.
	notNull := asm uniqueLabelName: 'notNull'.
	done := asm uniqueLabelName: 'done'.
	
	
	asm mov: EAX to: cPtr.

	"check if return value is NULL, then answer nil instead" 
	asm 
		or: EAX with: EAX;
		jnz: notNull.

	proxy nilObject.
	asm jmp: done.		

	asm label: notNull.
	
	"count a number of characters"
	asm mov: (self strLen: gen) to: strLen.

	proxy classString.
	proxy instantiateClass: EAX indexableSize: strLen.
	
	asm mov: EAX to: oop. "oop"
	
	"copy the string"
	proxy firstIndexableField: EAX.
	asm 
		push: ESI;
		push: EDI;
		mov: cPtr to: ESI;
		mov: EAX to: EDI;
		mov: strLen to: ECX;
		rep; movsb; 
		pop: EDI;
		pop: ESI;
		mov: oop to: EAX.

	asm label: done.
		
	gen releaseTemps: 3.
! !

!NBExternalString methodsFor: 'emitting code' stamp: 'CamilloBruni 7/23/2012 13:29'!
prepareArgumentUsing: gen

	"prepare the ByteString argument.
	Allocate a space for string on stack, then copy string contents there
	and add terminating null character "
	
	| asm stringOop len loop done donePreparing notNil |
	
	asm := gen asm.
	
	loop := asm uniqueLabelName: 'loop'.
	done := asm uniqueLabelName: 'done'.
	notNil  := asm uniqueLabelName: 'notNil'.
	donePreparing := asm uniqueLabelName: 'donePreparing'.
	    
	loader emitLoad: gen.

	"reserve after emitting load, otherwise, if proxy using stackpointer temp, it will be clobbered"
	address := gen reserveTemp.  
	stringOop := gen reserveTemp.
	len := gen reserveTemp.

	asm mov: EAX to: stringOop.
	
	gen optStringOrNull ifTrue: [
		"allow passing nil as string, effectively will push null pointer as argument"
		gen proxy nilObject.
		asm 
			cmp: EAX with: stringOop;
			jne: notNil;
			mov: 0 to: address;  "null pointer"
			jmp: donePreparing.
	].
	asm label: notNil.
	gen proxy isBytes: stringOop.
	
	asm or: EAX with: EAX.
	asm jz: gen failedLabel.
	
	gen proxy byteSizeOf: stringOop.
	asm mov: EAX to: len.
	asm inc: EAX. "add 1 byte for terminating null character"
	gen reserveStackBytes: EAX andStoreAddrTo: address.

	gen proxy firstIndexableField: stringOop.

	asm decorateWith: ' copy string contents to the stack ' during: [
	asm 
		push: ESI;
		push: EDI;
		mov: EAX to: ESI;
		mov: address to: EDI;
		mov: len to: ECX;
"		rep; movsb;  -- is flat memory model has ES=DS ? "
	label: loop;
		dec: ECX;
		jl: done;
		mov: ESI ptr to: AL;
		mov: AL to: EDI ptr;
		inc: ESI;
		inc: EDI;
		jmp: loop;
	label: done;
		mov: 0 to: EDI ptr8;  "store null-terminating character"
		pop: EDI;
		pop: ESI.
	].
	gen releaseTemps: 2.  "keep the address reserved, otherwise it will be clobbered"
	asm label: donePreparing   ! !

!NBExternalString methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 20:26'!
pushAsPointer: gen 

	self error: 'Strings already passed as a pointer'.! !

!NBExternalString methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 13:44'!
pushAsValue: gen

	gen asm push: address.

! !

!NBExternalString methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/2/2010 20:38'!
strLen: gen
	" input: EAX - pointer to char* string
	 output: ECX - string length "
	| loop end asm |
	asm := gen asm.
	
	loop := asm uniqueLabelName: 'loop'.
	end := asm uniqueLabelName: 'end'.
	asm 
		mov: EAX to: ECX;
	label: loop;
		cmp: ECX ptr8 with: 0;
		je: end;
		inc: ECX;
		jmp: loop;
	label: end;
		sub: ECX with: EAX.
		
	^ ECX
! !

!NBExternalString methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:56'!
valueSize
	^ self pointerSize "i am live and die as a pointer"! !

NBExternalType subclass: #NBExternalStructureType
	instanceVariableNames: 'objectClass returnOop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalStructureType class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/17/2010 18:42'!
objectClass: aClass
	^ self new objectClass: aClass! !

!NBExternalStructureType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/4/2012 19:17'!
coerceReturnValue: gen

	| asm proxy |
	
	asm := gen asm.
	proxy := gen proxy.
	
	self returnViaRegisters ifTrue: [
		| temp1 temp2 oop |

		"save struct value(s) into temps"
		temp1 := gen reserveTemp.
		asm mov: asm EAX to: 	temp1.
			
		objectClass instanceSize > 4 ifTrue: [
			temp2 := gen reserveTemp.
			asm mov: asm EDX to: temp2
		].
	
		"instantiate our struct"

		oop := gen reserveTemp.
		gen emitFetchClass: objectClass.
		proxy instantiateClass: asm EAX indexableSize: objectClass instanceSize.
		asm mov: asm EAX to: oop.
		proxy firstIndexableField: asm EAX. "in EAX is pointer to first byte of struct"

		"copy struct values into newly created instance"
		asm mov: temp1 to: asm ECX.
		asm mov: asm ECX to: asm EAX ptr.

		objectClass instanceSize > 4 ifTrue: [
			asm mov: temp2 to: asm ECX.
			asm mov: asm ECX to: asm EAX ptr + 4.
		].

		"return an instance of objectClass as result"
		asm mov: oop to: asm EAX 
		
	] ifFalse: [
		
		"just return a previously instantiated struct oop"		
		asm mov: returnOop to: asm EAX
	]! !

!NBExternalStructureType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 18:43'!
objectClass

	^objectClass! !

!NBExternalStructureType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/17/2010 18:43'!
objectClass: anObject

	objectClass := anObject! !

!NBExternalStructureType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/4/2012 19:16'!
prepareReturnValue: gen for: callinfo

	| asm proxy |
	
	asm := gen asm.
	proxy := gen proxy.
	
	(pointerArity = 0 and: [ self returnViaRegisters not ]) ifTrue: [
		"we should instantiate a new instance of struct 
		and push a pointer to its first byte on a stack (so C function will know where to store return value(s))"
		returnOop := gen reserveTemp.
		gen emitFetchClass: objectClass.
		proxy instantiateClass:  asm EAX indexableSize: objectClass instanceSize.
		asm mov: asm EAX to: returnOop.
		proxy firstIndexableField: asm EAX. "in EAX is pointer to first byte of struct"
		
		asm noticePush: asm pointerSize forCall: callinfo.
		asm push: asm EAX
	]
! !

!NBExternalStructureType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/26/2012 00:53'!
pushAsPointer: gen
	"push a pointer to structure (which should be a subinstance of NBExternalStructure)"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp annotation: 'oop'.

	loader emitLoad: gen to: oop.
	self verifyClassOf: oop is: objectClass generator: gen.
	
	"do a shortcut, since we know that variable bytes first byte offset"
	asm mov: oop to: asm EAX;
		add: asm EAX with: 
			(proxy objectFormat varBytesFirstField asUImm32 
				annotation: 'variable-byte first field offset').
	asm push: asm EAX.

	gen releaseTemps: 1.
	! !

!NBExternalStructureType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/26/2012 14:19'!
pushAsValue: gen
	"pass a structure by value on stack"
	| asm proxy oop bytesToCopy offset |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp annotation: 'oop'.

	loader emitLoad: gen to: oop.
	
	loader isReceiver ifFalse: [
		"do not check type if argument is receiver, since we know its class"
		self verifyClassOf: oop is: objectClass generator: gen.
	].

	asm mov: oop to: asm EAX;
		add: asm EAX with: 
			(proxy objectFormat varBytesFirstField asUImm32 
				annotation: 'variable-byte first field offset').
	
	"struct size aligned to stack argument alignment"
	asm sub: asm ESP with: self stackSize. 

	"generate code to copy struct contents on a stack.
	source is [EAX]
	destination is [ESP]
	"

	bytesToCopy := self valueSize. 
	offset := 0.	
	"we can afford to read past struct size, since all objects 
	in obj memory are 4-byte aligned"
	[ bytesToCopy > 0 ] whileTrue: [
		asm 
			mov: asm EAX ptr32 + offset to: asm EDX;
			mov: asm EDX to: asm ESP ptr32 + offset.
			
		bytesToCopy := bytesToCopy - 4.
		offset := offset + 4. 
	].
	gen releaseTemps: 1.
	! !

!NBExternalStructureType methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 01:03'!
readOop: memoryOperand generator: gen
	"emit code to read a value from given memory operand
	and convert it to a corresponding ST object" 

	| asm proxy size offset oop src |
	
	asm := gen asm.
	proxy := gen proxy.

	pointerArity > 0 ifTrue: [
		asm mov: memoryOperand to: asm EAX.
		^ self coerceReturn: gen.
		].
	
	"read structure from given address, copy it to newly created instance of corresponding struct class"
	
	asm lea: asm EAX with: memoryOperand.
	src := gen reserveTemp.
	asm mov: asm EAX to: src.
	
	"instantiate our struct"

	oop := gen reserveTemp.
	gen emitFetchClass: objectClass.
	proxy instantiateClass: asm EAX indexableSize: self valueSize.
	asm mov: asm EAX to: oop.

	proxy varBytesFirstFieldOf: asm EAX.
	asm mov: src to: asm EDX.
	"in EAX is pointer to first byte of struct"

	size := self valueSize.
	offset := 0.
	[ size >= 4 ] whileTrue: [
		asm 
			mov: asm EDX ptr + offset to: asm ECX;
			mov: asm ECX to: asm EAX ptr + offset.
		size := size - 4.
		offset := offset + 4.
	].

	size >= 2  ifTrue: [
		asm 
			mov: asm EDX ptr16 + offset to: asm CX;
			mov: asm CX to: asm EAX ptr16 + offset.
		size := size - 2.
		offset := offset + 2.
	].

	size > 0  ifTrue: [
		" last byte "
		asm 
			mov: asm EDX ptr8 + offset to: asm CL;
			mov: asm CL to: asm EAX ptr8 + offset.
	].

	"return an instance of objectClass as result"
	asm mov: oop to: asm EAX 
! !

!NBExternalStructureType methodsFor: 'testing' stamp: 'CiprianTeodorov 1/28/2013 23:42'!
returnViaRegisters
"
answer true if return-by-value for given struct are returned in registers.
1byte, 2 bytes, and 4 bytes structures are returned in EAX.
8 byte structures are returned in EDX:EAX
otherwise it is assumed that caller passing a hidden argument (a pointer to struct)
which callee using for filling the data
"
"Both Mac OS X x86 and Win32 x86 return structs of a power of two in size
less than or equal to eight bytes in length in registers. Linux never does so. "
	^NativeBoost platformId = NativeBoostConstants linux32PlatformId
		ifTrue:[false]
		ifFalse:[ #(1 2 4 8) includes: self valueSize]! !

!NBExternalStructureType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 14:12'!
valueSize 
	^ objectClass instanceSize ! !

NBExternalStructureType subclass: #NBExternalUnionType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBExternalType class methodsFor: 'converting' stamp: 'Igor.Stasenko 4/28/2010 12:20'!
asNBExternalType: gen

	^ self new! !

!NBExternalType class methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 05:49'!
pointerSize
	"Answer a number of bytes, which takes a pointer value"
	self flag: #x64.
	^ 4! !

!NBExternalType class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 11:25'!
prepareArgument: typeArgument generator: gen

	"by default, do nothing"! !

!NBExternalType class methodsFor: 'public' stamp: 'IgorStasenko 12/30/2011 12:55'!
sizeOf: aTypeName

	^ (NBFFICallout new resolveType: aTypeName) valueSize! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 14:30'!
baseTypeSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/11/2010 01:30'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel

	"coerce a object - oop , provided by loader and then put a result into an appropriate 
	operand (memory/register), answer that operand"
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 17:42'!
coerceReturn: gen
	 pointerArity > 0 ifTrue: [ self coerceReturnPointer: gen ]
			ifFalse: [ self coerceReturnValue: gen ].
! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 12/20/2011 14:21'!
coerceReturnPointer: gen

	"Return a pointer to receiver. 
	lets just return its value"
	
	| asm EAX cont done |
	asm := gen asm.
	EAX := asm EAX.
	cont := asm uniqueLabelName: 'cont'.
	done := asm uniqueLabelName: 'done'.
	
	(gen optReturnNullAsNil or: [gen optFailOnReturnNull ]) ifTrue: [
		asm or: EAX with: EAX.
		gen optFailOnReturnNull 
			ifTrue: [	asm jz: gen failedLabel. ]
			ifFalse: [
				asm jnz: cont.
				gen proxy nilObject.
				asm jmp: done 	]
	].
	asm label: cont.
	gen optReturnPtrAsExternalAddress 
		ifTrue: [ 
			(NBExternalAddress asNBExternalType: gen) coerceReturnValue: gen ]
		ifFalse: [ 
			gen optReturnPtrAsInt ifFalse: [
				self error: 'Function returns a pointer, but returning raw pointer value is prohibited by options' ].

			gen proxy positive32BitIntegerFor: asm EAX ].
	asm label: done
	! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 08:10'!
coerceReturnValue: generator
	"emit code to coerce return value from external function call"
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'testing' stamp: 'IgorStasenko 5/11/2011 17:26'!
coercionMayFail
	"answer true if argument coercion ST->C may fail due to passing incomatible argument type.
	Some types could accept any ST object as argument and therefore never fail,
	and we don't need to check a primitive failuer before making a call.
	By default, asnwer true
	"
	^ true! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/11/2011 17:24'!
emitPush: generator

	pointerArity > 0 ifTrue: [ ^ self pushAsPointer: generator ].
	 
	generator coercionMayFail: self coercionMayFail.    
	^ self pushAsValue: generator.! !

!NBExternalType methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 4/28/2010 11:34'!
initialize

	pointerArity := 0.! !

!NBExternalType methodsFor: 'testing' stamp: 'Igor.Stasenko 5/1/2010 16:05'!
isCallback
	^ false! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/26/2012 18:21'!
loadMem: memoryOperand generator: gen.
	"load the value from memory operand into return value register"
	gen asm mov: memoryOperand to: (gen asm reg: 0 size: self typeSize).
! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 09:50'!
loader
	^ loader! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 09:51'!
loader: aLoader
	loader := aLoader! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 11:35'!
pointerArity
	^ pointerArity! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 11:35'!
pointerArity: additionalArity

	pointerArity := pointerArity + additionalArity.! !

!NBExternalType methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 05:49'!
pointerSize
	"Answer a number of bytes, which takes a pointer value"
	^ self class pointerSize! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 11:41'!
prepareArgumentUsing: aNBFFICallout 
	"by default, do nothing"! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 5/4/2012 17:08'!
prepareReturnValue: gen for: callinfo

	"do some extra for preparing a function return value holder.
	no-op for most of the types, except external structures " 
! !

!NBExternalType methodsFor: 'printing' stamp: 'Igor.Stasenko 4/30/2010 09:22'!
printOn: aStream

	super printOn: aStream.
	
	pointerArity timesRepeat: [ aStream nextPut: $* ].! !

!NBExternalType methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/20/2010 06:31'!
pushAsPointer: gen 
	"by default, push argument as a bytearray ptr"
	
	"may accept:
		- nil
		- variable bytes oop
		- external address "
	| asm proxy notNil done oop  notExternalAddress |
	
	asm := gen asm.
	proxy := gen proxy.
	done := asm uniqueLabelName: 'done'.
	oop := gen reserveTemp.
	
	"load argument oop"
	loader emitLoad: gen to: oop.
	
	"handle nils, if we care"
	gen optCoerceNilToNull ifTrue: [
		notNil := asm uniqueLabelName: 'notNil'.
		proxy nilObject.
		asm cmp: asm EAX with: oop;
		jne: notNil;
		xor: asm EAX with: asm EAX;
		push: asm EAX;
		jmp: done;
		label: notNil.
	].

	"handle ExternalAddress, if we care"
	gen optAllowExternalAddressPtr ifTrue: [ | oopClass |
		oopClass := gen reserveTemp.
		notExternalAddress := asm uniqueLabelName: 'notExternalAddress'.
		proxy fetchClassOf: oop.
		asm mov: asm EAX to: oopClass.

		gen emitFetchClass: NBExternalAddress.
		asm cmp: asm EAX with: oopClass.
		asm jne: notExternalAddress.
		
		proxy fetchPointer: 0 ofObject: oop.  
		asm push: asm EAX.
		
		asm jmp: done.
		asm label: notExternalAddress.
		gen releaseTemps: 1.
	].

	"the last case is a byte/word array, 
	simply push a pointer to first indexable field of oop"

	gen optAllowByteArraysPtr ifTrue: [
		proxy isBytesOrWords: oop ifNotJumpTo: gen failedLabel.
		proxy firstIndexableField: oop.
		asm push: asm EAX.
		asm jmp: done.
	].
	asm jmp: gen failedLabel.
	asm label: done.

	gen releaseTemps: 1.
	! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 01:03'!
readOop: memoryOperand generator: gen
	"emit code to read a value from given memory operand
	and convert it to a corresponding ST object" 
	
	memoryOperand size: self typeSize.
	pointerArity > 0 
		ifTrue: [ gen asm mov: memoryOperand to: gen asm EAX ]
		ifFalse: [ self loadMem: memoryOperand generator: gen ].
	
	self coerceReturn: gen! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 01:04'!
stackArgumentAlignment
	"a minimum number of bytes, which argument of any type
	can have on stack, when pushed as argument"
	^ 4! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 14:33'!
stackSize
	"Answer a number of bytes, which takes a value of given type when pushed on stack"
	
	^ self typeSize alignedTo: self stackArgumentAlignment ! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 14:26'!
storageSize
	"Answer a number of bytes, which receiver type takes in memory"
	
	pointerArity > 0 ifTrue: [ ^ self pointerSize ].
	^ self valueSize! !

!NBExternalType methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/16/2012 15:34'!
typeName
	| tName |
	tName := self class name.
	pointerArity timesRepeat: [ tName , '*' ].
	^ tName! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 17:09'!
typeSize
	
	"Answer a number of bytes, which receiver type takes in memory"

	pointerArity > 0 ifTrue: [ ^ self pointerSize ].
	^ self valueSize ! !

!NBExternalType methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 14:28'!
valueSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	
	self subclassResponsibility ! !

!NBExternalType methodsFor: 'emitting code' stamp: 'IgorStasenko 8/8/2011 19:54'!
verifyClassOf: oop is: aClass generator: gen

	| asm class okLabel |
	asm := gen asm.
	okLabel := asm uniqueLabelName: 'classIsOk'.
	
	class := gen reserveTemp.
	
	gen proxy fetchClassOf: oop.
	asm mov:  asm EAX to: class.
	
	gen emitFetchClass: aClass.
	
	asm cmp: asm EAX with: class;
		je: okLabel.
		gen failWithMessage: 'An instance of ' , aClass name , ' expected'.
	asm label: okLabel.
	
	gen releaseTemps: 1.! !

NBExternalType subclass: #NBFFICallbackType
	instanceVariableNames: 'callbackClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFFICallbackType commentStamp: 'Igor.Stasenko 5/4/2010 05:15' prior: 0!
Pushing a callback to stack!

!NBFFICallbackType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/13/2010 23:33'!
callbackClass: aClass
	callbackClass := aClass! !

!NBFFICallbackType methodsFor: 'emitting code' stamp: 'cipt 11/28/2012 19:36'!
coerceReturnValue: gen

	"trunk is in EAX. 
	first, create an instance of NBExternalHandle. Place the trunk there ,
	then create an instance of receiver and place trunk oop in its trunk ivar"

	| asm proxy result trunkOop oop done |
	
	proxy := gen proxy.
	asm := gen asm.
	result := gen reserveTemp.
	trunkOop := gen reserveTemp.
	oop := gen reserveTemp.
	done := asm uniqueLabelName: 'done'.
	
	asm mov: asm EAX to: result.

	gen optReturnNullAsNil ifTrue: [ | notnil |
		notnil := asm uniqueLabelName: 'notNil'.
		
		asm 
			or: asm EAX with: asm EAX;
			jne: notnil.
		proxy nilObject.
		asm jmp: done.
		asm label: notnil.
	].	
	gen emitFetchClass: NBExternalAddress.
	
	proxy instantiateClass: asm EAX indexableSize: 4.
	asm mov: asm EAX to: trunkOop.

	proxy firstIndexableField: asm EAX.
	asm mov: result to: asm ECX;
		mov: asm ECX to: asm EAX ptr.
	
	proxy pushRemappableOop: trunkOop.
	
	gen emitFetchClass: callbackClass.
	
	proxy instantiateClass: asm EAX indexableSize: 0.
	"EAX <- our instance "
	asm mov: asm EAX to: oop.
	proxy popRemappableOop.
	asm mov: asm EAX to: trunkOop.
	
	proxy storePointer: self trunkIvarIndex ofObject: oop  withValue: trunkOop.
	
	asm mov: oop to: asm EAX.  "return the oop"

	gen releaseTemps: 3.
	asm label: done.! !

!NBFFICallbackType methodsFor: 'testing' stamp: 'Igor.Stasenko 5/13/2010 23:31'!
isCallback
	^ true! !

!NBFFICallbackType methodsFor: 'emitting code' stamp: 'IgorStasenko 9/15/2012 14:22'!
pushAsValue: gen
	"push the callback trunk address"
	| asm proxy oop |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := gen reserveTemp.

	loader emitLoad: gen to: oop.
	self verifyClassOf: oop is: callbackClass generator: gen.
	
	asm mov: oop to: asm EAX.
	asm mov: asm EAX ptr + (proxy ivar: #trunk in: callbackClass) to: asm EAX. 
	proxy fetchPointer: 0 ofObject: asm EAX. "callback address"
	asm push: asm EAX.
! !

!NBFFICallbackType methodsFor: 'accessing' stamp: 'cipt 11/28/2012 19:04'!
trunkIvarIndex
	" return a zero-based index "
	^ ( callbackClass instVarIndexFor: #trunk ifAbsent: [ self error: ' should not happen ' ] ) - 1! !

!NBFFICallbackType methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/4/2010 05:16'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBFloatPtr
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloatPtr commentStamp: 'IgorStasenko 12/21/2011 13:43' prior: 0!
Use to pass a pointer to instance of Float, which is C (double *) equivalent.
Can be used for functions which may modify the floating-point values at specified memory pointer.

NOTE: always copy float objects before passing them to such callouts.!

!NBFloatPtr methodsFor: 'emitting code' stamp: 'IgorStasenko 12/21/2011 13:40'!
pushAsPointer: gen

	self error: 'only value-type arguments allowed'! !

!NBFloatPtr methodsFor: 'emitting code' stamp: 'IgorStasenko 12/21/2011 14:26'!
pushAsValue: gen

	"argument in ST(0) "

	| proxy oop asm |
	
	proxy := gen proxy.
	asm := gen asm.
	
	oop := loader emitLoad: gen.
	proxy verifyCompactClassOf: oop is: Float.
	asm 
		add: asm EAX with: proxy baseHeaderSize;
		push: asm EAX.
	! !

!NBFloatPtr methodsFor: 'accessing' stamp: 'IgorStasenko 12/21/2011 13:40'!
valueSize
	^ self pointerSize! !

NBExternalType subclass: #NBFloatType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloatType commentStamp: 'Igor.Stasenko 4/28/2010 11:54' prior: 0!
Abstract class for floating-point native types!

NBFloatType subclass: #NBFloat128
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat128 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:53'!
valueSize
	^ 16! !

NBFloatType subclass: #NBFloat16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat16 commentStamp: '<historical>' prior: 0!
not supported on x86 archs..

!

!NBFloat16 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:53'!
valueSize
	^ 2! !

NBFloatType subclass: #NBFloat32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 14:43'!
coerceReturnValue: gen

	"return value in ST(0)"
	
	NBFloat64 new pushValue: gen.
	gen proxy gatedCallFn: #floatObjectOf: .

	! !

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 18:32'!
loadMem: memoryOperand generator: gen.
	"floats get loaded into FP stack"
	
	gen asm fld: memoryOperand.
! !

!NBFloat32 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/20/2010 04:06'!
pushAsValue: gen

	gen proxy pushFloatOopAsFloat32: (loader emitLoad: gen).

! !

!NBFloat32 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:52'!
valueSize
	^ 4! !

NBFloatType subclass: #NBFloat64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFloat64 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 14:43'!
coerceReturnValue: gen

	"return value in ST(0)"
	
	self pushValue: gen.
	gen proxy gatedCallFn: #floatObjectOf: .
! !

!NBFloat64 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/28/2010 18:32'!
loadMem: memoryOperand generator: gen.
	"floats get loaded into FP stack"
	
	gen asm fld: memoryOperand.
! !

!NBFloat64 methodsFor: 'emitting code' stamp: 'JavierPimas 11/17/2011 11:04'!
pushAsValue: gen
	| proxy asm oop EAX |

	proxy := gen proxy.
	asm := gen asm.
	EAX := asm EAX.
	oop := loader emitLoad: gen.
	
	asm mov: oop to: EAX.
	
	proxy oop: EAX 
		ifSmallInt: [
			asm sar: EAX with: 1;
			push: EAX;
			push: EAX; " extra push to reserve totally 8 bytes on stack"
			fild: asm ESP ptr32;
			fstp: asm ESP ptr64 ] 
		ifNotSmallInt: [
			proxy pushFloatOopAsFloat64: EAX.
		].! !

!NBFloat64 methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/2/2010 20:41'!
pushValue: gen

	"argument in ST(0) "

	| asm |
	asm := gen asm.
	
	asm sub: (asm ESP) with: 8.
	asm fstp: asm ESP ptr64
	
	! !

!NBFloat64 methodsFor: 'accessing' stamp: 'IgorStasenko 5/26/2012 14:01'!
stackSize
	"Answer a number of bytes, which takes a value of given type when pushed on stack"
	pointerArity > 0 ifTrue: [ ^ self pointerSize ].
	^ 8! !

!NBFloat64 methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/28/2010 15:52'!
valueSize
	^ 8! !

NBExternalType subclass: #NBIntegerExternalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBIntegerExternalType commentStamp: 'Igor.Stasenko 4/28/2010 11:53' prior: 0!
Abstract class for all integer external types!

NBIntegerExternalType subclass: #NBSizeT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBSizeT commentStamp: '<historical>' prior: 0!
i implement marshalling for the size_t type.

size_t value size depends on a platform's word size.
on 32-bit it will be 32 bit.
on 64-bit it will be 64 bit 
!

!NBSizeT class methodsFor: 'converting' stamp: 'IgorStasenko 9/3/2012 00:10'!
asNBExternalType: gen

	self pointerSize = 4 ifTrue: [
		^ (gen resolveType: #uint32 )
		].
	
	self pointerSize = 8 ifTrue: [
		^  (gen resolveType: #uint64 )
		].
	
	self error: 'no clue'! !

NBIntegerExternalType subclass: #NBUInt16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBUInt16 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	unsigned 16-bit integer 

type values.!

NBUInt16 subclass: #NBInt16
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBInt16 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	signed 16-bit integer 

type values.!

!NBInt16 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:14'!
coerceReturnValue: gen
	| asm |
	"convert signed short to ST integer"
	asm := gen asm.
	
	asm movsx: asm EAX with: asm AX.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBInt16 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:14'!
pushAsValue: gen

	gen asm push: (gen proxy integerValueOf: (loader emitLoad: gen))! !

!NBUInt16 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:14'!
coerceReturnValue: gen
	| asm |
	
	"convert signed short to ST integer"
	asm := gen asm.
	
	asm movzx: asm EAX with: asm AX.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBUInt16 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:14'!
pushAsValue: gen

	gen asm push: (gen proxy positive32BitValueOf: (loader emitLoad: gen))! !

!NBUInt16 methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 23:14'!
valueSize
	^ 2! !

NBIntegerExternalType subclass: #NBUInt32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBUInt32 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	unsigned 32-bit integer 

type values.!

NBUInt32 subclass: #NBInt32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBInt32 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	signed 32-bit integer 

type values.!

!NBInt32 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:17'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel
	" input: 
		EAX - oop
	  output:
	      EAX - result of coercion
	"
	
	self assert: (pointerArity = 0).
	gen proxy signed32BitValueOf: gen asm EAX! !

!NBInt32 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:17'!
coerceReturnValue: gen
	
	"convert int32 to ST integer"
	gen proxy signed32BitIntegerFor: (gen returnValueRegister).
 
	! !

!NBInt32 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:17'!
pushAsValue: gen

	gen asm push: (gen proxy signed32BitValueOf: (loader emitLoad: gen) )! !

!NBUInt32 methodsFor: 'emitting code' stamp: 'CiprianTeodorov 12/11/2012 19:22'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel
	" input: 
		EAX - oop
	  output:
	      EAX - result of coercion
	"
	
	self assert: (pointerArity = 0).
	gen proxy positive32BitValueOf: gen asm EAX! !

!NBUInt32 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:17'!
coerceReturnValue: gen
	| asm |
	
	"convert signed byte to ST integer"
	asm := gen asm.
	
	gen proxy positive32BitIntegerFor: asm EAX.! !

!NBUInt32 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:17'!
pushAsValue: gen
	| asm |
	asm := gen asm.

	asm push:
		(gen proxy positive32BitValueOf: (loader emitLoad: gen)).

	gen optCheckFailOnEveryArgument ifTrue: [
		gen proxy ifFailedEmit: [  gen failWithMessage: 'Argument coercion failed: positive 32-bit integer value expected' ].
	].! !

!NBUInt32 methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 23:17'!
valueSize
	^ 4! !

NBIntegerExternalType subclass: #NBUInt64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBUInt64 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	unsigned 64-bit integer 

type values.!

NBUInt64 subclass: #NBInt64
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBInt64 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	signed 64-bit integer 

type values.!

!NBInt64 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 00:55'!
coerceReturnValue: gen
	
	"convert 64-bit unsigned value in EAX:EDX to ST integer"
	gen proxy signed64BitIntegerFor
	
	! !

!NBInt64 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 00:24'!
pushAsValue: gen
	| asm |
	asm := gen asm.

	gen proxy signed64BitValueOf: (loader emitLoad: gen).

	asm 
		push: asm EDX;
		push: asm EAX.

	gen optCheckFailOnEveryArgument ifTrue: [
		gen proxy ifFailedEmit: [  gen failWithMessage: 'Argument coercion failed: signed 64-bit integer value expected' ].
	].! !

!NBUInt64 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 00:57'!
coerceReturnValue: gen
	
	"convert 64-bit unsigned value in EAX:EDX to ST integer"
	gen proxy positive64BitIntegerFor
	
	! !

!NBUInt64 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 01:10'!
loadMem: memoryOperand generator: gen

	self shouldNotImplement! !

!NBUInt64 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 00:25'!
pushAsValue: gen
	| asm |
	asm := gen asm.

	gen proxy positive64BitValueOf: (loader emitLoad: gen).

	asm 
		push: asm EDX;
		push: asm EAX.

	gen optCheckFailOnEveryArgument ifTrue: [
		gen proxy ifFailedEmit: [  gen failWithMessage: 'Argument coercion failed: unsigned 64-bit integer value expected' ].
	].! !

!NBUInt64 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 01:11'!
readOop: memoryOperand generator: gen
	"emit code to read a value from given memory operand
	and convert it to a corresponding ST object" 
	| asm |
	
	pointerArity > 0 ifTrue: [
		asm mov: memoryOperand to: asm EAX.
		^ self coerceReturn: gen
		].
	
	asm := gen asm.
	
	asm 
		lea: asm EAX with: memoryOperand;
		mov: asm EAX ptr + 4 to: asm EDX;
		mov: asm EAX ptr to: asm EAX.  
	
	self coerceReturn: gen
	! !

!NBUInt64 methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 23:22'!
valueSize
	^ 8! !

NBIntegerExternalType subclass: #NBUInt8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBUInt8 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	unsigned 8-bit integer 

type values.!

NBUInt8 subclass: #NBInt8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBInt8 commentStamp: '<historical>' prior: 0!
I responsible for marshalling 
	
	signed 8-bit integer 

type values.!

!NBInt8 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:12'!
coerceReturnValue: gen
	| asm |
	
	"convert signed byte to ST integer"
	asm := gen asm.
	
	asm movsx: asm EAX with: asm AL.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBInt8 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:12'!
pushAsValue: gen
	"should we truncate it to 8bit value here?"
	gen asm push: (gen proxy integerValueOf: (loader emitLoad: gen) )	

	! !

!NBUInt8 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:12'!
coerceReturnValue: gen
	| asm |
	
	"convert unsigned byte to ST integer"
	asm := gen asm.
	
	asm movzx: asm EAX with: asm AL.

	gen proxy integerObjectOf: asm EAX.
 
	! !

!NBUInt8 methodsFor: 'emitting code' stamp: 'IgorStasenko 9/2/2012 23:12'!
pushAsValue: gen 

	gen asm push: (	gen proxy positive32BitValueOf: (loader emitLoad: gen)).

	! !

!NBUInt8 methodsFor: 'accessing' stamp: 'IgorStasenko 9/2/2012 23:12'!
valueSize
	^ 1! !

NBExternalType subclass: #NBOop
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBOop commentStamp: '<historical>' prior: 0!
i am special "type", doing no conversion of any sort, just passing an object oop as it is.!

!NBOop methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/1/2010 12:04'!
coerceReturnValue: generator
	"oop is already in EAX, we don't need to do anything"! !

!NBOop methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/29/2010 07:56'!
pushAsPointer: gen

	self error: 'oop is already a pointer. go away'.! !

!NBOop methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/30/2010 13:55'!
pushAsValue: gen

	gen asm push: (loader emitLoad: gen) 

	! !

!NBOop methodsFor: 'accessing' stamp: 'IgorStasenko 5/28/2012 01:38'!
valueSize
	"Answer a number of bytes, which takes a value of given type
	(not a pointer to it)
	"
	
	^ self pointerSize  ! !

NBExternalType subclass: #NBVoid
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBVoid methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/11/2010 02:30'!
coerceOopToOperand: gen ifFailedJumpTo: aLabel

	"coerce a object - oop , provided by loader and then put a result into an appropriate 
	operand (memory/register), answer that operand"
	
	pointerArity = 0 ifTrue: [ ^ self .  "returning void, do nothing " ].
	
	self shouldBeImplemented ! !

!NBVoid methodsFor: 'emitting code' stamp: 'Igor.Stasenko 5/3/2010 14:00'!
coerceReturnValue: gen

	"just return nil"
	
	gen proxy nilObject
! !

!NBVoid methodsFor: 'emitting code' stamp: 'IgorStasenko 9/3/2012 00:14'!
pushAsValue: gen

	self error: 'pushing void ... puff... done!!'! !

!NBVoid methodsFor: 'accessing' stamp: 'CiprianTeodorov 12/15/2012 21:13'!
valueSize 
	pointerArity < 1 ifTrue: [^self error: 'void has unknown size'].
	^self pointerSize ! !

Object subclass: #NBExtraRootsRegistry
	instanceVariableNames: 'pool array cell freeCallbackIndexes'
	classVariableNames: 'Current Seed'
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBExtraRootsRegistry commentStamp: 'Igor.Stasenko 4/29/2010 07:53' prior: 0!
This registry serve for instantiating an external types by native code.

My sole instance is always refreshing during fresh image startup.!

!NBExtraRootsRegistry class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/2/2010 12:50'!
new

	self error: 'use #newWithCell:'! !

!NBExtraRootsRegistry class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/2/2010 12:50'!
newWithCell: aMemoryCell

	^ self basicNew initialize: aMemoryCell! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 06:36'!
at: aName

	"Answer an object associated with given name."
	| index |
	index := pool at: aName.
	^ array at: index! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/14/2010 02:06'!
at: aName ifAbsent: aBlock

	"Answer an object associated with given name."
	| index |
	index := pool at: aName ifAbsent: [ ^ aBlock value ].
	^ array at: index! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'CamilloBruni 7/23/2012 17:54'!
at: aName ifAbsentPut: aBlock

	^ self at: aName ifAbsent: [ self at: aName put: aBlock value ]! !

!NBExtraRootsRegistry methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 12:52'!
at: aName put: anObject

	"register an object under given name."
	| sz index |
	sz := array size.
	index := sz + 1.
	(pool includesKey: aName) 
		ifTrue: [	index := pool at: aName ]
		ifFalse: [ pool at: aName put: index ].
		
	(index > array size) ifTrue: [
		array := array copyWith: anObject.
		self primAtMem: cell put: array.
		].
	
	array at: index put: anObject.
	^ anObject.
	
! !

!NBExtraRootsRegistry methodsFor: 'callbacks support' stamp: 'Igor.Stasenko 5/18/2010 02:48'!
emitFetchCallback: index generator: gen
	"index are one, returned from #registerCallback "
	| reg temp |
	index isMem 
		ifTrue: [ temp := index ]
		ifFalse: [ temp := gen reserveTemp. gen asm mov: index to: temp ].
	pool at: #callbacks ifAbsent: [
		self at: #callbacks put: WeakArray new ].	
	reg := self emitOopAt: #callbacks generator: gen.
	reg := gen proxy fetchPointer: temp ofObject: reg.
	
	index isMem ifFalse: [ gen releaseTemps: 1 ].
	^ reg
! !

!NBExtraRootsRegistry methodsFor: 'code generation' stamp: 'Igor.Stasenko 5/1/2010 12:44'!
emitFetchClass: aClass generator: gen

	(self assert: aClass  isMeta not ).  " no metaclasses here"

	"make sure we registered it"
	self at: aClass name put: aClass.
	^ self emitOopAt: aClass name	generator: gen! !

!NBExtraRootsRegistry methodsFor: 'code generation' stamp: 'CamilloBruni 10/3/2012 14:42'!
emitOopAt: aName generator: gen

	"emit code for fetching an oop at given name from registry"
	
	| asm proxy index |
	
	proxy := gen proxy.
	asm := gen asm.
	index := pool at: aName.
	
	asm decorateWith: 'NBExtraRootsRegistry at: ', aName printString , ' (' , index asString , ')' during: [  
		asm mov: cell asUImm32 to: asm EAX.
		asm mov: asm EAX ptr to: asm EAX.  "array oop -> EAX"
	
		proxy fetchPointer: index-1 ofObject: asm EAX. ].
	"EAX <- oop"
	^ asm EAX! !

!NBExtraRootsRegistry methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 5/5/2010 13:46'!
initialize: aMemoryCell
	freeCallbackIndexes := OrderedCollection new.
	pool := IdentityDictionary new.
	array := Array new.
	
	cell := aMemoryCell asUnsignedLong. 
	
	self primAtMem: cell put: array.
	self primAddGCRoot: cell.
	
	self at: #'___seed' put: Seed.
	self assert: array size = 1.
	
! !

!NBExtraRootsRegistry methodsFor: 'primitives' stamp: 'IgorStasenko 11/24/2012 16:25'!
primAddGCRoot: addr

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	"add a given address as GC root"
	
	^ self nbCallout function: #(void ( ulong addr ) ) emit: [:gen |
		| proxy asm |
		proxy := gen proxy.
		asm := gen asm.
		
		asm 
			pop: asm EAX. "address"
			
		proxy addGCRoot: asm EAX.
	].
	
! !

!NBExtraRootsRegistry methodsFor: 'primitives' stamp: 'IgorStasenko 11/24/2012 16:25'!
primAtMem: addr put: anOop 

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	"write an oop to given memory address"
	
	^ self nbCallout function: #(void ( ulong addr, oop anOop )) emit: [:gen |
		| proxy asm |
		proxy := gen proxy.
		asm := gen asm.
		
		asm 
			pop: asm EAX; "address"
			pop: asm ECX; "oop"
			mov: asm ECX to: asm EAX ptr
	].
	
! !

!NBExtraRootsRegistry methodsFor: 'callbacks support' stamp: 'Igor.Stasenko 5/5/2010 21:09'!
registerCallback: aCallback
	"answer a zero-based index of registered callback "
	| index callbacks |
	
	callbacks := pool at: #callbacks ifAbsent: [
		self at: #callbacks put: (WeakArray with: aCallback).
		^ 0.
		].
	callbacks := array at: callbacks.
	freeCallbackIndexes ifEmpty: [
		
		callbacks := callbacks copyWith: aCallback.
		self at: #callbacks put: callbacks.
		^ callbacks size - 1
		].
	
	index := freeCallbackIndexes removeLast.
	callbacks at: index+1 put: aCallback.
	^ index
	! !

!NBExtraRootsRegistry methodsFor: 'callbacks support' stamp: 'Igor.Stasenko 5/14/2010 02:07'!
releaseCallbackIndex: anIndex
	| callbacks |
	"release a previously registered zero-based callback index"
	
	callbacks := self at: #callbacks ifAbsent: [^ self ].
	
	freeCallbackIndexes add: anIndex.
	callbacks at: anIndex+1 put: nil.! !

Object subclass: #NBFFICallback
	instanceVariableNames: 'trunk index enterMethod block'
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core-Objects'!

NBFFICallback class
	instanceVariableNames: 'session numArgs cbEnter cbLeave trunkCode'!

!NBFFICallback commentStamp: '<historical>' prior: 0!
My instances represent a callback function, which will be called by external function at some moment.

To create a new callback, first, make a subclass of me and override #fnSpec method, which is an anonymous C function signature, 
l.e.  'int (int foo , float bar )'  , which tells that given callback class implements a callback for a function which takes two arguments (foo, bar),
and returns integer.
(Additionally you can override a #callType method which determines a callback function calling convention. A default calling convention for callbacks is #cdecl,
and others is barely used on x86 platforms).

To use callbacks, you must instantiate it first by passing block as an argument:

mycallback := MyCallback on: someBlock.

The block is the closure which will be evaluated when callback function get called, so the block must take same number of arguments as specified in #fnSpec method, and its evaluation result must yield a value which can be converted back C type value, which you speficied as a return type of callback function.
For example, if callback signature is 'int (int foo , float bar )' , we can create a callback with following block closure:

mycallback := MyCallback on: [:foo :bar |  (foo + bar ) asInteger ]. 

Passing callback as an argument to external function. 

For passing a callbacks as an argument to C function, you can use its class name for an argument type.

For example:

primStQSort: base len: size compare: qsortCallback

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self 
		nbCall: #(void qsort (NBExternalAddress base, ulong size, 1, NBQSortCallback qsortCallback))
		module: NativeBoost CLibrary 
		options: #( optMayGC )

as you can see , the third argument (qsortCallback) of function signature, has 'NBQSortCallback' type, which is a class name of existing NBFFICallback subclass. 
And, of course you are free to create any type aliases for the callback type to use different type names in signature. Just make sure that aliases are resolved correctly to an instance of NBFFICallbackType, during processing of the function signature by NBFFICallout class.

!!!!Note!!!! A special care must be taken for all functions which may make callbacks!! 
In the above qsort() example, you can see an additional option for external call - #optMayGC, which tells a code generator to call an external function via call gate (a special stub which handling a code relocation caused by GC). Thats it, for any external functions, which may call the callback you must pass this option. 
Rationale: since most of external functions don't make any callbacks (and so has no chance to trigger GC), using this option by default will be an overkill, which will just spend extra CPU cycles for nothing. 
However, if you omit this option when calling the function(s) which may call back, expect a hard crash(es) to happen.   
If you unsure which external library functions may call back, you can turn on this option by default for all methods in your class by implementing  #ffiCalloutOptions method at class side:

MyClass class>>ffiCalloutOptions
 ^ #( optMayGC )

Like that, for any code generated to make external calls in methods of your class, this option will take an effect.

Callback lifetime. 

Each time you instantiating a new callback, it reserves a small amount of external memory , which must be freed once callback is no longer used.
This is done automatically, using object finalization scheme, once system detects that there is no more strong references to callback left.
So, you only need to make sure that an instance of callback, which you passed to some external function will be kept around in system, as long as
an external library has a pointer to it and can perform calls to it.  
If you lose the last reference to callback object before making sure that external library can no longer make calls to it, this will lead to an unpredictive behavior (segmentation fault, invalid instruction, memory corruption / pick your favorite).   

Redefining callback signature. 

A callback uses a lazy-initialization scheme to generate a common marshalling code which will be used by all instances of specific callback class.
So, changing a callback signature (by changing its #fnSpec method) will not have an immediate effect, if you already created at least a single instance of it. 
To make changes take effect, you must restart an image.
!

NBFFICallback class
	instanceVariableNames: 'session numArgs cbEnter cbLeave trunkCode'!

!NBFFICallback class methodsFor: 'callback spec' stamp: 'Igor.Stasenko 5/13/2010 23:33'!
asNBExternalType: gen
	^ NBFFICallbackType new callbackClass: self! !

!NBFFICallback class methodsFor: 'callback spec' stamp: 'IgorStasenko 9/15/2012 14:24'!
callType

	"Answer a callback function calling convention
	#cdecl or #stdcall
	"
	
	"By default, use cdecl convention"
	
	^ #cdecl! !

!NBFFICallback class methodsFor: 'accessing' stamp: 'IgorStasenko 5/8/2012 16:04'!
callbackEnterAddress

	self checkSession.
	
	cbEnter ifNil: [ self installCallbackCode ].
	
	^ cbEnter address

! !

!NBFFICallback class methodsFor: 'accessing' stamp: 'IgorStasenko 5/7/2012 13:47'!
callbackEnterMethod
	"do not override"
	^ NBFFICallback compiledMethodAt: #pvtEnter:stackPointer:primitiveMethod:  .! !

!NBFFICallback class methodsFor: 'accessing' stamp: 'IgorStasenko 5/8/2012 16:05'!
callbackLeaveAddress

	self checkSession.
	
	cbLeave ifNil: [ self installCallbackCode ].
	
	^ cbLeave address

! !

!NBFFICallback class methodsFor: 'private' stamp: 'IgorStasenko 5/8/2012 16:06'!
checkSession
	session == NativeBoost uniqueSessionObject ifFalse: [
		numArgs := cbEnter := cbLeave := trunkCode := nil.
		session := NativeBoost uniqueSessionObject.
	].

! !

!NBFFICallback class methodsFor: 'finalization' stamp: 'IgorStasenko 9/15/2012 14:18'!
finalizeResourceData: trunkAndIndex
	
	NativeBoost free: trunkAndIndex first.
	NativeBoost extraRootsRegistry releaseCallbackIndex: trunkAndIndex second.
! !

!NBFFICallback class methodsFor: 'callback spec' stamp: 'IgorStasenko 9/16/2012 17:20'!
fnSpec

	"answer an anonymous C function signature for a given callback,
	like #( long ( int a, int* b) )"

	self subclassResponsibility .
! !

!NBFFICallback class methodsFor: 'code generation' stamp: 'IgorStasenko 5/8/2012 16:53'!
installCallbackCode
	| enterCodeFn leaveCodeFn leaveOffset returnAddr |

		cbEnter := NBCallbackCodeGen new generateCallbackEnterCodeFor: self.
		cbEnter install.
		
		returnAddr := cbEnter address value + (cbEnter code offsetAt: #returnToC).
		cbLeave := NBCallbackCodeGen new generateCallbackLeaveCodeFor: self leaveAddr: returnAddr.
		
		cbLeave install.
! !

!NBFFICallback class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/13/2010 22:40'!
new
	self error: 'use #on: instead'.! !

!NBFFICallback class methodsFor: 'private' stamp: 'IgorStasenko 5/7/2012 13:40'!
numArgs: int

	numArgs := int! !

!NBFFICallback class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/11/2010 02:35'!
numberOfArguments

	^ numArgs! !

!NBFFICallback class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/13/2010 22:43'!
on: aBlock

	^ self basicNew initialize block: aBlock! !

!NBFFICallback class methodsFor: 'private' stamp: 'IgorStasenko 5/8/2012 16:06'!
reset 
	self checkSession.
	
	cbEnter ifNotNil: [
		
		cbEnter uninstall.
		cbLeave uninstall.
		numArgs := cbEnter := cbLeave := trunkCode := nil.
	].
! !

!NBFFICallback class methodsFor: 'accessing' stamp: 'IgorStasenko 5/8/2012 03:04'!
trunkCode
	self checkSession.

	^ trunkCode ifNil: [ | asm |
		asm := NativeBoost newAssembler noStackFrame.  "NO STACK FRAME, since we just jump to common entry point"

		asm
			mov: (0 asUImm32 label: (asm labelNamed: #index)) to: ECX; " callback index "
			mov: ((self callbackEnterAddress asUImm32) label: (asm labelNamed: #cbEnterAddress)) to: EAX;
			jmp: EAX.
		
		trunkCode := asm generatedCode.
	]
! !

!NBFFICallback methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/13/2010 22:38'!
block: aBlock

	self class numberOfArguments = aBlock numArgs ifFalse: [
		self error: 'Invalid number of arguments' ].
	
	block := aBlock! !

!NBFFICallback methodsFor: 'initialize-release' stamp: 'IgorStasenko 9/15/2012 20:07'!
initialize

	enterMethod := self class callbackEnterMethod.
	index := NativeBoost extraRootsRegistry registerCallback: self.
	self installTrunk.
	
	NBExternalResourceManager addResource: self data: {trunk. index }.! !

!NBFFICallback methodsFor: 'trunk management' stamp: 'IgorStasenko 11/24/2012 15:44'!
installTrunk
	| code bytes |
	code := self class trunkCode.
	bytes := code bytes.
	
	trunk := NativeBoost allocate: bytes size.
	NativeBoost memCopy: bytes to: trunk size: bytes size.
	
	trunk nbUInt32AtOffset: (code offsetAt: #index) put: index
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/15/2012 14:21'!
primLeave: leaveAddr stackPtr: saveStackPtr contextOop: senderContext 
	returnValue: oop primitiveMethod: aMethod
	"simply jump to the address, provided in leaveAddr parameter,
	which should be an unsigned integer value"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBNativeCodeGen methodAssembly: [:gen | | proxy asm |
		proxy := gen proxy.
		asm := gen asm.
		proxy stackValue: 4. "leaveAddr"
		proxy positive32BitValueOf: EAX.
		asm push: EAX.
		proxy ifFailedJumpTo: #failed.
		asm pop: EAX;
			jmp: EAX.  " jump to callback leave address "
		asm label: #failed.
		gen epilogue.
	]
! !

!NBFFICallback methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/8/2012 16:09'!
pvtEnter: arguments stackPointer: savedStackPtr primitiveMethod: aMethod
	"Note, this is for internal use only!!!!!! do not touch this method ever!! "
	| result theSender |
	result := 0.
	theSender := thisContext sender.
	[ 
	result := block valueWithArguments: arguments ]
	ensure: [
		self 
			primLeave: self class callbackLeaveAddress asUnsignedLong 
			stackPtr: savedStackPtr 
			contextOop: theSender 
			returnValue: result
			primitiveMethod: aMethod
		]
! !

NBFFICallback subclass: #NBQSortCallback
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Objects'!

!NBQSortCallback class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/8/2010 19:17'!
callType

	^ #cdecl! !

!NBQSortCallback class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/13/2010 22:54'!
fnSpec

	^ #(int ( NBExternalAddress a, NBExternalAddress b))! !

!NBQSortCallback methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 15:30'!
index
	^ index! !

!NBQSortCallback methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 15:30'!
trunk
	^ trunk! !

Object subclass: #NBFFICalloutAPI
	instanceVariableNames: 'context conv options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBFFICalloutAPI class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/22/2012 14:24'!
inContext: aContext
	^ self new context: aContext! !

!NBFFICalloutAPI methodsFor: 'call conventions' stamp: 'IgorStasenko 11/22/2012 18:11'!
cdecl
	conv := #cdecl! !

!NBFFICalloutAPI methodsFor: 'accessing' stamp: 'IgorStasenko 11/22/2012 14:23'!
context
	^ context! !

!NBFFICalloutAPI methodsFor: 'accessing' stamp: 'IgorStasenko 11/22/2012 14:23'!
context: anObject
	context := anObject! !

!NBFFICalloutAPI methodsFor: 'accessing' stamp: 'IgorStasenko 11/23/2012 13:56'!
convention: aCallConvention
	conv := aCallConvention ! !

!NBFFICalloutAPI methodsFor: 'action' stamp: 'IgorStasenko 11/25/2012 15:40'!
function: functionSignature address: fnAddressBlock

	^ NBFFICallout handleFailureIn: context nativeCode: [:gen |
			gen
				callType: conv;
				sender: context;
				parseOptions: options;
				anonSpec: functionSignature;
				generateCallToAddress: fnAddressBlock  
		]
! !

!NBFFICalloutAPI methodsFor: 'action' stamp: 'IgorStasenko 11/24/2012 22:38'!
function: functionSignature emit: aCallEmittingBlock

	^ NBFFICallout handleFailureIn: context nativeCode: [:gen |
			gen
				useEmitCall;
				callType: conv;
				sender: context;
				parseOptions: options;
				
				anonSpec: functionSignature;
				generate: aCallEmittingBlock  
		]
! !

!NBFFICalloutAPI methodsFor: 'action' stamp: 'IgorStasenko 11/24/2012 22:38'!
function: functionSignature module: moduleNameOrHandle

	^ NBFFICallout
		handleFailureIn: context nativeCode: [:gen |
			gen 
				callType: conv;
				sender: context;
				parseOptions: options;
				generateCall: functionSignature module: moduleNameOrHandle 
		]! !

!NBFFICalloutAPI methodsFor: 'initialize-release' stamp: 'IgorStasenko 11/22/2012 18:18'!
initialize
	conv := #cdecl.
	options := #().! !

!NBFFICalloutAPI methodsFor: 'options' stamp: 'IgorStasenko 11/22/2012 18:12'!
options: codeGenerationOptions
	options := codeGenerationOptions! !

!NBFFICalloutAPI methodsFor: 'call conventions' stamp: 'IgorStasenko 11/22/2012 18:11'!
stdcall
	conv := #stdcall! !

Object subclass: #NBFFIConst
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Types'!

!NBFFIConst commentStamp: 'Igor.Stasenko 5/3/2010 18:10' prior: 0!
My instances can be used to push an arbitrary integer value to the stack.
Could be useful for purposes, when some of the external function values is known beforehead,
like size of structure etc.

For emitting a constant as argument  for a function just put it into an argument list, like: 

apiCall: #( long 'IsBadWritePtr' (10) ) module: 'Kernel32.dll'

here, 10 is a constant, which will be pushed on stack!

!NBFFIConst class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 4/15/2010 22:18'!
value: aValue
	^ self new value: aValue! !

!NBFFIConst methodsFor: 'testing' stamp: 'IgorStasenko 5/11/2011 17:27'!
coercionMayFail
	"Constants are pushed as is, and there is no any coercion required, so it cannot fail anything"
	
	^ false! !

!NBFFIConst methodsFor: 'emitting code' stamp: 'Igor.Stasenko 4/15/2010 22:33'!
emitPush: gen

	gen asm push: ((gen asm imm: value) size: 4)! !

!NBFFIConst methodsFor: 'testing' stamp: 'Igor.Stasenko 5/3/2010 00:53'!
isCallback
	^ false! !

!NBFFIConst methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/18/2010 23:07'!
loader
	^ self! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 11:46'!
pointerArity: ptrArity

	ptrArity > 0 ifTrue: [ self error: 'passing pointer to constant' ]! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/28/2010 13:54'!
prepareArgumentUsing: gen

	"do nothing"! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/26/2010 03:21'!
prepareUsing: gen
	"do nothing"
	^ self! !

!NBFFIConst methodsFor: 'accessing' stamp: 'IgorStasenko 8/2/2011 14:39'!
stackSize
	^ 4! !

!NBFFIConst methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 23:08'!
usesSTStack
	"Test, whether a receiver using an ST method's argument
	for converting it into a corresponding C value for pushing on stack
	"
	^ false! !

!NBFFIConst methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/15/2010 22:17'!
value
	^ value! !

!NBFFIConst methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/15/2010 22:17'!
value: aValue
	value := aValue! !

Object subclass: #NBFinalizationRegistry
	instanceVariableNames: 'list items nextFreeIndex sema'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBFinalizationRegistry commentStamp: '<historical>' prior: 0!
i am a simplified implementation of WeakRegistry,
and have same public protocol.

The implementation is simpler and faster, because i rely on new finalization support in VM.
!

!NBFinalizationRegistry methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 02:59'!
add: anObject
	^ self add: anObject executor: anObject executor! !

!NBFinalizationRegistry methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 14:55'!
add: anObject executor: executor
	| item |
	
	"fool protection"
	anObject ifNil: [ self error: 'nil cannot be finalized!!!!'].
	
	sema critical: [
		item := self getFreeItem.
		item object: anObject executor: executor
	].
	^ item! !

!NBFinalizationRegistry methodsFor: 'finalizing' stamp: 'IgorStasenko 8/24/2012 17:17'!
finalizeValues 
	"Finalize any values, which happen to be stocked in finalization list, due to some weak references become garbage"
	
	sema critical: [ | item next |
		item := list swapWithNil.
		[ item notNil ]	whileTrue: [
			next := item next.
			[ item finalizeValues ] on: Exception fork: [:ex | ex pass ].
			
			item markAsFree: nextFreeIndex.
			nextFreeIndex := item index.
			item := next.
		]
	].
! !

!NBFinalizationRegistry methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 03:57'!
formatItems: startingIndex

	startingIndex to: items size do: [:i | | item |
		item := 
			NBWeakFinalizerItem new
				list: list index: i freeIndex: nextFreeIndex.
		items at: i put: item.
		nextFreeIndex := i.
	].! !

!NBFinalizationRegistry methodsFor: 'for tests only' stamp: 'IgorStasenko 5/31/2012 14:44'!
freeItemsDo: aBlock

	| free index |
	sema critical: [
		index := nextFreeIndex.
		
		[ index notNil ] whileTrue: [  |next item|
			item := items at: index.
			next := item nextFreeIndex.
			aBlock value: item.
			index := next
		]]! !

!NBFinalizationRegistry methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 03:58'!
getFreeItem
	| item nextFree |
	nextFreeIndex ifNil: [ self grow ].
	item := items at: nextFreeIndex.
	nextFreeIndex := item nextFreeIndex.
	^ item! !

!NBFinalizationRegistry methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 03:55'!
grow
	"double the items array size"
	| oldSz |
	oldSz := items size.
	items := items grownBy: oldSz.
	
	self formatItems: oldSz+1
	! !

!NBFinalizationRegistry methodsFor: 'accessing' stamp: 'IgorStasenko 5/31/2012 02:56'!
initialSize
	^ 100! !

!NBFinalizationRegistry methodsFor: 'initialize-release' stamp: 'IgorStasenko 5/31/2012 14:51'!
initialize
	super initialize.
	sema := Semaphore forMutualExclusion.
	self reset.
	WeakArray addWeakDependent: self! !

!NBFinalizationRegistry methodsFor: 'for tests only' stamp: 'IgorStasenko 5/31/2012 14:41'!
items
	^ items! !

!NBFinalizationRegistry methodsFor: 'private' stamp: 'IgorStasenko 5/31/2012 14:24'!
reset
	sema critical: [
		nextFreeIndex := nil.
		list := WeakFinalizationList new.
		items := Array new: self initialSize.
		self formatItems: 1.
	]
	
	! !

Object subclass: #NBFnArgument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBFnArgument commentStamp: 'Igor.Stasenko 4/30/2010 12:12' prior: 0!
I am abstract class, describing a function argument.
My subclasses should know what code to emit in order to load an argument.
!

!NBFnArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 10:46'!
emitLoad: gen
	"emit instructions to load a function argument into default register
	(EAX for integral types, FP(0) for floating point)"
	
	self subclassResponsibility ! !

!NBFnArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 12:21'!
emitLoad: gen to: operand
	"emit instructions to load a function argument into given operand"
	
	self subclassResponsibility ! !

!NBFnArgument methodsFor: 'testing' stamp: 'IgorStasenko 8/5/2011 18:02'!
isReceiver 
	"answer true if loader loads a primitive method's receiver "
	^ false! !

!NBFnArgument methodsFor: 'testing' stamp: 'Igor.Stasenko 5/18/2010 02:21'!
usesSTStack
	^ false! !

NBFnArgument subclass: #NBNativeFunctionArgument
	instanceVariableNames: 'name offset type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBNativeFunctionArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 18:58'!
name
	^ name! !

!NBNativeFunctionArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/3/2010 18:58'!
name: aName
	name := aName! !

!NBNativeFunctionArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
offset

	^offset! !

!NBNativeFunctionArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
offset: anObject

	offset := anObject! !

!NBNativeFunctionArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
type

	^type! !

!NBNativeFunctionArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 19:13'!
type: anObject

	type := anObject! !

NBFnArgument subclass: #NBSTIndirectArgument
	instanceVariableNames: 'argumentLoader elementIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/24/2012 20:34'!
argumentLoader
	^ argumentLoader! !

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/24/2012 20:34'!
argumentLoader: anObject
	argumentLoader := anObject! !

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/24/2012 20:34'!
elementIndex
	^ elementIndex! !

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/24/2012 20:34'!
elementIndex: anObject
	elementIndex := anObject! !

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/27/2012 12:34'!
emitLoad: gen
	| asm |
	asm := gen asm.
	argumentLoader emitLoad: gen to: asm EAX.
	gen optCheckIndirectArgBounds
		ifTrue: [ 
			| typeOk boundsFailed endLabel oop |
			typeOk := asm uniqueLabelName: 'typeOk'.
			boundsFailed := asm uniqueLabelName: 'boundsFailed'.
			endLabel := asm uniqueLabelName: 'end'.
			oop := gen reserveTemp.
			asm mov: asm EAX to: oop.	
			"type checking"
			gen proxy isPointers: oop.
			asm cmp: asm EAX with: 0 asImm.
			asm jne: typeOk.
			gen failWithMessage: 'Type checking failed on indirect argument loading'.
			asm label: typeOk.
			"bounds checking"
			"bigger than 0"
			asm mov: elementIndex asImm to: asm EAX.
			asm cmp: asm EAX with: 0 asImm.
			asm jle: boundsFailed.
			"smaller than slot size"
			gen proxy slotSizeOf: oop.
			asm cmp: asm EAX with: elementIndex asImm.
			asm jl: boundsFailed.
			asm mov: oop to: asm EAX.
			asm jmp: endLabel .
			asm label: boundsFailed.
			gen failWithMessage: 'Bound checking failed on indirect argument loading'.
			asm label: endLabel .
			 ].
	gen proxy fetchPointer: elementIndex - 1 ofObject: asm EAX.
	^ asm EAX! !

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/24/2012 20:34'!
emitLoad: gen to: operand
	self emitLoad: gen.
	operand = gen asm EAX ifFalse:[gen asm mov: gen asm EAX to: operand]! !

!NBSTIndirectArgument methodsFor: 'accessing' stamp: 'cipt 10/24/2012 20:39'!
usesSTStack
	^ argumentLoader usesSTStack! !

NBFnArgument subclass: #NBSTIvarArgument
	instanceVariableNames: 'receiverClass ivarName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBSTIvarArgument commentStamp: 'Igor.Stasenko 4/30/2010 12:24' prior: 0!
This guy knows how to load a receiver's ivar.

!

!NBSTIvarArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 14:33'!
emitLoad: gen
	"emit instructions to load a function argument into default register
	(EAX for integral types, FP(0) for floating point)"

	| index |
	index := receiverClass allInstVarNames indexOf: ivarName.
	
	gen receiverArgumentLoader emitLoad: gen to: gen asm EAX.
	
	"receiver in EAX"
	gen proxy fetchPointer: index-1 ofObject: gen asm EAX.
	
	^ gen asm EAX! !

!NBSTIvarArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/30/2010 12:29'!
emitLoad: gen to: operand
	"emit instructions to load a function argument into given operand"
	
	self emitLoad: gen.
	
	operand = gen asm EAX ifFalse: [ gen asm mov: gen asm EAX to: operand ]
! !

!NBSTIvarArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
ivarName

	^ivarName! !

!NBSTIvarArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
ivarName: anObject

	ivarName := anObject! !

!NBSTIvarArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
receiverClass

	^receiverClass! !

!NBSTIvarArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 12:24'!
receiverClass: anObject

	receiverClass := anObject! !

!NBSTIvarArgument methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/18/2010 02:22'!
usesSTStack
	^ true " to fetch receiver we accessing the stack"! !

NBFnArgument subclass: #NBSTMethodArgument
	instanceVariableNames: 'stackIndex isReceiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBSTMethodArgument commentStamp: 'Igor.Stasenko 4/30/2010 10:47' prior: 0!
i know what to emit for loading a method's argument from VM stack into register
!

!NBSTMethodArgument class methodsFor: 'errors' stamp: 'IgorStasenko 8/6/2011 18:20'!
lastError
	<primitive: #primitiveLastNativeCodeError module: #NativeBoostPlugin>
	^ self error: 'NativeBoost plugin is missing?'! !

!NBSTMethodArgument methodsFor: 'emitting the code' stamp: 'Igor.Stasenko 4/30/2010 07:25'!
emitLoad: gen

	gen proxy stackValue: stackIndex.
	
	^ gen asm EAX! !

!NBSTMethodArgument methodsFor: 'emitting the code' stamp: 'Igor.Stasenko 4/30/2010 12:22'!
emitLoad: gen to: operand
	"emit instructions to load a function argument into given operand"
	
	gen proxy stackValue: stackIndex.
	
	operand = gen asm EAX ifFalse: [ gen asm mov: gen asm EAX to: operand ]
! !

!NBSTMethodArgument methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/5/2011 18:00'!
initialize 
	isReceiver := false! !

!NBSTMethodArgument methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2011 18:00'!
isReceiver 
	^ isReceiver ! !

!NBSTMethodArgument methodsFor: 'accessing' stamp: 'IgorStasenko 8/5/2011 18:00'!
isReceiver: aBool
	isReceiver := aBool ! !

!NBSTMethodArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 07:23'!
stackIndex

	^stackIndex! !

!NBSTMethodArgument methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 07:23'!
stackIndex: anObject

	stackIndex := anObject! !

!NBSTMethodArgument methodsFor: 'testing' stamp: 'Igor.Stasenko 5/18/2010 02:22'!
usesSTStack
	^ true " to fetch receiver we accessing the stack"! !

Object subclass: #NBFnSpec
	instanceVariableNames: 'returnType functionName arguments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBFnSpec commentStamp: 'IgorStasenko 2/15/2012 19:46' prior: 0!
I am used to hold a parsed function signature, describing a C function.
Since all C functions having return type, arguments and name (unless it anonymous one), 
same structure can be used to hold an information about it in my instances.
However, what objects used to represent types and arguments is up to code generator.

Instance Variables:
	returnType <Object>
	functionName	<String>
	arguments	<SequenceableCollection>!

!NBFnSpec class methodsFor: 'instance creation' stamp: 'IgorStasenko 8/21/2011 11:07'!
namedFunctionFrom: anArrayWithDefinition

	"Create an instance of receiver by parsing an array in a form like C function definition: 

	#( void foo (int * x, float y ) ) 
	"

	^ NBFnSpecParser new parseNamedFunction: anArrayWithDefinition ! !

!NBFnSpec methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/21/2011 02:49'!
addArgument: anArgument
	^ arguments add: anArgument! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
arguments

	^ arguments! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
arguments: anObject

	arguments := anObject! !

!NBFnSpec methodsFor: 'converting' stamp: 'IgorStasenko 8/21/2011 11:35'!
asArraySpec

	^ String streamContents: [:str | 

		str 
			nextPutAll: '#( '.
		
		self printType: returnType on: str.
		str space.
		
		functionName ifNotNil: [
			str nextPutAll: functionName; space ].
		
		str nextPutAll: '( '.
		
		arguments do: [:arg | 
			
			str nextPutAll: arg second. "type name"
			arg third timesRepeat: [
				str nextPut: $* ].
			str space;
				nextPutAll: arg first;
				space
		] separatedBy: [ str nextPutAll: ', ' ].
	
		str nextPutAll: '))'.
		
	]! !

!NBFnSpec methodsFor: 'converting' stamp: 'cipt 10/21/2012 19:33'!
asArraySpecArrayedArgs

	^ String streamContents: [:str | |idx|

		str 
			nextPutAll: '#( '.
		
		self printType: returnType on: str.
		str space.
		
		functionName ifNotNil: [
			str nextPutAll: functionName; space ].
		
		str nextPutAll: '( '.
		idx := 1.
		arguments do: [:arg | 
			
			str nextPutAll: arg second. "type name"
			arg third timesRepeat: [
				str nextPut: $* ].
			str space;
				nextPutAll: 'argsArray@', idx printString;
				space.
			idx := idx + 1.
		] separatedBy: [ str nextPutAll: ', ' ].
	
		str nextPutAll: '))'.
		
	]! !

!NBFnSpec methodsFor: 'converting' stamp: 'IgorStasenko 8/19/2011 19:01'!
asMethodSelectorAndArguments

	^ String streamContents: [:str | 

		str 
			nextPutAll: functionName.
			
		arguments isEmpty ifFalse: [
			arguments size = 1 ifFalse: [
				str
					nextPut: $_;
					nextPutAll: arguments first first.
				].
			str
				nextPut: $: ; space;
				nextPutAll: arguments first first.
				
			arguments allButFirst do: [:arg | 
				str 
					space;
					nextPutAll: arg first; 
					nextPut: $: ;
					space;
					nextPutAll: arg first				
				]
			]
	]! !

!NBFnSpec methodsFor: 'converting' stamp: 'cipt 10/21/2012 19:38'!
asMethodSelectorAndArrayOfArguments
	^ String
		streamContents: [ :str | 
			str
				nextPutAll: functionName;
				nextPutAll: ': argsArray';
				cr;
				nextPut: $".
			arguments do: [ :arg | str nextPutAll: arg first ] separatedBy: [ str nextPutAll: ', ' ].
			str nextPut: $" ]! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
functionName

	^ functionName! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
functionName: anObject

	functionName := anObject! !

!NBFnSpec methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/19/2011 17:53'!
initialize
	arguments := OrderedCollection new! !

!NBFnSpec methodsFor: 'converting' stamp: 'IgorStasenko 8/19/2011 18:39'!
printType: typeAndArity on: str

	str nextPutAll: typeAndArity first.
	typeAndArity second timesRepeat: [ str nextPut: $* ].
! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
returnType

	^ returnType! !

!NBFnSpec methodsFor: 'accessing' stamp: 'IgorStasenko 8/19/2011 17:44'!
returnType: anObject

	returnType := anObject! !

Object subclass: #NBFnSpecParser
	instanceVariableNames: 'requestor stream fnSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBFnSpecParser methodsFor: 'requestor callbacks' stamp: 'cipt 10/24/2012 20:19'!
argName: aName indirectIndex: anIndex type: aTypeName ptrArity: arity
	
	^ { aName. anIndex. aTypeName. arity }! !

!NBFnSpecParser methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/21/2011 02:50'!
initialize
	requestor := self. ! !

!NBFnSpecParser methodsFor: 'requestor callbacks' stamp: 'IgorStasenko 8/21/2011 10:57'!
integerConstantArgument: aValue
	^ aValue! !

!NBFnSpecParser methodsFor: 'public interface' stamp: 'IgorStasenko 2/9/2012 12:42'!
parseAnonFunction: aFunctionDefinition

"
Parse a function definition in a form of: 

#( returnType (arguments) )
or

'returnType (arguments)'


Answer an instance of NBFnSpec class
"
	| argsSpec retType |
	
	fnSpec := NBFnSpec new.
	
	aFunctionDefinition isString ifTrue: [

		retType :=  (aFunctionDefinition copyUpTo: $( ) trimBoth.
		argsSpec := ((aFunctionDefinition copyAfter: $( ) copyUpTo: $)) trimBoth.
	
	] ifFalse: [

		argsSpec := aFunctionDefinition last gather: [:ea | ea asString, ' ' ].
		retType := aFunctionDefinition allButLast  gather: [:ea | ea asString, ' ' ].
	].
	
	stream := retType readStream.
	fnSpec returnType: (requestor returnType: self parseType).

	stream atEnd ifFalse: [ self error: 'Nothing more expected after function type'].	
	
	stream := argsSpec readStream.
	self parseArguments.

	^ fnSpec! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'cipt 10/26/2012 19:21'!
parseArgument
	| argName indirectIndex typeAndPtrArity char |
	" An argument can be:

 - nil , true , false
 - a class/pool variable name
 - integer literal

 - self , with optional **
 - type name *** arg name

"
	char := stream peek.
	(char isDigit or: [ char = $- ])
		ifTrue: [ ^ requestor integerConstantArgument: self parseInt ].
	typeAndPtrArity := self parseType.
	self skipSpace.
	argName := self parseWord.
	self skipSpace.
	char := stream peek.
	char = $@
		ifTrue: [ 
			stream next.
			self skipSpace.
			argName := argName.
			indirectIndex := self parseInt ].	
	"for sole 'void' fake argument "
	(typeAndPtrArity = #('void' 0) and: [ argName isNil ])
		ifTrue: [ ^ nil ].
	^ requestor
		argName: argName
		indirectIndex: indirectIndex
		type: typeAndPtrArity first
		ptrArity: typeAndPtrArity second ! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'IgorStasenko 12/18/2011 19:28'!
parseArguments
"
Parse a arguments spec in a form of: 

#( type1 name1 , type2 name2 , nil, true, false , 100 )
"
	[ stream atEnd ] whileFalse: [
		self parseArgument ifNotNil: [:arg | 
			fnSpec addArgument: arg].
		
		self skipSpace.
		
		stream atEnd ifFalse: [ stream peek = $, ifFalse: [ self error: 'comma expected' ].
			stream next. self skipSpace. ]
	].! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'Igor.Stasenko 4/30/2010 06:03'!
parseInt

	| negate num |

	negate := false.
	stream peek = $- ifTrue: [ negate := true. stream next.  self skipSpace ].

	num := String new writeStream.	
	[ stream atEnd not and: [stream peek isDigit ] ] whileTrue: [ num nextPut: stream next ].

	num := num contents asInteger.
	negate ifTrue: [ num := num negated ].
	
	^ num! !

!NBFnSpecParser methodsFor: 'public interface' stamp: 'IgorStasenko 2/9/2012 12:47'!
parseNamedFunction: aFunctionDefinition

"
Parse a function definition in a form of: 

#( returnType functionName (arguments) )
or

'returnType functionName (arguments)'


Answer an instance of NBFnSpec class
"
	| argsSpec typeAndName fnName |
	
	fnSpec := NBFnSpec new.
	
	aFunctionDefinition isString ifTrue: [

		typeAndName :=  (aFunctionDefinition copyUpTo: $( ) trimBoth.
		argsSpec := ((aFunctionDefinition copyAfter: $( ) copyUpTo: $)) trimBoth.
	
	] ifFalse: [

		argsSpec := aFunctionDefinition last gather: [:ea | ea asString, ' ' ].
		typeAndName := aFunctionDefinition allButLast  gather: [:ea | ea asString, ' ' ].
	].
	
	stream := typeAndName readStream.
	fnSpec returnType: (requestor returnType: self parseType).
	
	fnName := self parseWord.
	fnName ifNil: [ self error: 'function name expected' ].

	fnSpec functionName: fnName.
	
	stream := argsSpec readStream.
	self parseArguments.

	^ fnSpec! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'IgorStasenko 8/19/2011 17:59'!
parseType
	" parse type name and optional number of asterisks, following it"
	| typeName ptrArity |

	typeName := self parseWord.
	typeName isNil ifTrue: [ ^ self error: 'type name expected' ].

	"skip 'const' , which is often used but has no any use for us "
	
	typeName = 'const' ifTrue: [
		self skipSpace.
		typeName := self parseWord.
		typeName isNil ifTrue: [ ^ self error: 'type name expected' ].
	].
	
	ptrArity := 0.
	[ self skipSpace. stream peek = $* ] whileTrue: [ 
		ptrArity := ptrArity + 1.
		stream next ].

	^ Array with: typeName with: ptrArity

! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'IgorStasenko 6/1/2012 18:37'!
parseWord

	^ String streamContents: [:st |  | ch |
	
		"first char must be letter or underscore"
		ch := stream peek.	
		(ch notNil and: [ ch isLetter or: [ '_$' includes: ch ]]) ifFalse: [ ^ nil ].
		
		[ ch := stream peek. ch notNil and: [ch isLetter or: [ ('_$' includes: ch)  or: [ch isDigit] ] ] ] 
				whileTrue: [ st nextPut: stream next].
	]

! !

!NBFnSpecParser methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 05:31'!
requestor: aRequestor

	requestor := aRequestor.! !

!NBFnSpecParser methodsFor: 'requestor callbacks' stamp: 'IgorStasenko 8/21/2011 10:55'!
returnType: aType

	
	^ aType! !

!NBFnSpecParser methodsFor: 'parsing' stamp: 'cipt 10/21/2012 01:27'!
skipSpace
	| ch |
	[ 
	ch := stream peek.
	ch ifNil: [ ^ self ].
	ch isSeparator ] whileTrue: [ stream next ]! !

Object subclass: #NBInterpreterProxy
	instanceVariableNames: 'gen asm objectFormat usedGate stackPtrAddress framePtrAddress cStackPtrAddress cFramePtrAddress'
	classVariableNames: 'CogFunctions Functions'
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core'!

!NBInterpreterProxy commentStamp: '<historical>' prior: 0!
I am an important part of a native code generation toolchain, which provides an access to all interpreterProxy functions.

A native code, inevitably, needs to convert a method's arguments to their native representations, and access a different fields of oops. For this, we need to use interpreter proxy methods.

Code generator options, used by proxy: 

	#optNonMovable
		- The code is a standalone routine, which 
		a) will be placed into a non-movable memory region.
		b) can be called by any other function, not by primitiveNativeCall, therefore
	
	#optDirectProxyFnAddress
		- call proxy functions directly, instead of loading 
		their address indirectly via interpreterProxy struct

	 #optUseStackPointer 
		- use a direct ST stack pointer, initially retrieved using #getStackPointer
!

NBInterpreterProxy subclass: #NBCogInterpreterProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core'!

!NBCogInterpreterProxy commentStamp: '<historical>' prior: 0!
I am a specialized interpreter proxy for the Cog family of intererpreters!

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'CamilloBruni 7/18/2012 14:41'!
CogProxyFunctionsData

	"taken from sqVirtualMachine.h"
	^ #(
		#minorVersion (void)
		#majorVersion (void)

		" InterpreterProxy methodsFor: 'stack access' "
		#pop: (sqInt)
		#pop:thenPush: (sqInt sqInt)
		#push: (sqInt)
		#pushBool: (sqInt)
		#pushFloat: (double)
		#pushInteger: (sqInt)
		#stackFloatValue: (sqInt )
		#stackIntegerValue: (sqInt)
		#stackObjectValue: (sqInt)
		#stackValue: (sqInt)

		" InterpreterProxy methodsFor: 'object access'  "
		#argumentCountOf: (sqInt)
		#arrayValueOf: (sqInt)
		#byteSizeOf: (sqInt)
		#fetchArray:ofObject: (sqInt sqInt)
		#fetchClassOf: (sqInt)
		#fetchFloat:ofObject: (sqInt sqInt)
		#fetchInteger:ofObject: (sqInt sqInt)
		#fetchPointer:ofObject: (sqInt sqInt)
		#obsoleteDontUseThisFetchWord:ofObject: (sqInt sqInt)
		#firstFixedField: (sqInt)
		#firstIndexableField: (sqInt)
		#literal:ofMethod: (sqInt  sqInt)
		#literalCountOf: (sqInt )
		#methodArgumentCount (void)
		#methodPrimitiveIndex (void)
		#primitiveIndexOf: (sqInt )
		#sizeOfSTArrayFromCPrimitive: (voidPtr)
		#slotSizeOf: (sqInt )
		#stObject:at: (sqInt   sqInt )
		#stObject:at:put: (sqInt   sqInt   sqInt)
		#stSizeOf: (sqInt)
		#storeInteger:ofObject:withValue: (sqInt   sqInt   sqInt )
		#storePointer:ofObject:withValue: (sqInt   sqInt   sqInt )

		" InterpreterProxy methodsFor: 'testing' "

		#is:KindOf: (sqInt   charPtr)
		#is:MemberOf: (sqInt charPtr)
		#isBytes: (sqInt )
		#isFloatObject: (sqInt )
		#isIndexable: (sqInt )
		#isIntegerObject: (sqInt )
		#isIntegerValue: (sqInt )
		#isPointers: (sqInt )
		#isWeak: (sqInt )
		#isWords: (sqInt )
		#isWordsOrBytes: (sqInt )

		" InterpreterProxy methodsFor: 'converting' "

		#booleanValueOf: (sqInt )
		#checkedIntegerValueOf: (sqInt )
		#floatObjectOf: (double )
		#floatValueOf: (sqInt )
		#integerObjectOf: (sqInt )
		#integerValueOf: (sqInt )
		#positive32BitIntegerFor: (sqInt )
		#positive32BitValueOf: (sqInt )

		" InterpreterProxy methodsFor: 'special objects' "

		#characterTable (void)
		#displayObject (void)
		#falseObject (void)
		#nilObject (void)
		#trueObject (void)

		" InterpreterProxy methodsFor: 'special classes' "

		#classArray (void)
		#classBitmap (void)
		#classByteArray (void)
		#classCharacter (void)
		#classFloat (void)
		#classLargePositiveInteger (void)
		#classPoint (void)
		#classSemaphore (void)
		#classSmallInteger (void)
		#classString (void)

		" InterpreterProxy methodsFor: 'instance creation' "

		#clone: (sqInt )
		#instantiateClass:indexableSize: (sqInt   sqInt )
		#makePointwithxValue:yValue: (sqInt   sqInt )
		#popRemappableOop (void)
		#pushRemappableOop: (sqInt )

		" InterpreterProxy methodsFor: 'other' "

		#become:with: (sqInt   sqInt )
		#byteSwapped: (sqInt)
		#failed (void)
		#fullDisplayUpdate (void)
		#fullGC (void)
		#incrementalGC (void)
		#primitiveFail (void)
		#showDisplayBits:Left:Top:Right:Bottom: (sqInt   sqInt  sqInt  sqInt  sqInt)
		#signalSemaphoreWithIndex: (sqInt)
		#success: (sqInt )
		#superclassOf: (sqInt )

		" InterpreterProxy methodsFor: 'compiler' "

		#compilerHookVector (void)
		#setCompilerInitialized: (sqInt )

		" VM_PROXY_MINOR > 1 "
		2
		" InterpreterProxy methodsFor: 'BitBlt support' "

		#loadBitBltFrom: (sqInt )
		#copyBits (void)
		#copyBitsFrom:to:at: (sqInt   sqInt   sqInt )

		" VM_PROXY_MINOR > 2 "
		3
		#classLargeNegativeInteger (void)
		#signed32BitIntegerFor: (sqInt )
		#signed32BitValueOf: (sqInt )
		#includesBehavior:ThatOf: (sqInt   sqInt )
		#primitiveMethod (void)

		" InterpreterProxy methodsFor: 'FFI support' "
		#classExternalAddress (void)
		#classExternalData (void)
		#classExternalFunction (void)
		#classExternalLibrary (void)
		#classExternalStructure (void)
		#ioLoadModule:OfLength: (sqInt sqInt)
		#ioLoadSymbol:OfLength:FromModule: (sqInt   sqInt   sqInt )
		#isInMemory: (sqInt )

		" VM_PROXY_MINOR > 3 "
		4
		#ioLoadFunction:From: (charPtr charPtr)
		#ioMicroMSecs (void)

		" VM_PROXY_MINOR > 4 "
		5
		#positive64BitIntegerFor: (sqLong)
		#positive64BitValueOf: (sqInt)
		#signed64BitIntegerFor: (sqLong)
		#signed64BitValueOf: (sqInt)

		" VM_PROXY_MINOR > 5 "
		6
		#isArray: (sqInt )
		#forceInterruptCheck (void)


		" VM_PROXY_MINOR > 6 "
		7
		#fetchLong32:ofObject: (sqInt  sqInt)
		#getThisSessionID (void)
		#ioFilename:fromString:ofLength:resolveAliases: (charPtr charPtr sqInt sqInt)
		#vmEndianness (void)

		8
		" New methods for proxy version 1.8 "
			
		callbackEnter: (sqIntPtr)
		callbackLeave: (sqInt)
		addGCRoot: (sqIntPtr)
		removeGCRoot: (sqIntPtr)

		9

		primitiveFailFor: (sqInt code)
		setInterruptCheckChain: (void * aFunction )

		classAlien (void)
		classUnsafeAlien (void)
		sendInvokeCallback:Stack:Registers:Jmpbuf: (sqInt thunkPtrAsInt, sqInt stackPtrAsInt, sqInt regsPtrAsInt, sqInt jmpBufPtrAsInt)
		reestablishContextPriorToCallback: (sqInt callbackContext)
		getStackPointer (void)
		internalIsImmutable: (sqInt oop)
		internalIsMutable: (sqInt oop)

		10
		methodArg:  (sqInt index)
		objectArg:  (sqInt index)
		integerArg: (sqInt index)
		floatArg:   (sqInt index)
		methodReturnValue: (sqInt oop)
		topRemappableOop  (void)

		11

		disownVM: (sqInt flags)
		ownVM:   (sqInt threadIdAndFlags)
		addHighPriorityTickee:period: (void ticker (void), unsigned periodms)
		addSynchronousTickee:period:round: (void ticker (void), unsigned periodms, unsigned roundms)
		utcMicroseconds (void)
		tenuringIncrementalGC (void)
		isYoung: (sqInt anOop)
		isKindOf:Class: (sqInt oop, sqInt aClass)
		primitiveErrorTable (void)
		primitiveFailureCode (void)
		instanceSizeOf: (sqInt aClass)
	)
! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'CamilloBruni 8/3/2012 18:26'!
cFramePointerAddress

	"to prevent recursion, we prohibit using stack pointer address when bootstrapping"
	NativeBoost forCurrentPlatform isBootstrapping ifTrue: [ ^ nil ].
	
	^ NativeBoost loadSymbol: #CFramePointer ! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'CamilloBruni 8/3/2012 18:26'!
cStackPointerAddress

	"to prevent recursion, we prohibit using stack pointer address when bootstrapping"
	NativeBoost forCurrentPlatform isBootstrapping ifTrue: [ ^ nil ].
	
	^ NativeBoost loadSymbol: #CStackPointer! !

!NBInterpreterProxy class methodsFor: 'options' stamp: 'Igor.Stasenko 5/19/2010 13:02'!
defaultOptions
	"Default options for proxy.
	Proxy options is applied before default options of generator,
	so generator can override them"

	^ #(
	"call proxy functions directly, instead of loading their address indirectly via interpreterProxy struct"
	#optDirectProxyFnAddress
		
	"use a direct ST stack pointer, initially retrieved using #getStackPointer"	
	 #optUseStackPointer 
	
	)
! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'Igor.Stasenko 5/3/2010 10:36'!
fnAddressAt: index
	"retrieve an interpreter proxy function address
	at given zero-based index.
	
	(self functions at: #minorVersion) address
	"
	index isString ifTrue: [ ^ self fnAddressAt: (self functions at: index) index ].
	^ NativeBoost ulongAt: self interpreterProxyAddress + (4 * index)
	! !

!NBInterpreterProxy class methodsFor: 'debugging' stamp: 'Igor.Stasenko 4/16/2010 03:31'!
fnSelectorAt: offset
" NBInterpreterProxy fnSelectorAt: 16r130 "
	^ (self functionAtOffset: offset) selector! !

!NBInterpreterProxy class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/1/2010 11:46'!
forGenerator: aNativeCodeGenerator

	^ self basicNew initialize generator: aNativeCodeGenerator! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'CamilloBruni 8/3/2012 17:21'!
framePointerAddress

	"to prevent recursion, we prohibit using stack pointer address when bootstrapping"
	NativeBoost forCurrentPlatform isBootstrapping ifTrue: [ ^ nil ].
	
	^ self primFramePointerAddress ! !

!NBInterpreterProxy class methodsFor: 'debugging' stamp: 'Igor.Stasenko 9/29/2010 09:26'!
functionAtOffset: offset
	| index |
	index := offset / 4.
	^ self functions detect: [:fn | fn index = index ]
! !

!NBInterpreterProxy class methodsFor: 'accessing' stamp: 'IgorStasenko 11/23/2011 10:44'!
functions
	" choose a set of interprterProxy functions, depending on VM we're currently running on"
	^ (Smalltalk vm version beginsWith: 'Squeak') 
		ifTrue: [	Functions ]
		ifFalse: [ CogFunctions ]! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'Igor.Stasenko 9/29/2010 09:22'!
generateFunctions
	" self generateFunctions   "
	
	Functions := self generateFunctionsFrom: self proxyFunctionsData.

	"checked using compiler on 32bits"
	self assert: (Functions at: #vmEndianness) index * 4 = 456.
	
	CogFunctions := self generateFunctionsFrom: self CogProxyFunctionsData.! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/3/2011 07:36'!
generateFunctionsFrom: data
	| i stream minorV functions |
	
	functions := IdentityDictionary new.
	
	i := 0.
	stream := data readStream.
	minorV := 0.
	[ stream atEnd ] whileFalse: [ | val |
		val := stream next.
		val isInteger ifTrue: [ minorV := val ]
			ifFalse: [
				(functions includesKey: val) ifTrue: [ self error: 'duplicated function!!!!' ].
				functions at: val put: (
					NBProxyFunction new selector: val; parseArguments: stream next; index: i; 
					majorVersion: 1; minorVersion: minorV;	requiresAlignment: (self safeNoAlignFunctions includes: val) not; yourself ).
				i := i + 1. ]
	].
	^ functions! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'IgorStasenko 8/3/2011 09:08'!
initialize
	"self initialize"
	self generateFunctions! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'Igor.Stasenko 5/2/2010 08:34'!
interpreterProxyAddress

	<primitive: #primitiveGetInterpreterProxy module: #NativeBoostPlugin> 

	^ self primitiveFailed! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 11/24/2012 17:19'!
majorVersion
	"retrieve an interpreter proxy structure major version value"

	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout
		options: #(
			"do not use interpreterProxy address directly"
			 - optDirectProxyFnAddress 
			"do not align stack for FFI call"
			+ optNoAlignment );
			 
		function: #(short ()) emit: [:gen | 
			gen proxy majorVersion
		] ! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 11/24/2012 17:19'!
minorVersion
	"retrieve an interpreter proxy structure minor version value"

	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout
		options: #(
			"do not use interpreterProxy address directly"
			 - optDirectProxyFnAddress 
			"do not align stack for FFI call"
			+ optNoAlignment ); 
		function: #(short ()) emit: [:gen | 
			gen proxy minorVersion
		] ! !

!NBInterpreterProxy class methodsFor: 'instance creation' stamp: 'Igor.Stasenko 5/1/2010 11:46'!
new
	self error: 'Use #forGenerator: '! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 11/24/2012 17:20'!
primFramePointerAddress
	"retrieve a stack pointer address"

	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin' error: errorCode>

	^ self nbCallout function: #(uint ()) emit: [:gen :proxy :asm | | fn | 
			fn :=  [ (NativeBoost forCurrentPlatform 
						loadSymbol: 'framePointerAddress' fromModule: '') ] ifError: [ nil ].
			fn ifNil: [ ^ nil ]. "just for safety" 

			asm 
				mov: fn asUImm32 to: asm EAX;			
				call: EAX.
		].! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 2/8/2013 12:59'!
primStackPointerAddress
	"retrieve a stack pointer address"

	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin' error: errorCode>

	^ self nbCallout function: #(uint ()) emit: [:gen :proxy :asm | | fn | 
			fn :=  [ (NativeBoost loadSymbol: 'stackPointerAddress' fromModule: NativeBoost VMModule) ] ifError: [ nil ].
			fn ifNil: [ ^ nil ]. "just for safety" 

			asm 
				mov: fn asUImm32 to: asm EAX;			
				call: EAX.
		].! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'CamilloBruni 7/19/2012 11:54'!
proxyFunctionsData

	"taken from sqVirtualMachine.h"
	^ #(
		#minorVersion (void)
		#majorVersion (void)

		" InterpreterProxy methodsFor: 'stack access' "
		#pop: (sqInt)
		#pop:thenPush: (sqInt sqInt)
		#push: (sqInt)
		#pushBool: (sqInt)
		#pushFloat: (double)
		#pushInteger: (sqInt)
		#stackFloatValue: (sqInt )
		#stackIntegerValue: (sqInt)
		#stackObjectValue: (sqInt)
		#stackValue: (sqInt)

		" InterpreterProxy methodsFor: 'object access'  "

		#argumentCountOf: (sqInt)
		#arrayValueOf: (sqInt)
		#byteSizeOf: (sqInt)
		#fetchArray:ofObject: (sqInt sqInt)
		#fetchClassOf: (sqInt)
		#fetchFloat:ofObject: (sqInt sqInt)
		#fetchInteger:ofObject: (sqInt sqInt)
		#fetchPointer:ofObject: (sqInt sqInt)
		#obsoleteDontUseThisFetchWord:ofObject: (sqInt sqInt)
		#firstFixedField: (sqInt)
		#firstIndexableField: (sqInt)
		#literal:ofMethod: (sqInt  sqInt)
		#literalCountOf: (sqInt )
		#methodArgumentCount (void)
		#methodPrimitiveIndex (void)
		#primitiveIndexOf: (sqInt )
		#sizeOfSTArrayFromCPrimitive: (voidPtr)
		#slotSizeOf: (sqInt )
		#stObject:at: (sqInt   sqInt )
		#stObject:at:put: (sqInt   sqInt   sqInt)
		#stSizeOf: (sqInt)
		#storeInteger:ofObject:withValue: (sqInt   sqInt   sqInt )
		#storePointer:ofObject:withValue: (sqInt   sqInt   sqInt )

		" InterpreterProxy methodsFor: 'testing' "

		#is:KindOf: (sqInt   charPtr)
		#is:MemberOf: (sqInt charPtr)
		#isBytes: (sqInt )
		#isFloatObject: (sqInt )
		#isIndexable: (sqInt )
		#isIntegerObject: (sqInt )
		#isIntegerValue: (sqInt )
		#isPointers: (sqInt )
		#isWeak: (sqInt )
		#isWords: (sqInt )
		#isWordsOrBytes: (sqInt )

		" InterpreterProxy methodsFor: 'converting' "

		#booleanValueOf: (sqInt )
		#checkedIntegerValueOf: (sqInt )
		#floatObjectOf: (double )
		#floatValueOf: (sqInt )
		#integerObjectOf: (sqInt )
		#integerValueOf: (sqInt )
		#positive32BitIntegerFor: (sqInt )
		#positive32BitValueOf: (sqInt )

		" InterpreterProxy methodsFor: 'special objects' "

		#characterTable (void)
		#displayObject (void)
		#falseObject (void)
		#nilObject (void)
		#trueObject (void)

		" InterpreterProxy methodsFor: 'special classes' "

		#classArray (void)
		#classBitmap (void)
		#classByteArray (void)
		#classCharacter (void)
		#classFloat (void)
		#classLargePositiveInteger (void)
		#classPoint (void)
		#classSemaphore (void)
		#classSmallInteger (void)
		#classString (void)

		" InterpreterProxy methodsFor: 'instance creation' "

		#clone: (sqInt )
		#instantiateClass:indexableSize: (sqInt   sqInt )
		#makePointwithxValue:yValue: (sqInt   sqInt )
		#popRemappableOop (void)
		#pushRemappableOop: (sqInt )

		" InterpreterProxy methodsFor: 'other' "

		#become:with: (sqInt   sqInt )
		#byteSwapped: (sqInt)
		#failed (void)
		#fullDisplayUpdate (void)
		#fullGC (void)
		#incrementalGC (void)
		#primitiveFail (void)
		#showDisplayBits:Left:Top:Right:Bottom: (sqInt   sqInt  sqInt  sqInt  sqInt)
		#signalSemaphoreWithIndex: (sqInt)
		#success: (sqInt )
		#superclassOf: (sqInt )

		" InterpreterProxy methodsFor: 'compiler' "

		#compilerHookVector (void)
		#setCompilerInitialized: (sqInt )

		" VM_PROXY_MINOR > 1 "
		2
		" InterpreterProxy methodsFor: 'BitBlt support' "

		#loadBitBltFrom: (sqInt )
		#copyBits (void)
		#copyBitsFrom:to:at: (sqInt   sqInt   sqInt )

		" VM_PROXY_MINOR > 2 "
		3
		#classLargeNegativeInteger (void)
		#signed32BitIntegerFor: (sqInt )
		#signed32BitValueOf: (sqInt )
		#includesBehavior:ThatOf: (sqInt   sqInt )
		#primitiveMethod (void)

		" InterpreterProxy methodsFor: 'FFI support' "

		#classExternalAddress (void)
		#classExternalData (void)
		#classExternalFunction (void)
		#classExternalLibrary (void)
		#classExternalStructure (void)
		#ioLoadModule:OfLength: (sqInt sqInt)
		#ioLoadSymbol:OfLength:FromModule: (sqInt   sqInt   sqInt )
		#isInMemory: (sqInt )

		" VM_PROXY_MINOR > 3 "
		4
		#ioLoadFunction:From: (charPtr charPtr)
		#ioMicroMSecs (void)

		" VM_PROXY_MINOR > 4 "
		5
		#positive64BitIntegerFor: (sqLong)
		#positive64BitValueOf: (sqInt)
		#signed64BitIntegerFor: (sqLong)
		#signed64BitValueOf: (sqInt)

		" VM_PROXY_MINOR > 5 "
		6
		#isArray: (sqInt )
		#forceInterruptCheck (void)


		" VM_PROXY_MINOR > 6 "
		7
		#fetchLong32:ofObject: (sqInt  sqInt)
		#getThisSessionID (void)
		#ioFilename:fromString:ofLength:resolveAliases: (charPtr charPtr sqInt sqInt)
		#vmEndianness (void)

		8
		#internalIsImmutable: (sqInt)
		#internalIsMutable: (sqInt)
		#primitiveFailFor: (sqInt)
		#classAlien (void)
		#getStackPointer (void)
		#sendInvokeCallback:Stack:Registers:Jmpbuf: (sqInt sqInt sqInt sqInt)
		#reestablishContextPriorToCallback: (sqInt)
		#classUnsafeAlien (void)
		" New methods for proxy version 1.8 "
			
		" callbackEnter: Re-enter the interpreter loop for a callback.
			Arguments:
			callbackID: Pointer to a location receiving the callback ID
			used in callbackLeave
			Returns: True if successful, false otherwise  "
		callbackEnter: (sqIntPtr)
			
		" callbackLeave: Leave the interpreter from a previous callback
			Arguments:
			callbackID: The ID of the callback received from callbackEnter()
			Returns: True if succcessful, false otherwise. "
		callbackLeave: (sqInt)
			
		" addGCRoot: Add a variable location to the garbage collector.
			The contents of the variable location will be updated accordingly.
			Arguments:
			varLoc: Pointer to the variable location
			Returns: True if successful, false otherwise. "
		addGCRoot: (sqIntPtr)
			
		"  removeGCRoot: Remove a variable location from the garbage collector.
			Arguments:
			varLoc: Pointer to the variable location
			Returns: True if successful, false otherwise. "
		removeGCRoot: (sqIntPtr)
	)
! !

!NBInterpreterProxy class methodsFor: 'class initialization' stamp: 'CamilloBruni 7/18/2012 14:41'!
safeNoAlignFunctions

	"list of functions which is safe to call without stack alignment"
	
	^ #(
		minorVersion
		majorVersion
		failed
		primitiveMethod
		getStackPointer
		stackValue:
		primitiveFail
		nilObject
		trueObject
		falseObject
		methodArgumentCount
	)! !

!NBInterpreterProxy class methodsFor: 'accessing functions' stamp: 'IgorStasenko 5/28/2012 05:18'!
stackPointerAddress

	"to prevent recursion, we prohibit using stack pointer address when bootstrapping"
	NativeBoost forCurrentPlatform isBootstrapping ifTrue: [ ^ nil ].
	
	^ self primStackPointerAddress ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/29/2010 06:20'!
addGCRoot: sqIntPtr
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
addHighPriorityTickee: thickeeFnAddr period: periodms
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
addSynchronousTickee: tickerFnAddr period: periodms round: roundms
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:26'!
argumentCountOf: methodOop
	"return a number of arguments for given method oop"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:27'!
arrayValueOf: oop
	"Return the address of first indexable field of resulting array object, or fail if the instance variable does not contain an indexable bytes or words object."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:56'!
baseHeaderSize
	^ objectFormat baseHeaderSize! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:21'!
become: array1 with: array2

	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'CamilloBruni 7/16/2012 09:50'!
booleanValueOf: oop
	"convert true and false (Smalltalk) to true or false(C).
	Fails if oop is not a boolean object"
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:28'!
byteSizeOf: oop
	"Return the size of the receiver in bytes"

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:22'!
byteSwapped: w

	"Answer the given integer with its bytes in the reverse order."
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'CamilloBruni 8/3/2012 18:23'!
cFramePointer
	(self canUseStackPointer not
	or: [stackPtrAddress isNil]) ifTrue: [ 
		self error: 'cannot use c stack pointer directly' ].

	"answer a memory operand "	
	^ cFramePtrAddress asUImm32 ptr32! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'CamilloBruni 8/3/2012 18:23'!
cStackPointer
	(self canUseStackPointer not
	or: [stackPtrAddress isNil]) ifTrue: [ 
		self error: 'cannot use c stack pointer directly' ].

	"answer a memory operand "	
	^ cStackPtrAddress asUImm32 ptr32! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'Igor.Stasenko 4/9/2010 07:57'!
call: aFunction
	^ self call: aFunction arguments: #()

! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'CamilloBruni 7/23/2012 13:29'!
call: aFunction arguments: args
	
	| align |
	
	asm decorateWith: 'InterpreterProxy >> ' , aFunction name during: [ 
	

	align := gen stackAlignment.
	aFunction requiresAlignment ifFalse: [ align := 1 ].
	
	asm cdeclCall: [ :call |

		args reverseDo: [:arg | call push: arg value ].
		self callFn: aFunction.

	] alignment: align ].
	
	^ EAX! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'CamilloBruni 7/19/2012 12:04'!
callFn: aFunctionOrName
	
	| fn |
	fn := aFunctionOrName.
	aFunctionOrName isString ifTrue: [ fn := self functions at: aFunctionOrName ].

	fn checkVersion. 

	gen optProxyLabels ifTrue: [
		asm label: (asm uniqueLabelName: fn name).
		].
	self canUseDirectProxyFnAddress ifTrue: [		
		asm 
			mov: (fn address asUImm32 annotation: fn name )   to: EAX;
			call: EAX	
	] ifFalse: [
		asm
			mov: (self class interpreterProxyAddress asUImm32 annotation: 'interpreterProxy address')   to: EAX;
			mov: ((EAX ptr + (fn index * self pointerSize)) annotation: fn name) to: EAX;
			call: EAX
	]
! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'CamilloBruni 7/23/2012 13:29'!
callGated: aFunction arguments: args
	"Call an interpreter proxy function through special gate function,
	ensuring that if it triggers GC and native code could be relocated, 
	then gate will return to correct native code address after relocation"

	| align |

	asm decorateWith: 'InterpreterProxy >> ' , aFunction name during: [ 

	align := gen stackAlignment.
	aFunction requiresAlignment ifFalse: [ align := 1 ].
	
	asm cdeclCall: [ :call |

		args reverseDo: [:arg | call push: arg value ].
		self gatedCallFn: aFunction.

	] alignment: align ].
	
	^ EAX! !

!NBInterpreterProxy methodsFor: 'VM-extras' stamp: 'IgorStasenko 3/24/2011 21:28'!
callInterpreter

	"call the 'callInterpreter' VM function "
	
	| fn |
	
	fn := NativeBoost loadFunction: #callInterpret from: ''.
	self assert: (fn ~= 0).
	asm mov: fn asUImm to: EAX.
	asm call: EAX.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:38'!
callbackEnter: callbackIDPtr

	" sqInt * callbackIDPtr 
	should point to a memory where jumpbuf will be stored "
	
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:11'!
callbackLeave:  callbackId
	"Leave from a previous callback"
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'testing' stamp: 'Igor.Stasenko 9/29/2010 10:48'!
canUseDirectProxyFnAddress
	"Answer true if code generation routines can use interpreterProxy
	function addresses directly (available after bootstrap) "
	
	^ NativeBoost forCurrentPlatform isBootstrapping not
		and: [ gen optDirectProxyFnAddress ]! !

!NBInterpreterProxy methodsFor: 'testing' stamp: 'IgorStasenko 5/28/2012 05:25'!
canUseStackPointer
	
	gen optUseStackPointer ifFalse: [ ^ false ].
	^ stackPtrAddress notNil
	! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
characterTable
	"return a character table special object (array of 256 characters)"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:03'!
checkedIntegerValueOf: oop
	"convert smallinteger into integer value. fails if oop is not a smallinteger"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/30/2010 20:29'!
classAlien
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classArray
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classBitmap
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classByteArray
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
classCharacter
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalAddress
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalData
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalFunction
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalLibrary
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
classExternalStructure
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classFloat
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:38'!
classLargeNegativeInteger

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classLargePositiveInteger
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classPoint
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classSemaphore
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classSmallInteger
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/11/2010 16:16'!
classString
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy classes' stamp: 'Igor.Stasenko 4/30/2010 20:29'!
classUnsafeAlien
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:17'!
clone: oop
	"Return a shallow copy of the given object. May cause GC"
	"Assume: Oop is a real object, not a small integer."
	
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:36'!
compilerHookVector
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:38'!
copyBits
	"This entry point needs to be implemented for the interpreter proxy.
	Since BitBlt is now a plugin we need to look up BitBltPlugin:=copyBits
	and call it. This entire mechanism should eventually go away and be
	replaced with a dynamic lookup from BitBltPlugin itself but for backward
	compatibility this stub is provided"
	
	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:38'!
copyBitsFrom: x0 to: x1 at: y
	"This entry point needs to be implemented for the interpreter proxy.
	Since BitBlt is now a plugin we need to look up BitBltPlugin:=copyBitsFrom:to:at:
	and call it. This entire mechanism should eventually go away and be
	replaced with a dynamic lookup from BitBltPlugin itself but for backward
	compatibility this stub is provided"

	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/3/2010 14:29'!
createInstanceOf: aClass
	^ self createInstanceOf: aClass size: 0! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/3/2010 14:28'!
createInstanceOf: aClass size: indexableSize

	^ self instantiateClass: [ gen emitFetchClass: aClass ] indexableSize: indexableSize! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
disownVM: flags
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
displayObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 14:57'!
failed
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
falseObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:30'!
fetchArray: index ofObject: oop
	"Fetch the instance variable at the given index of the given object. Return the address of first indexable field of resulting array object, or fail if the instance variable does not contain an indexable bytes or words object."
		
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:31'!
fetchClassOf: oop
	"Fetch the class of given oop"
		
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:10'!
fetchFloat: fieldIndex ofObject: objectPointer
	"Fetch the instance variable at the given index of the given object. Return the C double precision floating point value of that instance variable, or fail if it is not a Float."
	"Note: May be called by translated primitive code."
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/28/2010 13:32'!
fetchInteger: index ofObject: oop
	"Fetch the instance variable at the given index of the given object. Return the C integer value of that instance variable, or fail if it is not an integer."

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:49'!
fetchLong32: index ofObject: oop
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 5/4/2012 16:41'!
fetchPointer: index ofObject: oop
	"Answer an instance variable value at given index for given oop.
	No range checking performed.
	
	Output: EAX"
	| reg mem |
	(index isBlock or: [ oop isBlock]) ifTrue: [ ^ self simpleCall ].

	"shortcut if arguments are not blocks"
	reg := oop.
	reg isMem ifTrue: [ asm mov: oop to: EAX. reg := EAX ].

	mem := reg ptr32.

	index isInteger ifTrue: [
		mem displacement: (self baseHeaderSize+ (index*self oopSize)) asImm ]
	ifFalse: [ | idx  |
		idx := index.
		index isMem ifTrue: [ 
			"index stored at pointer" 
			asm mov: index to: ECX.
			idx := ECX.
			].
		mem index: idx; 
			scale: self oopSize;
			displacement: self baseHeaderSize asImm ].
	
	asm mov: mem to: EAX.
	^ EAX
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:37'!
firstFixedField: oop
	"Answer an address of first fixed field for given oop"

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:37'!
firstIndexableField: oop
	"Answer an address of first indexable field for given oop"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
floatArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 19:02'!
floatObjectOf: floatValue
	"istantiate a floating point object and put a floating point value to it.
	answer that object "
	
	"we can't pass the floating point value in general purpose register,
	see the NBFloat64>>coerceReturnValue: how to do that."
	
	self shouldNotImplement.
	" ^ self gatedCall "
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:12'!
floatValueOf: oop
	"Return a double value of given floating point object.
	fails if oop is not a Float class instance"
	
	"note, result is floating point value"
	self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:49'!
forceInterruptCheck
	
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'CamilloBruni 8/3/2012 17:19'!
framePointer
	(self canUseStackPointer not
	or: [framePtrAddress isNil]) ifTrue: [ 
		self error: 'cannot use frame pointer directly' ].

	"answer a memory operand "	
	^ framePtrAddress asUImm32 ptr32! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:23'!
fullDisplayUpdate
	"Repaint the entire smalltalk screen, ignoring the affected rectangle. Used in some platform's code when the Smalltalk window is brought to the front or uncovered."

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:23'!
fullGC
	"Do a mark/sweep garbage collection of the entire object memory. Free inaccessible objects but do not move them."

	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/29/2010 09:27'!
functions
	^ self class functions! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'Igor.Stasenko 9/29/2010 09:27'!
gatedCall

	| sender fn args |
	sender := thisContext sender.
	fn := self functions at: (sender method selector).
	args := Array new: sender method numArgs.
	1 to: args size do: [:i |  args at: i put: (sender tempAt: i ) ].
	
	^ self callGated: fn arguments: args! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'IgorStasenko 8/3/2011 05:57'!
gatedCallFn: aFunctionOrName
	
	| fn gate |
	gen optNonMovable ifTrue: [
		"a non-movable code don't needs to use gate"
		^ self callFn: aFunctionOrName
		].
	
	fn := aFunctionOrName.
	aFunctionOrName isString  ifTrue: [ fn := self functions at: aFunctionOrName ].

	gate := NativeBoost callgateFunctionAddress.
	fn checkVersion.

	gen optProxyLabels ifTrue: [
		asm label: (asm uniqueLabelName: 'gated_', fn name).
		].

	"push an address of function to call"	
	self canUseDirectProxyFnAddress ifTrue: [ 
		asm 
			push: (fn address asUImm32 annotation: fn name).
	] ifFalse: [
		asm
			mov: (self class interpreterProxyAddress asUImm32 annotation: 'interpreterProxy address') to: EAX;
			mov: ((EAX ptr + (fn index * self pointerSize)) annotation: fn name) to: EAX;
			push: EAX
	].

	asm 
		mov: (gate asUImm32 annotation: 'Call gate')  to: EAX;
		call: EAX.

	usedGate := true.! !

!NBInterpreterProxy methodsFor: 'accessing' stamp: 'IgorStasenko 12/21/2011 14:20'!
generator: aGenerator

	gen := aGenerator.
	asm := aGenerator asm.
	objectFormat := NBObjectFormat current asm: asm.
	gen parseOptions: self class defaultOptions! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:12'!
getStackPointer
	"return a ST stack pointer"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:49'!
getThisSessionID
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 8/7/2011 04:24'!
ifFailedEmit: aBlock
	| lbl |
	lbl := asm uniqueLabelName: 'notFailed'.
	
	self failed.
	asm or: EAX with: EAX.
	asm jz: lbl.
		
	aBlock value.
	
	asm label: lbl! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 4/11/2010 23:04'!
ifFailedJumpTo: label
	self failed.
	asm or: EAX with: EAX.
	asm jnz: label.
		
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:39'!
includesBehavior: aClass ThatOf: aSuperclass
	"Return the equivalent of 
		aClass includesBehavior: aSuperclass.
	Note: written for efficiency and better inlining (only 1 temp)"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:32'!
incrementalGC
	"Do a mark/sweep garbage collection of just the young object 
	area of object memory (i.e., objects above youngStart), using 
	the root table to identify objects containing pointers to 
	young objects from the old object area."
	
	^ self gatedCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/5/2010 20:11'!
indexOf: ivarName in: aClass

	^ aClass instVarIndexFor: ivarName ifAbsent: [nil]! !

!NBInterpreterProxy methodsFor: 'initialize-release' stamp: 'CamilloBruni 8/3/2012 18:24'!
initialize
	
	"actually, this should be determined by querying NativeBoost platformId"
	objectFormat := NBObjectFormat32 new.

	"set it to nil, if there is recursion"
	stackPtrAddress := [self class stackPointerAddress] on: NBCodeGenRecursion do: [ nil ].
	framePtrAddress := [self class framePointerAddress] on: NBCodeGenRecursion do: [ nil ].
	cStackPtrAddress := [self class cStackPointerAddress] on: NBCodeGenRecursion do: [ nil ].
	cFramePtrAddress := [self class cFramePointerAddress] on: NBCodeGenRecursion do: [ nil ].! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
instanceSizeOf: aClass
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:19'!
instantiateClass: classOop indexableSize: sz

	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
integerArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 5/5/2010 18:00'!
integerObjectOf:  value
	"Convert C integer value to smallinteger object.
	no range checking performed. "

	"lets not do call, but just do a shortcut (value << 1) + 1 "
	| tmp |
	tmp := value.
	value isBlock ifTrue: [ tmp := value value ].
	tmp = EAX ifFalse: [ asm mov: tmp to: EAX ].
	asm shl: EAX with: 1;
		inc: EAX	.
	
	^ EAX
	
	" ^ self simpleCall "
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:09'!
integerValueOf: oop
	"Convert smallinteger oop to C integer value.
	No type checking performed.
	"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:28'!
internalIsImmutable: oop
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:11'!
internalIsMutable: oop
	"return a ST stack pointer"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:51'!
ioFilename: aCharBuffer fromString: aFilenameString ofLength: filenameLength resolveAliases: bool
"the vm has to convert aFilenameString via any canonicalization and char-mapping and put the result in aCharBuffer.
Note the resolveAliases flag - this is an awful artefact of OSX and Apples demented alias handling. When opening a file, the flag must be  true, when closing or renaming it must be false. Sigh."	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:44'!
ioLoadFunction: fnName From: moduleName
	"Load and return the requested function from a module"
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:14'!
ioLoadModule: m OfLength: l
	"implemented , see NBUtils class>>ioLoadModule: "
	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:13'!
ioLoadSymbol: sym OfLength: len FromModule: handle
	"implemented , see NBUtils class>>ioLoadSymbol:fromModule: "
	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:44'!
ioMicroMSecs
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
is: oop KindOf: stringPtr "char *"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
is: oop MemberOf: stringPtr "char *"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:48'!
isArray: oop
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 09:33'!
isBytes: oop
	 
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/20/2010 06:02'!
isBytes: oop ifNotJumpTo: label
	^ objectFormat isBytes: oop ifNotJumpTo: label! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/20/2010 06:02'!
isBytesOrWords: oop ifNotJumpTo: label
	^ objectFormat isBytesOrWords: oop ifNotJumpTo: label! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
isFloatObject: oop
	 
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:42'!
isInMemory: oop
	"Return true if the given address is in ST object memory"
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 15:58'!
isIndexable: oop
	 
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 15:59'!
isIntegerObject: oop
	 " return true (1) only if oop is smallInteger (not big integer or any other object !!!!) "
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:00'!
isIntegerValue: value
	 " return true (1) only if given integer value fits in ST smallinteger immediate oop"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
isKindOf: oop Class: aClass
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:01'!
isPointers: value
	"Answer true if the argument has only fields that can hold oops. See comment in formatOf:"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:01'!
isWeak: oop
	"Answer true if the argument has only weak fields that can hold oops. See comment in formatOf:"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:01'!
isWords: oop
	"Answer true if the argument contains only indexable words (no oops). See comment in formatOf:"
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy testing' stamp: 'Igor.Stasenko 4/11/2010 16:02'!
isWordsOrBytes: oop
	"Answer true if the contains only indexable words or bytes (no oops). See comment in formatOf:"
	"Note: Excludes CompiledMethods."
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
isYoung: anOop
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:54'!
ivar: ivarName in: aClass
	"answer an offset of ivar relative to oop"
	| index |
	index := aClass instVarIndexFor: ivarName ifAbsent: [nil].
	^ objectFormat instVarOffsetAt: index.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:39'!
literal: index ofMethod: methodOop
	"Answer a method's literal at given zero-based index"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:39'!
literalCountOf: methodOop
	"Answer a total number of literals for given method"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:37'!
loadBitBltFrom: bbOop
	"This entry point needs to be implemented for the interpreter proxy.
	Since BitBlt is now a plugin we need to look up BitBltPlugin:=loadBitBltFrom
	and call it. This entire mechanism should eventually go away and be
	replaced with a dynamic lookup from BitBltPlugin itself but for backward
	compatibility this stub is provided"

	self shouldNotImplement ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:19'!
majorVersion
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:19'!
makePointwithxValue: xval yValue: yval
"make a Point xValue@yValue.
We know both will be integers so no value nor root checking is needed"
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
methodArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'HenrikSperreJohansen 8/25/2011 00:58'!
methodArgumentCount
	"Answer a total number of arguments of primitive method"
	^ gen method numArgs! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:41'!
methodPrimitiveIndex
	"Answer a primitive index of currently activated method"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
methodReturnValue: oop
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:19'!
minorVersion
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
nilObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
objectArg: index
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 19:50'!
objectFormat 
	^ objectFormat ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:08'!
obsoleteDontUseThisFetchWord: index ofObject: zap
	self shouldNotImplement! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/20/2010 07:25'!
oop: anOop ifSmallInt: aBlock ifNotSmallInt: notSmallIntBlock

	" emit code to check if argument, oop is smallInteger 
	squeak smallints having a least significant bit set"
	| lbl1 lbl2 |
	
	lbl1 := asm uniqueLabelName: 'notSmallInt'.
	asm 
		mov: anOop to: EAX;
		test: AL with: 1;
		je: lbl1.
	aBlock value.
	notSmallIntBlock ifNil: [ asm label: lbl1. ^ self ].
	
	lbl2 := asm uniqueLabelName: 'smallIntTestEnd'.
	asm jmp: lbl2.
	
	asm label: lbl1.
	notSmallIntBlock value.
	asm label: lbl2.
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:54'!
oopSize
	^ objectFormat oopSize! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
ownVM: threadIdAndFlags
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 5/19/2010 11:54'!
pointerSize
	^ self oopSize! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:21'!
pop: nItems
	"not recommended for use in native code.
	use #stackValue: "
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
pop: nItems thenPush: anObject
	"not recommended for use in native code.
	use #stackValue: , and return a result oop from native function instead"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:20'!
popRemappableOop
	"Pop and return the possibly remapped object from the remap buffer."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:12'!
positive32BitIntegerFor: integerValue
	"Convert a (possibly positive) integer value
	into corresponding smallint object or positive big int instance
	"
	
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:13'!
positive32BitValueOf: oop
	"Convert the given object into an integer value.
	The object may be either a positive ST integer or a four-byte LargePositiveInteger."
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 9/3/2012 00:56'!
positive64BitIntegerFor
		
	"Assume integer value is in EAX:EDX register pair.
	Make a call as if we push 2 arguments "
	| fn |
	
	fn := self functions at: #positive64BitIntegerFor: .
	
	^ self call: fn arguments: { asm EAX. asm EDX }! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 9/3/2012 02:31'!
positive64BitIntegerFor: op
"use positive64BitIntegerFor instead"
	self shouldNotImplement.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 9/3/2012 00:23'!
positive64BitValueOf: oop 
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 5/28/2012 03:17'!
prepareForCallout
	"reserve a stack pointer temp above any others
	
	- not used anymore, since Cog supports stackPointerAddress() function
	"
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
primitiveErrorTable
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:32'!
primitiveFail
	"Fail a primitive."
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
primitiveFailFor: errorCode
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
primitiveFailureCode
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:51'!
primitiveIndexOf: methodOop
	"return a primitive index for given method oop"
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:40'!
primitiveMethod
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
push: anObject
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
pushBool: trueOrFalse
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:22'!
pushFloat: f
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 9/29/2010 11:03'!
pushFloatOopAsFloat32: oop

	" input - oop , and operand, pointing to a Oop
	output: 32-bit floating-point value pushed on stack
	clobbers: EAX, ECX"

	Smalltalk compactClassesArray indexOf: Float ifAbsent: [
		"if Float is not compact class, do the hard way "
		self floatValueOf: oop.
		asm sub: (asm ESP) with: 4.
		asm fstp: asm ESP ptr32.
		^ self.
		].
	"since Float is a compact, to check that object is instance of float, 
	we just need to make sure that its header matching the Float's header format" 

	"Floating point value is stored in PowerPC word order"	
	self verifyCompactClassOf: oop is: Float.
	
	objectFormat floatsMatchingPlatform ifFalse: [
		asm 
			sub: ESP with: 8;
			mov: EAX ptr + self baseHeaderSize to: ECX;
			mov: ECX to: ESP ptr+4;
			mov: EAX ptr + (4+self baseHeaderSize) to: ECX;
			mov: ECX to: ESP ptr;
			fld: ESP ptr64;
			add: ESP with: 4 ] 
		ifTrue: [
			asm 
				fld: EAX ptr64 + self baseHeaderSize;
				sub: ESP with: 4 ].
	asm fstp: asm ESP ptr32
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'Igor.Stasenko 9/29/2010 11:04'!
pushFloatOopAsFloat64: oop

	" input - oop , and operand, pointing to a Oop
	output: 32-bit floating-point value pushed on stack
	clobbers: EAX, ECX"

	Smalltalk compactClassesArray indexOf: Float ifAbsent: [
		"if Float is not compact class, do the hard way "
		self floatValueOf: oop.
		asm sub: (asm ESP) with: 8.
		asm fstp: asm ESP ptr64.
		^ self.
		].

	self verifyCompactClassOf: oop is: Float.
	objectFormat floatsMatchingPlatform ifFalse: [
		asm 
			push: EAX ptr + (self baseHeaderSize);
			push: EAX ptr + (self baseHeaderSize+4) ]
	ifTrue: [
		asm 
			push: EAX ptr + (self baseHeaderSize+4);
			push: EAX ptr + (self baseHeaderSize) ]
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:23'!
pushInteger: int
	"not recommended for use in native code"
	self shouldNotImplement  
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:20'!
pushRemappableOop: oop
	"Record the given object in a the remap buffer. Objects in this buffer are remapped when a compaction occurs. This facility is used by the interpreter to ensure that objects in temporary variables are properly remapped."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 5/28/2012 01:31'!
receiver
	"Input: none.
	Output: EAX - a method's receiver"
	
	self canUseStackPointer ifFalse: [ ^self stackValue: self methodArgumentCount ].
	"EAX - count "
	^self receiverInto: EAX.
	"EAX - receiver"
	! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'HenrikSperreJohansen 8/25/2011 13:22'!
receiverInto: aReg
	"Input: aReg.
	Output: aReg - register holding method's receiver"
	

	^self stackValue: self methodArgumentCount storeIn: aReg.

	! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:35'!
reestablishContextPriorToCallback: callbackContext
	"callbackContext is an activation of invokeCallback:stack:registers:jmpbuf:.  Its sender
	 is the interpreter's state prior to the callback.  Reestablish that state."
	
	"WARNING!!!! do not use any proxy functions, which may 
	access the ST stack after calling this function, because its changing the active context
	and method, stack etc.
	
	Use at your own risk"
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:29'!
removeGCRoot: addr
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:40'!
sendInvokeCallback: thunkPtr Stack: stackPtr Registers: regsPtr Jmpbuf: jmpBufPtr
	"Send the 4 argument callback message invokeCallback:stack:registers:jmpbuf:
	 to Alien class with the supplied args.  The arguments are raw C addresses
	 and are converted to integer objects on the way."
	
	"useless without Alien... "
	^ self gatedCall
	! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:36'!
setCompilerInitialized: initFlag
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
setInterruptCheckChain: aFunctionAddr
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 8/10/2011 17:52'!
shiftForPointer
	"answer the shift bits for pointer size"
	^ self pointerSize highBit - 1
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:34'!
showDisplayBits: aForm Left: l Top: t Right: r Bottom: b
	"Repaint the portion of the Smalltalk screen bounded by the affected rectangle. Used to synchronize the screen after a Bitblt to the Smalltalk Display object."
	
	"any reason to use it here?"
	self shouldBeImplemented! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/30/2010 20:15'!
signalSemaphoreWithIndex: index
	"Record the given semaphore index in the double buffer semaphores array to be signaled at the next convenient moment. Force a real interrupt check as soon as possible."
	
	
	^self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:38'!
signed32BitIntegerFor: value 
	^ self gatedCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:34'!
signed32BitValueOf: object

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 9/3/2012 00:54'!
signed64BitIntegerFor		
	"Assume integer value is in EAX:EDX register pair.
	Make a call as if we push 2 arguments "
	| fn |
	
	fn := self functions at: #signed64BitIntegerFor: .
	
	^ self call: fn arguments: { asm EAX. asm EDX }! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 9/3/2012 02:32'!
signed64BitIntegerFor: op
"use #signed64BitIntegerFor instead"
	self shouldNotImplement.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'IgorStasenko 9/3/2012 00:23'!
signed64BitValueOf: oop 
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'call' stamp: 'Igor.Stasenko 9/29/2010 09:27'!
simpleCall

	| sender fn args |
	sender := thisContext sender.
	fn := self functions at: (sender method selector).
	args := Array new: sender method numArgs.
	1 to: args size do: [:i |  args at: i put: (sender tempAt: i ) ].
	
	^ self call: fn arguments: args! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:52'!
sizeOfSTArrayFromCPrimitive: ptr
	"Return the number of indexable fields of the given object. This method is to be called from an automatically generated C primitive. The argument is assumed to be a pointer to the first indexable field of a words or bytes object; the object header starts 4 bytes before that."
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:52'!
slotSizeOf: oop
	"Returns the number of slots in the receiver.
	If the receiver is a byte object, return the number of bytes.
	Otherwise return the number of words."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'CamilloBruni 7/23/2012 18:03'!
specialObjectsArray
	" load the special objects array into EAX"
	
	"since we cannot directly access the specialObjectsArray we store it as an extra Root"
	NativeBoost extraRootsRegistry
		at: #specialObjectsArray ifAbsentPut: [ Smalltalk specialObjectsArray ];
		"specialObjectsArray -> EAX"
		emitOopAt: #specialObjectsArray generator: gen.! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'CamilloBruni 7/23/2012 17:10'!
specialObjectsArrayAt: index
	"generate the code to load the value at the given index into EAX"
	self specialObjectsArray.
	self stObject: asm EAX at: index.! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'CamilloBruni 7/23/2012 18:03'!
specialSelectorAt: index
	"generate the code to load the symbol at the given index from specialObjectsArray at: 23"
	"since we cannot directly access the specialObjectsArray we store it as an extra Root"
	NativeBoost extraRootsRegistry
		at: #specialSelectorsArray ifAbsentPut: [ Smalltalk specialSelectors ];
		"specialSelectorsArray -> EAX"
		emitOopAt: #specialSelectorsArray generator: gen.
	"EAX at: index"
	self stObject: asm EAX at: index.! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:53'!
stObject: obj at: index
	"Return what ST would return for <obj> at: index."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:53'!
stObject: obj at: index put: value
	"Do what ST would return for <obj> at: index put: value."

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:54'!
stSizeOf: obj
	"Return the number of indexable fields in the given object. (i.e., what Smalltalk would return for <obj> size)."
	"Note: Assume oop is not a SmallInteger!!"

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'proxy-stack access' stamp: 'Igor.Stasenko 4/30/2010 20:16'!
stackFloatValue: offset
	"answer a float value of oop on stack at given offset value.
	
	Note, return value is loaded in FP register, not GP register"
	
	self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy-stack access' stamp: 'Igor.Stasenko 4/30/2010 20:16'!
stackIntegerValue: offset
	"answer a integer value of oop on stack at given offset value"
	^self simpleCall ! !

!NBInterpreterProxy methodsFor: 'proxy-stack access' stamp: 'Igor.Stasenko 4/30/2010 20:16'!
stackObjectValue: offset
	"Ensures that the given object is a real object, not a SmallInteger."
	^self simpleCall ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 5/28/2012 06:32'!
stackPointer
	(self canUseStackPointer not
	or: [stackPtrAddress isNil]) ifTrue: [ 
		self error: 'cannot use stack pointer directly' ].

	"answer a memory operand "	
	^ stackPtrAddress asUImm32 ptr32! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'CamilloBruni 7/23/2012 13:29'!
stackValue: index
		
	(index isInteger and: [self canUseStackPointer]) ifTrue: [
		
		asm decorateWith: 'InterpreterProxy>>stackValue:' , index asString during:  [ 
		asm mov: self stackPointer to: EAX.
		
		objectFormat stackGrowsDown 
			ifTrue: [
				asm mov: EAX ptr + (self pointerSize*index) to: EAX]
			ifFalse: [
				asm mov: EAX ptr - (self pointerSize*index) to: EAX].
		^ EAX
	]].

	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'CamilloBruni 7/23/2012 13:29'!
stackValue: index storeIn: aReg
		
	(index isInteger and: [self canUseStackPointer]) ifTrue: [
		
		asm decorateWith: 'InterpreterProxy>>stackValue:' , index asString during:  [ 
		asm mov: self stackPointer to: aReg.
		
		objectFormat stackGrowsDown 
			ifTrue: [
				asm mov: aReg ptr + (self oopSize*index) to: aReg]
			ifFalse: [
				asm mov: aReg ptr - (self oopSize*index) to: aReg].
		^ aReg
	]].

	self error: 'Not available. (And should not reach here)'! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:55'!
storeInteger: index ofObject: obj withValue: integerValue
	"Note: Integer value must fit in SmallInt , otherwise function will fail primitive"

	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'accessing oop fields' stamp: 'Igor.Stasenko 5/19/2010 12:22'!
storePointer: op intoVarbytes: destOop at: offset
	" input:
	  op - register, holding a pointer value
	  destOop - register operand with variable bytes oop
	  offset - integer value"

	^ self 
		storeValue: op 
		ofSize: self pointerSize 
		intoVarbytes: destOop 
		at: offset
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 15:56'!
storePointer: index ofObject: obj withValue: oop
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'accessing oop fields' stamp: 'Igor.Stasenko 5/19/2010 13:22'!
storeValue: op ofSize: numBytes intoVarbytes: destOop at: offset
	" input:
	  op - a register operand
	  numBytes - integer
	  destOop - register operand with variable bytes oop
	  offset - integer value"

	| mem |
	mem := destOop ptr + (objectFormat varBytesFirstField + offset).
	self assert: (op isGeneralPurpose & destOop isGeneralPurpose).
	asm mov: (asm reg: op index size: numBytes) to: (mem size: numBytes).
! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 09:39'!
success: flag
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:36'!
superclassOf:  classPointer
	
	^ self simpleCall! !

!NBInterpreterProxy methodsFor: 'VM-extras' stamp: 'Igor.Stasenko 5/14/2010 03:48'!
swapActiveContext: newContext

	"call the 'swapActiveContext' VM function "
	
	| fn |
	
	fn := NativeBoost loadFunction: 'swapActiveContext' from: ''.
	self assert: (fn ~= 0).
	asm push: newContext.
	asm mov: fn asUImm to: EAX.
	asm call: EAX;
	add: ESP with: 4.
	
! !

!NBInterpreterProxy methodsFor: 'VM-extras' stamp: 'IgorStasenko 5/7/2012 07:30'!
swapActiveContext: newContext restoreMethod: aMethodOop

	"call the 'swapActiveContextrestoreMethod' VM function "
	
	| fn |
	
	fn := NativeBoost loadFunction: 'swapActiveContextrestoreMethod' from: ''.
	self assert: (fn ~= 0).
		
	asm cdeclCall: [ :call |

		call push: aMethodOop value.
		call push: newContext value.
		
		asm 
			mov: fn asUImm to: EAX;
			call: EAX

	] alignment: gen stackAlignment 
! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
tenuringIncrementalGC
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
topRemappableOop
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'proxy objects' stamp: 'Igor.Stasenko 4/11/2010 16:15'!
trueObject
	
	^ self simpleCall
! !

!NBInterpreterProxy methodsFor: 'testing' stamp: 'IgorStasenko 8/3/2011 05:56'!
usedGate 
	^ usedGate == true! !

!NBInterpreterProxy methodsFor: 'proxy functions Cog' stamp: 'CamilloBruni 7/19/2012 12:07'!
utcMicroseconds
	self shouldBeImplemented ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 5/26/2012 15:16'!
varBytesFirstFieldOf: oop 
	"Answer the address of first byte in oop in EAX.
	 oop must be of a variable byte format"
	
	asm 
		mov: oop to: asm EAX;
		add: asm EAX with: objectFormat varBytesFirstField ! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'CamilloBruni 7/23/2012 13:29'!
verifyClassOf: oop is: aClass

	asm decorateWith: 'verifyClassOf:is:', aClass name during: [  

	"do a shortcut for compact classes"
	Smalltalk compactClassesArray indexOf: aClass ifAbsent: [ | class |
		class := gen reserveTemp.
		gen proxy fetchClassOf: oop.
		asm mov:  asm EAX to: class.
		gen emitFetchClass: aClass.
		asm cmp: asm EAX with: class;
			jne: gen failedLabel.
		gen releaseTemps: 1.
		^ self
	].

	^ self verifyCompactClassOf: oop is: aClass
	]! !

!NBInterpreterProxy methodsFor: 'helpers' stamp: 'IgorStasenko 8/30/2012 18:45'!
verifyCompactClassOf: oop is: aClass
	" fail prim, if oop class not matching the aClas
	output: oop in EAX "
	| index cont fail |

	index := Smalltalk compactClassesArray indexOf: aClass.
	oop = EAX ifFalse: [ asm mov: oop to: EAX ].
	
	cont := asm uniqueLabelName: 'cont'.
	fail := asm uniqueLabelName: 'fail'.
	asm 
	"smallinteger test"	
		test: EAX with: 1;
		jnz: fail;

		mov: EAX ptr to: ECX;
		and: ECX with: objectFormat compactClassMask;
		cmp: ECX with: (index bitShift: objectFormat compactClassIndexShift);
		je: cont.
		asm label: fail.
		gen failWithMessage: 'An instance of ', aClass name , ' expected'.	

	asm label: cont.
	
	! !

!NBInterpreterProxy methodsFor: 'proxy functions' stamp: 'Igor.Stasenko 4/11/2010 16:51'!
vmEndianness
	^ self simpleCall! !

Object subclass: #NBMemoryBlock
	instanceVariableNames: 'left right address length free'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Heap'!

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
address

	^address! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
address: anObject

	address := anObject! !

!NBMemoryBlock methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/22/2010 04:38'!
initialize
	free := true! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:17'!
isFree
	^ free! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
left

	^left! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
left: anObject

	left := anObject! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
length

	^length! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/24/2010 04:29'!
length: aValue

	length := aValue! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 00:46'!
makeFreeFor: heapManager
	"mark receiver as free and merge with adjusted blocks, if they also free"

	free := true.
	
	(right notNil and: [right isFree]) ifTrue: [
		length := length + right length.
		heapManager removeFreeBlock: right.
		right := right right.
		].
	
	(left notNil and: [ left isFree ]) 
		ifTrue: [ left length: (left length + length). left right: right.
			heapManager checkForFreePage: left
			 ]
		ifFalse: [ heapManager addFreeBlock: self ].! !

!NBMemoryBlock methodsFor: 'printing' stamp: 'Igor.Stasenko 9/26/2010 03:59'!
printOn: aStream

	super printOn: aStream.
	
	aStream 
		nextPutAll: '( @ 16r';
		nextPutAll: (address printStringBase: 16);
		nextPutAll: ', ';
		print: length.
		
	free ifTrue: [ aStream nextPutAll: ', free' ].
	
	aStream nextPut: $)! !

!NBMemoryBlock methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 23:20'!
reserve: numBytes for: heapManager
	"reserve a given number of bytes of memory
	if numBytes < length, then create a smaller block with free memory"
	| leftover |
	self assert: free.
	numBytes > length ifTrue: [ self error: 'can''t reserve more than length of block' ].
	heapManager removeFreeBlock: self.
	numBytes = length ifTrue: [ free := false. ^ self ].
	
	leftover := 
		NBMemoryBlock new
			address: address + numBytes;
			length: length - numBytes;
			left: self; 
			right: right.
	right := leftover.
	length := numBytes.
	free := false.
	heapManager addFreeBlock: leftover.
! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
right

	^right! !

!NBMemoryBlock methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/22/2010 04:43'!
right: anObject

	right := anObject! !

Object subclass: #NBMemoryPage
	instanceVariableNames: 'address length initialBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-Heap'!

!NBMemoryPage class methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 23:42'!
address: addr length: len

	^ self basicNew address: addr length: len! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:32'!
address
	^ address! !

!NBMemoryPage methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 9/24/2010 23:41'!
address: addr length: len

	address := addr.
	length := len.
	initialBlock := NBMemoryBlock new address: addr; length: len! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:08'!
firstBlock
	^ initialBlock! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/25/2010 00:21'!
length
	^ length! !

!NBMemoryPage methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/24/2010 23:19'!
totalAllocatedMemory

	| blk total |
	
	blk := initialBlock.
	total := 0.
	[ blk notNil ] whileTrue: [
		blk isFree ifFalse: [ total := total + blk length ].
		blk := blk right.
		].
	^ total! !

Object subclass: #NBNativeCodeGen
	instanceVariableNames: 'asm proxy options method'
	classVariableNames: 'DebugOn'
	poolDictionaries: 'AJx86Registers NativeBoostConstants'
	category: 'NativeBoost-Core'!

!NBNativeCodeGen commentStamp: 'IgorStasenko 2/15/2012 19:49' prior: 0!
I providing a basic interface for use a dynamically generated native code with NativeBoost plugin using #primitiveNativeCall.
On my class side, you can find the interface to help managing native code, as well as basic functionality for dealing with it at run time. 

My instance serves as a helper to access common facilities used for code generation: 
 - assembler
 - interpreter proxy

i do not provide anything beyond that, so you still basically on you own, and must use assembler and interpreter proxy for implementing a low-level funcitonality
in your code (like new primitive, new function etc)

Instance Variables:
	asm							: An object that is used to generate native code
	proxy	<NBInterpreterProxy> : An object providing an access to public VM interface: like fetching a var from smalltalk stack, accessing object's internals, etc.
	options	<Collection>   : A set of options which generated code may use 
	method 	: a compiled method instance where native code will be installed to, (of course in case if my instance used for generating code to be installed there,
		and if not, it can be ignored)
		
Usage:

My most simple use is in a form: 

myMethod
 <primitive: #pritmiveNativeCall module: #NativeBoostPlugin>
  ^ NBNativeCodeGen methodAssembly: [:gen |
	 "here you put an instructions or provide own machine code.
	a block should answer a bytearray, which should contain ready for use machine code"
	]

In case, if you want to use different top-level interface, like in order to write something like following:

myMethod
 <primitive: #pritmiveNativeCall module: #NativeBoostPlugin>
  ^ self myCode: [
	 "here you put an instructions or provide own machine code"
	]

You can use #handleFailureIn:nativeCode: method , which takes care of handling primitive failure, dealing with errors and 
finally installing native code, which you providing, into corresponding method.

!

NBNativeCodeGen subclass: #NBFFICallout
	instanceVariableNames: 'fnSpec requestor methodArgs coercionMayFail callInfo'
	classVariableNames: 'CustomErrorCodes CustomErrorMessages TypeAliases'
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBFFICallout commentStamp: '<historical>' prior: 0!
Callout arguments can be either:
- an integer constant, boolean or nil
- a type name (string or symbol)
- a class name
- a class variable
- any other object, which responds to #asFFICalloutArgument:


An object , answered by #asFFICalloutArgument: should implement 
a public protocol of NBExternalType 

Todo....
Options:

argument coercion options:
	#coerceBoolToInt  - Boolean   -> C integer (0/1)
	#coerceNilToInt  -  nil       -> C integer (0)
	#coerceFloatToInt - Float     -> C integer
	#coerceCharToInt -  Character -> C integer

	#noTypeChecking - do not perform any type checking for pushed arguments 
	  (dangerous, but sometimes can be useful)
		
return value coercion options:
	#returnBoolAsInt  -  do not turn a bool(0/1) into Boolean (true/false)

cdecl calling convention:
   1.   Function parameters are pushed on the stack in a right-to-left order.
   2. Any local variables declared by the callee are allocated on the stack by subtracting the number of bytes required from esp. That is (sub esp,NUMBER_OF_BYTES).
   3. Registers eax, ecx, and edx are available for use in the subprogram.
   4. Registers ebx, esi, edi, and ebp must not be modified by the callee. (In fact, they may be used, but their original values must be restored before exiting the callee).
   5. When the callee terminates, any local variable must be released by restoring esp to its original value (mov esp,ebp).
   6. Function return values are returned in the eax register (except for floating point values, which are returned in the st0 register).
   7. After the callee is over, the parameters that were pushed on the stack by the caller must be removed by the caller itself once the callee is terminated. It can be done in two ways :
          * pop ecx n times, where n is the number of parameters pushed (cons: a useless result is stored in ecx, and ecx's value changes)
          * add esp,NUMBER_OF_BYTES_PREVIOUSLY_PUSHED (1 parameter pushed = 4 bytes on a 32 bit machine)!

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'IgorStasenko 11/22/2012 13:36'!
call: anonFunctionSignature convention: callConvention functionAddress: aFunctionAddressBlock

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument should be an anonymous function signature, describing the return type and arguments. 
	Second argument is calling convention for the function, should be either #cdecl or #stdcall (more can be added later)
	Third argument is a block, which takes 0 or 1 argument (generator instance) and should return an address of function to call,
	either an unsigned integer value, or NBExternalAddress instance.
	
	Example of use: 
	
		myMethod 
			<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
			^ NBFFICallout call: #( int () ) convention: #cdecl functionAddress: [:generator | NativeBoost loadSymbol: 'fork' fromModule: NativeBoost CLibrary]
			
	which is equivalent to: 
	
		myMethod 
			<primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >
			^ self nbCall: #( int fork() )

	This API allows users to define own custom semantics, how/where to obtain a pointer to function which needs to be called.
	Please note that function address block is evaluated only once during code generation, and received function address 
	will be imprinted into generated code, so this API does not fits for cases, when function address needs to be always
	resolved dynamically during each activation of the method.
	For that , there is #cdecl:emitCall: / #stdCall:emitCall: API which allow user to provide own assembler code for calling the function. 
	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: callConvention;
				anonSpec: anonFunctionSignature;
				generateCallToAddress: aFunctionAddressBlock
			]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'IgorStasenko 11/22/2012 13:39'!
call: anonFunctionSignature convention: callConvention functionAddress: aFunctionAddressBlock options: aCodeGenerationOptions

	"
	For documentation, please look at #call:convention:functionAddress:
	This method differs only by having additional argument - a code generation options
	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				callType: callConvention;
				parseOptions: aCodeGenerationOptions;
				anonSpec: anonFunctionSignature;
				generateCallToAddress: aFunctionAddressBlock
			]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 7/19/2012 17:28'!
cdecl: functionSpec
	" A shortcut for writing
	    cdecl: AFunctionSpecification module: NativeBoost CLibrary"
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				cdecl;
				generateCall: functionSpec module: NativeBoost CLibrary ]! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 7/17/2012 13:59'!
cdecl: functionSpec emitCall: aCallEmittingBlock

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument is an array of types, where first element denotes a function return type,
	and rest denoting argument types.
	A CallEmittingBlock serves to emit an actual function call code. 

	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				useEmitCall;
				sender: sender;
				cdecl;
				anonSpec: functionSpec;
				generate: aCallEmittingBlock  ]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 10/4/2012 15:34'!
cdecl: functionSpec emitCall: aCallEmittingBlock options: anOptions

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument is an array of types, where first element denotes a function return type,
	and rest denoting argument types.
	A CallEmittingBlock serves to emit an actual function call code. 

	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				useEmitCall;
				sender: sender;
				parseOptions: anOptions;
				cdecl;
				anonSpec: functionSpec;
				generate: aCallEmittingBlock  ]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'Igor.Stasenko 5/3/2010 21:48'!
cdecl: functionSpec module: aModuleName

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				cdecl;
				generateCall: functionSpec module: aModuleName ]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'Igor.Stasenko 5/3/2010 21:50'!
cdecl: functionSpec module: aModuleName options: anOptions

"Note, this is a special method, which should be sent only from 
methods, which intend to use FFI callout code.
All such methods should use a 'primitiveNativeCall' primitive.

First argument is an array of types, where first element denotes a function return type,
and rest denoting argument types.
A CallEmittingBlock serves to emit an actual function call code. 

" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				parseOptions: anOptions;
				cdecl;
				generateCall: functionSpec module: aModuleName ]
! !

!NBFFICallout class methodsFor: 'options' stamp: 'cipt 10/25/2012 19:14'!
defaultOptions
	"see #allOptions on my instance side"
	^ #(
	
	"#optCoerceNilToNull"
	"passing nil as a pointer-type argument, converts it to C NULL "
		
	#optAllowExternalAddressPtr
	"for a pointer-type argument, accept an instance of NBExternalAddress "
	
	"for a pointer-type argument, allow passing a pointer to byte arrays"
	#optAllowByteArraysPtr 
	
	"if function returns a pointer, return nil if pointer is null"
	#optReturnNullAsNil  
		
	"If function returns a pointer, fail primitive if pointer is null.
	Takes preference over #returnNullAsNil 
	Default: disabled. "
	"#optFailOnReturnNull"	

	"if function returns a pointer, convert it to unsigned integer object.
	Default: disabled
	#optReturnPtrAsInt "
	
	"If function returns a pointer, convert it to an instance of NBExternalAddress.
	Takes preference over #returnPtrAsInt.
	Default: enabled.  "
	#optReturnPtrAsExternalAddress
		
	"directly convert between C integers and Smallintegers instead of using proxy 	functions. perform no range checking"
	"#optQuickSmi --  not yet done	" 

	"directly convert between C integers and Smallintegers instead of using proxy 	functions. include range checking"
	"#optQuickSmiSafe --  not yet done	" 
				
	"string conversion"
	
	"for char* parameter type, when passed an instance of ByteString, 
	copy a ByteString's contents on a stack, append null character and pass a pointer to it"
	"#optAcceptStringForCharPtr ---  not yet implemented"	
		
	"for a function returning char* type, convert it to an instance of ByteString"
	"#optReturnCharPtrAsString -- not yet implemented"

	"for a function spec taking arguments indirectly from an array using the x@index convention
	check that the index is not outside x''s bounds "
	#optCheckIndirectArgBounds
	)
! !

!NBFFICallout class methodsFor: 'initialize-release' stamp: 'IgorStasenko 9/3/2012 01:42'!
initTypeAliases
	"self initTypeAliases"
	TypeAliases := Dictionary newFromPairs:
	#(
"not really a type, useful only as return type or with pointers "
		void NBVoid
		
" 0/!!0  <-> false/true "
		bool NBBool

"fixed size integer types, byte order is platform dependent "
		int8 NBInt8
		uint8 NBUInt8
		int16 NBInt16
		uint16 NBUInt16
		int32 NBInt32
		uint32 NBUInt32
		int64 NBInt64
		uint64 NBUInt64

" aliases to common C compiler types.. some of them are platform dependent, some is not.. to be sorted out later "		
		signedByte int8
		unsignedByte int8
		signedShort int16
		unsignedShort uint16
		signedChar int8  
		unsignedChar uint8
		schar int8
		uchar uint8
		signedLong int32
		unsignedLong uint32
		sbyte int8
		byte uint8
		short int16
		ushort uint16
		long int32
		ulong uint32
		longlong int64
		ulonglong uint64
		uint uint32
		int int32

"unsigned for sizes.. usually same size as platform's word size"
		size_t NBSizeT
		
"character type. uint8 <-> accepts Character/Smallint as argument, converts return to Character "
		Character NBCharacterType
		char NBCharacterType
		

"Floats fixed-size. platform-dependent byte order"
		float16 NBFloat16
		float32 NBFloat32
		float64 NBFloat64
		float128 NBFloat128

"Floats, C type name aliases"
				
		float float32
		double float64
		shortFloat float16
		
"Special types "		
		oop NBOop
	)
	! !

!NBFFICallout class methodsFor: 'initialize-release' stamp: 'Igor.Stasenko 4/28/2010 16:46'!
initialize

	Smalltalk removeFromStartUpList: self .
	
	self initTypeAliases! !

!NBFFICallout class methodsFor: 'error messages' stamp: 'IgorStasenko 8/8/2011 17:54'!
messageForCode: aCode
	CustomErrorCodes ifNil: [ ^ nil ].
	
	^ CustomErrorCodes at: aCode ifAbsent: nil! !

!NBFFICallout class methodsFor: 'error messages' stamp: 'IgorStasenko 8/8/2011 17:53'!
registerErrorMessage: aString
	| newCode |
	
	CustomErrorMessages ifNil: [ 
		CustomErrorMessages := Dictionary new.
		CustomErrorCodes := Dictionary new.
	].

	(CustomErrorMessages includesKey: aString) ifTrue: [
		^ CustomErrorMessages at: aString
	].
	
	"add new message and register code for it "

		
	newCode := 600 + CustomErrorCodes size.
	CustomErrorMessages at: aString put: newCode.
	CustomErrorCodes at: newCode put: aString.
	
	^ newCode! !

!NBFFICallout class methodsFor: 'error messages' stamp: 'IgorStasenko 2/20/2012 13:48'!
signalError: errorCode
	^ NBFFICalloutError signalError: errorCode
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 7/17/2012 14:01'!
stdcall: functionSpec emitCall: aCallEmittingBlock

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument is an array of types, where first element denotes a function return type,
	and rest denoting argument types.
	A CallEmittingBlock serves to emit an actual function call code. 

	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen	
				useEmitCall;
				sender: sender;
				stdcall;
				anonSpec: functionSpec;
				generate: aCallEmittingBlock  ]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 7/17/2012 14:01'!
stdcall: functionSpec emitCall: aCallEmittingBlock options: anOptions

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument is an array of types, where first element denotes a function return type,
	and rest denoting argument types.
	A CallEmittingBlock serves to emit an actual function call code. 

	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				useEmitCall;
				sender: sender;
				parseOptions: anOptions;
				stdcall;
				anonSpec: functionSpec;
				generate: aCallEmittingBlock  ]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 7/17/2012 14:01'!
stdcall: functionSpec module: aModuleName

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument is an array of types, where first element denotes a function return type,
	and rest denoting argument types.
	A CallEmittingBlock serves to emit an actual function call code. 

	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				stdcall;
				generateCall: functionSpec module: aModuleName ]
! !

!NBFFICallout class methodsFor: 'generator entry points' stamp: 'CamilloBruni 7/17/2012 14:00'!
stdcall: functionSpec module: aModuleName options: anOptions

	"Note, this is a special method, which should be sent only from 
	methods, which intend to use FFI callout code.
	All such methods should use a 'primitiveNativeCall' primitive.

	First argument is a function specification denoting return value type, name and
	arguments.

	" 
	| sender |
	sender := thisContext sender.
	^ self 
		handleFailureIn: sender
		nativeCode: [ :gen |
			gen
				sender: sender;
				parseOptions: anOptions;
				stdcall;
				generateCall: functionSpec module: aModuleName ]
! !

!NBFFICallout methodsFor: 'type aliases' stamp: 'Igor.Stasenko 9/28/2010 08:00'!
aliasForType: aTypeName

	| alias |
	alias := aTypeName.
	(requestor notNil and: [ requestor respondsTo: #externalTypeAlias: ]) 
		ifTrue: [ alias := requestor externalTypeAlias: aTypeName.
			alias ifNil: [ alias := aTypeName ] ].
	
	" internal aliases "
	TypeAliases ifNil: [ self class initTypeAliases ].
	^ TypeAliases at: alias ifAbsent: [ alias ]! !

!NBFFICallout methodsFor: 'accessing' stamp: 'IgorStasenko 8/21/2011 11:29'!
anonSpec: anonFunctionSpec

	fnSpec := self newSpecParser parseAnonFunction: anonFunctionSpec.
! !

!NBFFICallout methodsFor: 'spec parsing' stamp: 'cipt 10/24/2012 20:25'!
argName: argName indirectIndex: anIndex type: typeName ptrArity: ptrArity
	| type |
	argName
		ifNil: [ 
			"allow nil,true,false as untyped arguments"
			typeName = 'nil'
				ifTrue: [ ^ NBFFIConst value: 0 ].
			typeName = 'false'
				ifTrue: [ ^ NBFFIConst value: 0 ].
			typeName = 'true'
				ifTrue: [ ^ NBFFIConst value: 1 ].
			ptrArity > 0
				ifTrue: [ self error: 'missing argument name' ].	"lone self"
			typeName = 'self'
				ifTrue: [ ^ (requestor asNBExternalType: self) loader: self receiverArgumentLoader ].
			^ self resolveType: typeName ].
	type := self typeName: typeName ptrArity: ptrArity.
	type loader: (self loaderForArgNamed: argName indirectIndex: anIndex).
	^ type! !

!NBFFICallout methodsFor: 'code generation' stamp: 'Igor.Stasenko 5/1/2010 13:52'!
callCleanup
 	" for cdecl call type we should pop the function arguments we are pushed on stack..
	but since we returning back to interpreter using leave , it will be cleaned anyways"
! !

!NBFFICallout methodsFor: 'accessing' stamp: 'JavierPimas 11/16/2011 17:08'!
callType: aCallType

	aCallType == #cdecl ifTrue: [
		^ self cdecl.
		].
	
	aCallType == #stdcall ifTrue: [
		^ self stdcall
		].
	
	self error: 'unknown call type'.
! !

!NBFFICallout methodsFor: 'call conventions' stamp: 'Igor.Stasenko 5/3/2010 22:28'!
cdecl
	options add: #optCdecl! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 5/11/2011 17:23'!
coercionMayFail: aBoolean 
	coercionMayFail := coercionMayFail or: aBoolean ! !

!NBFFICallout methodsFor: 'failure code' stamp: 'CamilloBruni 7/23/2012 13:29'!
emitFailureHandler
	"emit failure code only if there was a jump on failed label,
	and label are not already defined in code"
	| failLbl failWithCodeLabel |
	failLbl := self failedLabel.
	failWithCodeLabel  := self failedWithCodeLabel.

	self assert: failLbl isSet not.
	self assert: failWithCodeLabel isSet not.

	((asm isLabelUsed: failWithCodeLabel) or: [asm isLabelUsed: failLbl ] ) ifTrue: [
		asm decorateWith: 'FFI: handle failure' during: [   

		(asm isLabelUsed: failWithCodeLabel) ifTrue: [
			"assume that error code is passed in EAX"
			asm label: failWithCodeLabel.
			proxy primitiveFailFor: asm EAX.
			self epilogue ].

		(asm isLabelUsed: failLbl) ifTrue: [
			asm label: self failedLabel.
			proxy primitiveFail.
			self epilogue ].
	]]	
! !

!NBFFICallout methodsFor: 'failure code' stamp: 'IgorStasenko 8/3/2011 06:53'!
emitFailureTest
	"emit call to InterpreterProxy>>failed to check if there's everything ok
	(usually done before making a call) "

	coercionMayFail ifTrue: [
		proxy ifFailedJumpTo: self failedLabel ].
! !

!NBFFICallout methodsFor: 'failure code' stamp: 'IgorStasenko 8/8/2011 17:50'!
errorCodeForMessage: aString
	
	^ self class registerErrorMessage: aString! !

!NBFFICallout methodsFor: 'failure code' stamp: 'IgorStasenko 8/6/2011 18:32'!
failWithCode: aCode

	asm 
		mov: aCode to: EAX;
		jmp: self failedWithCodeLabel! !

!NBFFICallout methodsFor: 'failure code' stamp: 'IgorStasenko 8/8/2011 17:49'!
failWithMessage: aString
	
	| errorCode |
	
	errorCode := self errorCodeForMessage: aString.
	
	^ self failWithCode: errorCode
! !

!NBFFICallout methodsFor: 'failure code' stamp: 'IgorStasenko 8/6/2011 18:25'!
failedLabel
	^ asm labelNamed: #FFICalloutFailed! !

!NBFFICallout methodsFor: 'failure code' stamp: 'IgorStasenko 8/6/2011 18:25'!
failedWithCodeLabel
	^ asm labelNamed: #FFICalloutFailedWithCode! !

!NBFFICallout methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 11:48'!
fnSpec
	^ fnSpec! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 1/18/2012 16:22'!
foreignCall: aBlock

	callInfo := self newCallInfo.
	callInfo alignment: self stackAlignment.
	asm performingCall: callInfo in: aBlock.! !

!NBFFICallout methodsFor: 'code generation' stamp: 'CamilloBruni 7/25/2012 12:43'!
generate: aFunctionBodyBlock
	"Answer the byte array, containing the generated machine code"
	| generatedCode |
	
	generatedCode := AJGeneratedCode fromInstructions: (self generateInstructions: aFunctionBodyBlock).
		
	^ generatedCode bytes
	
! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 11/22/2012 18:23'!
generateCall: functionSpec module: aModuleNameOrHandle
	"Generate a foreign function callout from given function specification and
	a module name"
	
	| fnAddress |

	self namedFnSpec: functionSpec.

	fnAddress := requestor nbGetSymbolAddress: fnSpec functionName module: aModuleNameOrHandle.
	fnAddress ifNil: [ self error: 'function unavailable' ].
	
	^ self generateCallToAddress: [ fnAddress ]
! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 11/22/2012 18:10'!
generateCallToAddress: aFunctionAddressBlock
	"Generate a foreign function callout using given function address"

	^ self generate: [:gen | | fnAddress |

		fnAddress := aFunctionAddressBlock cull: self cull: proxy cull: asm.
		
		fnAddress ifNil: [ self error: 'function unavailable' ].
		
		self optMayGC 
			ifTrue: [
				"a GC may be triggered during external call. Make sure we making a call via gate "
				asm 
					push: fnAddress asUImm32;
					mov: NativeBoost callgateFunctionAddress asUImm32 to: EAX;
					call: EAX ]
			ifFalse: [
				asm mov: fnAddress asUImm32 to: EAX;
				call: EAX.  ] 
		]
	! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 12/7/2012 01:04'!
generateInstructions: aFunctionBodyBlock
	| instructions |
	
	proxy prepareForCallout.
	"prepare & push arguments"	
	
	self foreignCall: [:call |
		"do not align, if its not required"
		self optNoAlignment ifTrue: [ call alignment: 1].

		self pushArguments.
	
		self emitFailureTest.

		asm decorateWith: 'FFI: performing a call' during: [
			aFunctionBodyBlock valueWithPossibleArgs: { self. proxy. asm}.
		
			"if we're using custom emitcall section, don't bother to cleanup the stack "
			(self optEmitCall or: [self optNoCleanup]) ifTrue: [ call disableCleanup ].
		].
	
	].
	
	"handle return value"
	asm decorateWith: 'FFI: coerce return value' during: [   
		fnSpec returnType coerceReturn: self ].
	
	self epilogue.
	self emitFailureHandler.

	(self optMayGC or: [proxy usedGate ]) ifTrue: [
		asm reserveExtraBytesOnStack: asm wordSize*2.
	].

	instructions := asm prepareInstructions.
	
	self optDebug ifTrue: [ self halt ].
	
	^ instructions
! !

!NBFFICallout methodsFor: 'argument loaders' stamp: 'cipt 10/24/2012 20:39'!
indirectLoader: aLoader byIndex: anIndex
	^ NBSTIndirectArgument new
		argumentLoader: aLoader;
		elementIndex: anIndex! !

!NBFFICallout methodsFor: 'initialize-release' stamp: 'IgorStasenko 8/3/2011 06:33'!
initialize 
	super initialize.
	coercionMayFail := false! !

!NBFFICallout methodsFor: 'spec parsing' stamp: 'Igor.Stasenko 4/30/2010 11:27'!
integerConstantArgument: int

	^ NBFFIConst value: int! !

!NBFFICallout methodsFor: 'argument loaders' stamp: 'cipt 10/26/2012 19:26'!
loaderForArgNamed: argName
	| loader |
	"try getting the argument from the method arguments"
	loader := self loaderFromMethodArgsNamed: argName.
	loader
		ifNil: [ 
			"special case, receiver argument"
			argName = 'self'
				ifTrue: [ loader := self receiverArgumentLoader ].
			loader
				ifNil: [ 
					"Ask the requestor for the argument"
					loader := requestor nbFnArgument: argName generator: self.
					loader ifNil: [ Error signal: 'Could not find accessor for variable named "' , argName , '" in ' , method name ] ] ].	"]"
	^ loader! !

!NBFFICallout methodsFor: 'argument loaders' stamp: 'cipt 10/24/2012 20:30'!
loaderForArgNamed: argName indirectIndex: anIndex
	| loader |
	loader := self loaderForArgNamed: argName.
	anIndex isNil
		ifFalse: [ loader := self indirectLoader: loader byIndex: anIndex ].
	^ loader! !

!NBFFICallout methodsFor: 'argument loaders' stamp: 'cipt 10/21/2012 20:25'!
loaderFromMethodArgsNamed: argName
	methodArgs
		ifNotNil: [ 
			| index |
			index := methodArgs indexOf: argName ifAbsent: [ nil ].
			index
				ifNotNil: [ 
					"ok, this is a method argument"
					^ NBSTMethodArgument new stackIndex: methodArgs size - index ] ].
	^ nil! !

!NBFFICallout methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 01:05'!
methodArgs
	^ methodArgs! !

!NBFFICallout methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 11:05'!
methodArgs: aMethodArgumentNames
	"avoid setting them directly,  useful for testing only"
	methodArgs := aMethodArgumentNames! !

!NBFFICallout methodsFor: 'accessing' stamp: 'IgorStasenko 8/21/2011 11:29'!
namedFnSpec: namedFn
	
	fnSpec := self newSpecParser parseNamedFunction: namedFn.
	! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 1/18/2012 16:22'!
newCallInfo 

	self optCdecl ifTrue: [ ^ asm newCdeclCall ].
	self optStdcall ifTrue: [ ^ asm newStdCall ].
	
! !

!NBFFICallout methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/30/2010 06:54'!
newSpecParser

	^ NBFnSpecParser new requestor: self
! !

!NBFFICallout methodsFor: 'code generation' stamp: 'CamilloBruni 7/23/2012 13:29'!
pushArguments

	" argument indexes pushed on ST stack are: 

	argType   ST stack  C stack 
	   index       index        push order
	    1              2             2
	    2              1             1
	    3              0             0
	"
	asm decorateWith: 'FFI: prepare arguments' during: [   
		fnSpec arguments do: [:arg | arg prepareArgumentUsing: self ] ].

	"both cdecl/apicall using reverse argument order on stack"
	fnSpec arguments notEmpty ifTrue: [
		asm decorateWith: 'FFI: pushing arguments' during: [   
			fnSpec arguments reverseDo: [:arg | 
				asm noticePush: arg stackSize forCall: callInfo.
				arg emitPush: self ] ]
	].

	fnSpec returnType 
		prepareReturnValue: self for: callInfo.! !

!NBFFICallout methodsFor: 'code generation' stamp: 'IgorStasenko 8/5/2011 18:01'!
receiverArgumentLoader
	^ NBSTMethodArgument new stackIndex: methodArgs size; isReceiver: true  ! !

!NBFFICallout methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/26/2010 02:03'!
requestor
	^ requestor! !

!NBFFICallout methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/26/2010 02:04'!
requestor: aRequestor
	requestor := aRequestor.
	
	(requestor respondsTo: #ffiCalloutOptions) ifTrue: [
		self parseOptions: requestor ffiCalloutOptions
	]
! !

!NBFFICallout methodsFor: 'accessing' stamp: 'IgorStasenko 2/9/2012 12:38'!
resolveType: aTypeName
	" a type name could be
	 - a class variable name
	- a class name
	- a type name 
	- a type name, followed by arbitrary number pointer chars - $*"

	| name newName resolver binding ptrArity |
	
	newName := aTypeName.
	ptrArity := 0.
	"resolve aliases and pointers"	
	[
		name := newName trimRight.  
		newName := self aliasForType: name.
		newName last = $* ifTrue: [
			ptrArity := ptrArity + 1.
			newName := newName allButLast ].
		name = newName ] whileFalse.
	
	resolver := requestor ifNil: [ self class ].
	binding := resolver nbBindingOf: name asSymbol.
	
	binding ifNotNil: [ 
		^ (binding value asNBExternalType: self) pointerArity: ptrArity ] .

	^ self error: 'Unable to resolve external type: ', aTypeName.

! !

!NBFFICallout methodsFor: 'spec parsing' stamp: 'IgorStasenko 8/21/2011 11:04'!
returnType: aType

	^ self  typeName: aType first ptrArity: aType second! !

!NBFFICallout methodsFor: 'code generation' stamp: 'Igor.Stasenko 4/28/2010 12:46'!
returnValueRegister
	
	"answer a register, which is used by functions to return value"
	^ EAX! !

!NBFFICallout methodsFor: 'accessing' stamp: 'IgorStasenko 3/27/2012 17:23'!
sender: aSenderContext
	| nArgs |
	self requestor: aSenderContext method methodClass.
	nArgs := aSenderContext method numArgs.
	methodArgs := aSenderContext method methodNode tempNames first: nArgs.
	
	self assert: (methodArgs size = nArgs).
! !

!NBFFICallout methodsFor: 'call conventions' stamp: 'Igor.Stasenko 5/3/2010 22:27'!
stdcall
	options add: #optStdcall! !

!NBFFICallout methodsFor: 'spec parsing' stamp: 'Igor.Stasenko 4/30/2010 09:18'!
typeName: aName ptrArity: ptrArity

	^ (self resolveType: aName) pointerArity: ptrArity! !

!NBFFICallout methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 08:42'!
useEmitCall
	"set the flag that we're generating code which using custom emitCall: section"
	
	options add: #optEmitCall! !

!NBFFICallout methodsFor: 'testing' stamp: 'Igor.Stasenko 5/18/2010 02:23'!
usesMethodArguments

	^ fnSpec arguments anySatisfy: [:type | type loader usesSTStack ]! !

NBFFICallout subclass: #NBNativeFunctionGen
	instanceVariableNames: 'nativeFunction code callType stackSize returnLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core-FFI'!

!NBNativeFunctionGen commentStamp: '<historical>' prior: 0!
I'm a generator of native code. I can create C style functions, providing convenient syntactic sugar for accessing the function arguments in function body (but you still have to write the body of the function with the assembler).
I can be used for implementing small helper routines, low-level callbacks or functions which will run in separate (to VM) thread.

A function spec is used to help with fetching arguments from call stack by using #arg: method for that:

 NBNativeFunctionGen 
		cdecl: #( int (byte* a, byte * b) )
		emit: [:gen | | asm |
			asm := gen asm.
			"this will load argument from stack to register"
			asm mov: (gen arg: #b) to: EAX;
		].

By invoking the expression above, I will generate a native code and keep it in my instance. 
Now to put this code in use, it must be installed  (see #install) into external memory. Then an address to the function can be passed to any other external function,
or even called by FFI callout:

	myFunction := NBNativeFunctionGen cdecl: #(..) emit: [...].
	myFunction install.
	address := myFunction address.

After function is no longer needed, it must be uninstalled (to conserve the external memory):

	myFunction uninstall.

Note, that this must be done explicitly, since like everything which works with external resources, there's no any automatic resource management for external memory.
!

!NBNativeFunctionGen class methodsFor: 'generator entry points' stamp: 'IgorStasenko 8/23/2012 18:06'!
cdecl: fnSpec emit: aFunctionBodyBlock
	^ self new cdecl;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock;
		yourself! !

!NBNativeFunctionGen class methodsFor: 'generator entry points' stamp: 'IgorStasenko 8/23/2012 18:06'!
cdecl: fnSpec emit: aFunctionBodyBlock options: anOptions

	^ self new cdecl;
		parseOptions: anOptions;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock;
		yourself! !

!NBNativeFunctionGen class methodsFor: 'generator entry points' stamp: 'IgorStasenko 8/23/2012 18:06'!
stdCall: fnSpec emit: aFunctionBodyBlock
	^ self new stdcall;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock;
		yourself! !

!NBNativeFunctionGen class methodsFor: 'generator entry points' stamp: 'IgorStasenko 8/23/2012 18:06'!
stdCall: fnSpec emit: aFunctionBodyBlock options: anOptions
	^ self new 
		parseOptions: anOptions;
		stdcall;
		fnSpec: fnSpec;
		generate: aFunctionBodyBlock;
		yourself! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2012 15:36'!
address
	^ nativeFunction address! !

!NBNativeFunctionGen methodsFor: 'convenience' stamp: 'IgorStasenko 5/28/2012 07:23'!
arg: aName
	| arg |
	
	arg := fnSpec arguments detect: [:argx | argx name = aName ]
		ifNone: [ self error: 'invalid argument name' ].
	
	self assert: (arg type typeSize <= 8).
	
	^ (asm EBP ptr + arg offset) size: arg type typeSize! !

!NBNativeFunctionGen methodsFor: 'as yet unclassified' stamp: 'cipt 10/26/2012 19:19'!
argName: argName indirectIndex: anIndex type: typeName ptrArity: ptrArity

	| arg |
	arg := NBNativeFunctionArgument new.
	arg type: (self typeName: typeName ptrArity: ptrArity).
	arg name: argName.
	
	^ arg
	! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/13/2010 23:34'!
code
	^ code! !

!NBNativeFunctionGen methodsFor: 'code generation' stamp: 'CamilloBruni 7/23/2012 16:40'!
epilogue
	
	asm
		label: self returnLabel;
		emitEpilogue: (self optStdcall ifTrue: [ stackSize] ifFalse: [0]).! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'IgorStasenko 8/21/2011 11:01'!
fnSpec: anonymousSpec
	
	fnSpec := NBFnSpecParser new requestor: self ; parseAnonFunction: anonymousSpec! !

!NBNativeFunctionGen methodsFor: 'code generation' stamp: 'IgorStasenko 8/23/2012 18:14'!
generate: aFunctionBodyBlock

	code := AJGeneratedCode fromInstructions: (self generateInstructions: aFunctionBodyBlock).
	
 ! !

!NBNativeFunctionGen methodsFor: 'code generation' stamp: 'CamilloBruni 7/23/2012 16:36'!
generateInstructions: aFunctionBodyBlock
	
	| instructions |
	
	options add: #optNonMovable.  "native functions are non-movable code"
		
	self prepareArguments.
	
	aFunctionBodyBlock cull: self cull: proxy cull: asm.

	self epilogue.
	
	instructions := asm prepareInstructions.
	
	self optDebug ifTrue: [ self halt ].
	
	^ instructions

! !

!NBNativeFunctionGen methodsFor: 'installing' stamp: 'IgorStasenko 8/23/2012 18:06'!
install
	"install the code into a memory heap"
	self assert: code notNil.
	nativeFunction := NBNativeFunction code: code fnSpec: fnSpec.
	^ nativeFunction ! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'CamilloBruni 8/3/2012 15:36'!
nativeFunction
	^ nativeFunction! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/3/2010 22:12'!
nb
	^ NativeBoost forCurrentPlatform ! !

!NBNativeFunctionGen methodsFor: 'code generation' stamp: 'IgorStasenko 5/28/2012 07:20'!
prepareArguments

	| args offset |
	
	(self optCdecl or: [ self optStdcall ]) ifTrue: [
		args := fnSpec arguments.
	].
	
	offset := 8.  "+ return address + EBP"
	stackSize := 0.
	args withIndexDo: [:arg :i |  | sz |
		"arg size is 4 or 8"
		sz := arg type stackSize.
		stackSize := stackSize + sz.
		arg offset: offset.
		offset := offset + sz.
	].
! !

!NBNativeFunctionGen methodsFor: 'convenience' stamp: 'CamilloBruni 7/23/2012 16:55'!
return
	"Generate a jump to the return label.
	Use this function instead of directly calling #ret, #leave on the assembler if you want to rely on the default cleanup instructions generated by me"
	asm jmp: self returnLabel.! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'CamilloBruni 7/23/2012 16:39'!
returnLabel
	^ returnLabel ifNil: [ 
		returnLabel := asm uniqueLabelName: 'Return' ]! !

!NBNativeFunctionGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/7/2010 22:31'!
stackSize
	^ stackSize! !

!NBNativeFunctionGen methodsFor: 'installing' stamp: 'IgorStasenko 8/23/2012 18:04'!
uninstall
	"uninstall the code from a memory heap"
	
	nativeFunction ifNotNil: [ nativeFunction uninstall ].! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 2/13/2012 14:50'!
assertIsNBMethod: aMethod

	"Check that method having a native-boost primitive"
	
	
		((aMethod primitive = 117) and: [  | lit |  lit := aMethod literalAt: 1. 
			lit first = #NativeBoostPlugin and: [ lit second == #primitiveNativeCall]]) ifFalse: [ ^NBNativeCodeError signalError: ErrNoNBPrimitive ].! !

!NBNativeCodeGen class methodsFor: 'debugging' stamp: 'Igor.Stasenko 4/28/2010 18:13'!
debugOff

	DebugOn := false! !

!NBNativeCodeGen class methodsFor: 'debugging' stamp: 'Igor.Stasenko 5/2/2010 18:05'!
debugOn

	DebugOn := true! !

!NBNativeCodeGen class methodsFor: 'options' stamp: ''!
defaultOptions

	^ #() ! !

!NBNativeCodeGen class methodsFor: 'instance creation' stamp: 'IgorStasenko 9/23/2012 04:31'!
generateCode: aBlock andRetry: retryCtx

	| method bytes newMethod args |

	method := retryCtx method.

	NBRecursionDetect in: method during: [ 
		bytes := aBlock value: (self newForMethod: method).
	].

	DebugOn == true ifTrue: [ 
		(FileStream newFileNamed: 'asm.bin') nextPutAll: bytes; close.
		self halt ].
	
	newMethod := self installNativeCode: bytes into: method.
	
	newMethod primitive = self jitPrimitiveNumber ifTrue: [ newMethod forceJIT ].
	^ self retrySend: retryCtx
! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 9/20/2012 14:43'!
getErrorFrom: aContext lastError: errorCode
	| lastError method |
	lastError := errorCode.
	method := aContext method.

	"Check that method has a #primitiveNativeCall, since it required by generator, and sometimes you can forget putting primitive pragma"
	(method primitive = 220 or: [
	((method primitive = 117) and: [  | lit |  lit := method literalAt: 1. 
			lit first = #NativeBoostPlugin and: [ lit second == #primitiveNativeCall]])])
		ifFalse: [ ^ ErrNoNBPrimitive ].
		
	"Check if method using an extended primitive pragma (introduced in Cog), 
	otherwise we just take an errorCode"
	(method pragmas anySatisfy: [:p | p keyword == #primitive:module:error: ])
	ifTrue: [
		"A primitive error is always the last temp (ensured by compiler) "
		lastError := aContext  tempAt: method numTemps. 
	].
	
	lastError = ErrNotEnabled ifTrue: [
		"If we cannot enable it, report an error..."
		NativeBoost enableNativeCode ifFalse: [ ^ NBNativeCodeError signal: 'Cannot enable native code execution' ].
	
		" Fake absence of native code, so then code generator will generate code and retry the call.
		Note that if you want to keep native code forever (generated once and kept forever as long as method exists), you might want to override this"
		
		lastError := ErrNoNativeCodeInMethod ].

	^ lastError ! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 9/21/2012 15:48'!
getErrorFromJit: aContext
	| lastError method |
	method := aContext method.

	"Check that method has a primitive 220"
	(method primitive = self jitPrimitiveNumber)
		ifFalse: [ ^ ErrNoNBPrimitive ].

	(method pragmas anySatisfy: [:p | p keyword == #primitive:error: ])
	ifTrue: [
		"A primitive error is always the last temp (ensured by compiler) "
		lastError := aContext  tempAt: method numTemps. 
	] ifFalse: [ lastError := ErrInvalidPrimitiveVoltageUse ].

	^ lastError ! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 2/20/2012 13:48'!
handleFailureIn: aContext nativeCode: aBlock

	| method lastError |

	"Note: make sure that #lastError are sent first, no guarantee that we won't be preempted before
	but this is best we can do if method is not using extended primitive pragma with error code"
	
	lastError := self getErrorFrom: aContext lastError: NativeBoost lastError.
	method := aContext method.

	"install native code and retry the send"
	lastError = ErrNoNativeCodeInMethod
		ifTrue: [ ^ self generateCode: aBlock andRetry: aContext ].

	"ok, we're out of options, signal an error here"
	^ self signalError: lastError
! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 11/9/2012 04:12'!
handleFailureInJit: aContext nativeCode: aBlock

	| method lastError |

	"Note: make sure that #lastError are sent first, no guarantee that we won't be preempted before
	but this is best we can do if method is not using extended primitive pragma with error code"
	
	lastError := self getErrorFromJit: aContext.
	method := aContext method.

	lastError = ErrRunningViaInterpreter ifTrue: [
		"a method contains native code, but executed by interpreter "
		method forceJIT ifFalse: [ self error: 'Failed to JIT the compiled method. Try reducing it''s size ' ].
		^ self retrySend: aContext
		].
	"install native code and retry the send"
	(lastError = ErrNoNativeCodeInMethod or: [ lastError isNil ] )
		ifTrue: [ ^ self generateCode: aBlock andRetry: aContext ].

	"ok, we're out of options, signal an error here"
	^ self signalError: lastError
! !

!NBNativeCodeGen class methodsFor: 'managing methods' stamp: 'IgorStasenko 2/13/2012 14:21'!
installNativeCode: bytes into: method 

	"install a native code into a compiled method"

	"Installing/removing native code directly:
		In some cases user(s) may need it, like in case if  you want to update/flush/recompile generated code 
		for a number of methods due to some change in environment.
	
		For example, my class(es) might have a 'DeveloperMode' flag, which depending on its value may affect a generated code
		in order to do some additional checks at runtime (when turned on), and suppress them (when turned off). 
		And so, in order to switch between those modes, we need a way to flush native code in affected methods.

		Also, since a plugin having no way to determine who provided a native code, users may implement own code generators
		(or just load code from file/cache) instead of using facilities provided by NativeBoost. "
	
	
	| trailer newMethod |
	trailer := CompiledMethodTrailer new.

	trailer 
		nativeCode: bytes
		platformId: NativeBoost platformId 
		sourcePointer: method trailer sourcePointer.
	newMethod :=  method copyWithTrailerBytes: trailer.
	method methodClass methodDict at: method selector put: newMethod.

	^ newMethod
! !

!NBNativeCodeGen class methodsFor: 'public API' stamp: 'CamilloBruni 10/4/2012 10:37'!
jitMethodAssembly: aBlock
	"This method will directly inline the nativecode in the jited
	method thus eliminating the overhead of running through the 
	whole primitive activation each time the method is invoked.
	Unlike in the cdecl style NativeBoost code generation the return
	value is passed in EDX and not in EAX."
	^ self handleFailureInJit: thisContext sender nativeCode:
		[:gen | aBlock cull: gen cull: gen proxy cull: gen asm. gen bytes ]
! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 9/20/2012 14:48'!
jitPrimitiveNumber
	^ 220! !

!NBNativeCodeGen class methodsFor: 'public API' stamp: 'HenrikSperreJohansen 8/23/2011 02:34'!
methodAssembly: aBlock

	"We're get here from a method, which contains  a native code.
	There are following error cases:
	  - method does not contains a NativeBoost primitive
	  - method's native code platform id doesn't match the current platform id
	  - method having no native code generated yet
	  - a native code runs but caused primitive failure
	"
	
	^ self handleFailureIn: thisContext sender nativeCode:
		[:gen | aBlock cull: gen cull: gen proxy cull: gen asm. gen bytes ]
! !

!NBNativeCodeGen class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 13:34'!
nativeMethods
	" self nativeMethods "
	^ CompiledMethod allInstances select: [:m |
		m trailer kind = #NativeCodeTrailer 
		and: [ m isInstalled ] ]! !

!NBNativeCodeGen class methodsFor: 'instance creation' stamp: 'HenrikSperreJohansen 8/23/2011 22:10'!
newForMethod: aMethod
	^self new setMethod: aMethod! !

!NBNativeCodeGen class methodsFor: 'managing methods' stamp: 'IgorStasenko 2/13/2012 14:21'!
removeNativeCodeFrom: method
	"Installing/removing native code directly:
		In some cases user(s) may need it, like in case if  you want to update/flush/recompile generated code 
		for a number of methods due to some change in environment.
	
		For example, my class(es) might have a 'DeveloperMode' flag, which depending on its value may affect a generated code
		in order to do some additional checks at runtime (when turned on), and suppress them (when turned off). 
		And so, in order to switch between those modes, we need a way to flush native code in affected methods.

		Also, since a plugin having no way to determine who provided a native code, users may implement own code generators
		(or just load code from file/cache) instead of using facilities provided by NativeBoost. "

	|trailer|
	trailer := method trailer.
	trailer kind == #NativeCodeTrailer ifTrue: [  "it _should_ be true.. but lets check to be sure"
		| newTrailer |
		newTrailer := CompiledMethodTrailer new sourcePointer: trailer sourcePointer.
			
		method isInstalled ifTrue: [
			method methodClass methodDict 
				at: method selector 
				put:  ( method copyWithTrailerBytes: newTrailer)
			]
	]! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 9/23/2012 03:38'!
retrySend: retryCtx

	| method args |

	method := retryCtx method.

	"just resending the same message"
	args := Array new: method numArgs.
	1 to: args size do: [ :i |  args at: i put: (retryCtx tempAt: i) ].

	thisContext terminateTo: retryCtx sender. 
	^ retryCtx receiver perform: method selector withArguments: args.
! !

!NBNativeCodeGen class methodsFor: 'error handling' stamp: 'IgorStasenko 2/20/2012 13:48'!
signalError: errorCode
	^ NBNativeCodeError signalError: errorCode
! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/11/2010 09:04'!
asm

	^ asm! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'IgorStasenko 8/3/2011 20:08'!
bytes
	^ self generatedCode bytes! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 10:18'!
defaultOptions

	^ self class defaultOptions! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 13:45'!
doesNotUnderstand: message

	(message selector isUnary and: [ message selector beginsWith: 'opt'] )
		ifTrue: [ ^ options includes: message selector ].
		
	^ super doesNotUnderstand: message! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'Igor.Stasenko 4/25/2010 01:05'!
dumpBytes
	^ String streamContents: [:str |
		self bytes do: [:b | str nextPutAll: (b printStringBase: 16); space ]
		]
! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'Igor.Stasenko 5/2/2010 13:03'!
emitFetchClass: aClass
	"emit code, which fetching the class oop into EAX"
	^  NativeBoost extraRootsRegistry emitFetchClass: aClass generator: self ! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'CamilloBruni 7/23/2012 16:40'!
epilogue

	asm emitEpilogue: 0. ! !

!NBNativeCodeGen methodsFor: 'retrieving the code' stamp: 'IgorStasenko 8/3/2011 20:15'!
generatedCode

	proxy usedGate ifTrue: [
		asm reserveExtraBytesOnStack: asm wordSize*2.
		].
	
	self optDebug ifTrue: [ self halt. ].

	^ asm generatedCode.
! !

!NBNativeCodeGen methodsFor: 'initialize-release' stamp: 'IgorStasenko 5/9/2011 13:12'!
initialize
	asm := self newAssembler.
	options := Set new.
	proxy := NBInterpreterProxy forGenerator: self. 
	self parseOptions: self defaultOptions.

! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'HenrikSperreJohansen 8/23/2011 22:08'!
method
	^method! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'IgorStasenko 5/7/2011 21:27'!
newAssembler

	^ NativeBoost newAssembler 
! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 10:56'!
optionAt: optionName

	^ options includes: optionName! !

!NBNativeCodeGen methodsFor: 'options' stamp: 'Igor.Stasenko 5/1/2010 10:55'!
parseOptions: optionsArray

	"parse an array, which is a sequence of options in a form of: 
	
	#( + option1 option2 - option3 ... )
	
	each time the #+ is seen, the options which follow it will be subject for inclusion
	and, correspondingly, if #- seen, then they will be excluded	.

	By default, (if none of #+ or #- specified initially), all options are subject for inclusion.
	"
	| include |
	
	include := true.
	
	optionsArray do: [:option |
		option == #+ 
			ifTrue: [ include := true ]
			ifFalse: [
				option == #- 
					ifTrue: [ include := false ]
					ifFalse: [ 
						include ifTrue: [ options add: option ] 
						ifFalse: [ options remove: option ifAbsent:[] ]]]
		].! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/1/2010 10:27'!
proxy
	^ proxy! !

!NBNativeCodeGen methodsFor: 'temporaries' stamp: 'IgorStasenko 5/9/2011 12:55'!
releaseTemps: count
	asm releaseTemps: count! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'IgorStasenko 8/5/2011 07:38'!
reserveStackBytes: numBytesOrBlock

	"emit code to reserve a given number of bytes, answer the temp,
	which will hold an allocated block address "
	
	| address |
	address := self reserveTemp.
	^ self reserveStackBytes: numBytesOrBlock andStoreAddrTo: address! !

!NBNativeCodeGen methodsFor: 'code generation' stamp: 'Igor.Stasenko 4/28/2010 13:48'!
reserveStackBytes: numBytesOrBlock andStoreAddrTo: aTemp

	"emit code to reserve a given number of bytes, answer the temp,
	which will hold an allocated block address "
	
	| numBytes |

	numBytes := numBytesOrBlock. 
	numBytesOrBlock isBlock ifTrue: [ numBytes := numBytesOrBlock value: self ].
	
	numBytes = EAX ifFalse: [
		asm mov: numBytes to: EAX ].
	
	"align stack to 4-bytes (will waste 4 bytes if its already aligned)"
	asm
		or: EAX with: 3;
		inc: EAX	;
		sub: ESP with: EAX;
		mov: ESP to: aTemp.  "store the allocated space start into a temp"
	^ aTemp
! !

!NBNativeCodeGen methodsFor: 'temporaries' stamp: 'IgorStasenko 5/9/2011 12:55'!
reserveTemp
	^ asm reserveTemp! !

!NBNativeCodeGen methodsFor: 'initialize-release' stamp: 'HenrikSperreJohansen 8/23/2011 22:09'!
setMethod: aMethod
	method := aMethod

! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'IgorStasenko 8/10/2011 15:08'!
stackAlignment

	^ self utils stackAlignment ! !

!NBNativeCodeGen methodsFor: 'accessing' stamp: 'IgorStasenko 8/10/2011 15:08'!
utils
	^ NativeBoost forCurrentPlatform! !

Object subclass: #NBObjectFormat
	instanceVariableNames: 'asm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBObjectFormat commentStamp: 'Igor.Stasenko 5/19/2010 11:12' prior: 0!
i am exposing an object format to ease accessing various object fields directly,
without calling interpreter proxy functions, where it is appropriate!

!NBObjectFormat class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 12/21/2011 14:20'!
current
	"answer an new instance of object format representing an object format of currently running system"
	^ NBObjectFormat32 new! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/20/2010 05:54'!
asm: anAsm
	asm := anAsm! !

!NBObjectFormat methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:44'!
baseHeaderSize

	^ self oopSize! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/20/2010 05:52'!
indexableWordsFormat
	self subclassResponsibility ! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:53'!
instVarOffsetAt: ivarIndex
	"answer an offset of instance variable with given 1-based index,
	relative to some oop"
	self subclassResponsibility ! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/23/2011 10:44'!
isCogVM

	^ (Smalltalk vm version beginsWith: 'Squeak') not! !

!NBObjectFormat methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:27'!
oopSize

	self subclassResponsibility ! !

!NBObjectFormat methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:51'!
stackArgumentSize

	"a default number of bytes on stack used by a single argument,
	for calling proxy functions"
	"In most cases, this will the same as oopSize, but not necessarily"
	^self subclassResponsibility! !

!NBObjectFormat methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:47'!
varBytesFirstField
	" answer an offset of first byte of variable-bytes oop, relative to object pointer"
	"In object formats where additional header fields are stored before the base header, this is just the size of the header"
	^ self baseHeaderSize
! !

NBObjectFormat subclass: #NBObjectFormat32
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'AJx86Registers'
	category: 'NativeBoost-Core'!

!NBObjectFormat32 commentStamp: 'Igor.Stasenko 5/19/2010 11:13' prior: 0!
- an object format for 32-bit images!

!NBObjectFormat32 class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 11/24/2012 17:22'!
headerOf: anObject

	<primitive: #primitiveNativeCall module: #NativeBoostPlugin >
	
	^ self nbCallout function: #( ulong (oop anObject) ) emit: [:gen |
		gen asm pop: gen asm EAX.
		gen asm mov: gen asm EAX ptr to: gen asm EAX
		]! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'Igor.Stasenko 5/20/2010 03:35'!
compactClassIndexShift
	"answer a compact class index shift"
	^ 12
! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/22/2011 23:19'!
compactClassMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000011111000000000000
! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'HenrikSperreJohansen 8/22/2011 22:11'!
fixedFieldsFormat
 	" fixed fields only (all containing pointers) "
 	^ 2r0001! !

!NBObjectFormat32 methodsFor: 'testing' stamp: 'Igor.Stasenko 9/29/2010 10:58'!
floatsMatchingPlatform
	"Answer true if floats are store in platform native endianesness.
	
	This is false for Squeak on x86 , since they are always stored in bigendian format.
	Cog promising to always use native format for floats.
	"
	
	^ self isCogVM! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/22/2011 23:16'!
headerTypeMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000000000000000000011
! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/22/2011 23:16'!
identityHashMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00011111111111100000000000000000
! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'CamilloBruni 7/23/2012 13:29'!
ifImmediate: aLocation jumpTo: aLabel
	"Jump to aLabel, if the OOP in aLocation is that of an immediate smallinteger"
	asm decorateWith: '#jumpTo:ifImmediate::' 
	during: [ asm 
				test: aLocation with: 1;
				jnz: aLabel ]! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'CamilloBruni 7/23/2012 13:29'!
ifWordsOOP: aLocation storeHeaderIn: destinationLocation ifNotJumpTo: aLabel
	asm decorateWith: '#jumpTo:ifNotWordsOOP:' during: [ 
	asm 	
		mov: aLocation ptr to: destinationLocation;
		test: destinationLocation with: (self indexableWordsFormat bitShift: self objectFormatShift);
		jz: aLabel
	]! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'HenrikSperreJohansen 8/22/2011 23:01'!
immediateShift

	^ 24! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'HenrikSperreJohansen 8/22/2011 22:11'!
indexableBytesFormat
	" 8-11      indexable byte fields only (no pointers) (low 2 bits are low 2 bits of size) "
	^ 2r1000! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'HenrikSperreJohansen 8/22/2011 22:11'!
indexableWordsFormat
	" indexable word fields only (no pointers) "
	^ 2r0110! !

!NBObjectFormat32 methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:53'!
instVarOffsetAt: index
	"answer an offset of instance variable with given 1-based index,
	relative to some oop"
	^ self baseHeaderSize + (self oopSize*(index-1)).! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/22/2011 22:26'!
isBytes2: oop ifNotJumpTo: label

	asm 
		mov: oop to: EAX;
		test: AL with: 1;
		jne: label;
		"mov: EAX ptr to: ECX;"
		"and: ECX with: self objectFormatMask;"
		test: EAX with: (self indexableBytesFormat bitShift: self objectFormatShift);
		jz: label! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'Igor.Stasenko 5/20/2010 07:25'!
isBytes: oop ifNotJumpTo: label

	asm 
		mov: oop to: EAX;
		test: AL with: 1;
		jne: label;
		mov: EAX ptr to: ECX;
		and: ECX with: self objectFormatMask;
		cmp: ECX with: (self indexableBytesFormat bitShift: self objectFormatShift);
		jl: label! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'CamilloBruni 7/23/2012 13:29'!
isBytesOrWords: oop ifNotJumpTo: label
	| gotIt |
	gotIt := asm uniqueLabelName: 'gotit'.
	asm decorateWith: '#isBytesOrWords:ifNotJumpTo:' during: [ 
	asm 
		mov: oop to: EAX;
		test: AL with: 1;
		jne: label;
		mov: EAX ptr to: ECX;
		and: ECX with: self objectFormatMask;
		cmp: ECX with: (self indexableWordsFormat bitShift: self objectFormatShift);
		je: gotIt;
		cmp: ECX with: (self indexableBytesFormat bitShift: self objectFormatShift);
		jl: label;
		label: gotIt
	]! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'CamilloBruni 7/23/2012 13:29'!
jumpTo: aLabel ifImmediate: aLocation
	asm decorateWith: '#jumpTo:ifImmediate::' 
	during: [ asm 
				test: aLocation with: 1;
				jnz: aLabel ]! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'CamilloBruni 7/23/2012 13:29'!
jumpTo: aLabel ifNotWordsOOP: aLocation
	asm decorateWith: '#jumpTo:ifNotWordsOOP:' during: [ 
	self ifImmediate: aLocation jumpTo: aLabel .
	asm 	
		push: asm EAX;
		mov: aLocation ptr to: asm EAX;
		test: asm EAX with: (self indexableWordsFormat bitShift: self objectFormatShift);
		pop: asm EAX;
		jz: aLabel
	]! !

!NBObjectFormat32 methodsFor: 'object formats' stamp: 'Igor.Stasenko 5/20/2010 06:06'!
noFieldsFormat
	^ 0! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/23/2011 21:41'!
objectFormatMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000000000111100000000
! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'HenrikSperreJohansen 8/23/2011 00:05'!
objectFormatShift

	^ 8! !

!NBObjectFormat32 methodsFor: 'header fields' stamp: 'HenrikSperreJohansen 8/23/2011 21:41'!
objectSizeMask

	"answer a bit mask for a compact class index in base header "
	" ggghhhhhhhhhhhhcccccffffsssssstt "
	^ 2r00000000000000000000000011111100
! !

!NBObjectFormat32 methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/19/2010 11:29'!
oopSize

	^ 4! !

!NBObjectFormat32 methodsFor: 'emitting tests' stamp: 'HenrikSperreJohansen 8/23/2011 01:51'!
sizeOf: headerRegister is: anImmediate ifNotJumpTo: aLabel
	asm 	and: headerRegister with: self objectSizeMask;
		xor: headerRegister with: (anImmediate bitShift: self sizeShift);
		jnz: aLabel! !

!NBObjectFormat32 methodsFor: 'header shifts' stamp: 'HenrikSperreJohansen 8/23/2011 00:55'!
sizeShift

	^ 2! !

!NBObjectFormat32 methodsFor: 'sizes' stamp: 'HenrikSperreJohansen 8/23/2011 21:50'!
stackArgumentSize

	"a default number of bytes on stack used by a single argument,
	for calling proxy functions"
	
	^self oopSize! !

!NBObjectFormat32 methodsFor: 'testing' stamp: 'IgorStasenko 8/5/2011 18:14'!
stackGrowsDown

	"Squeak interpreter stack grows up, while StackInterpreter down"
	^ self isCogVM! !

Object subclass: #NBProxyFunction
	instanceVariableNames: 'selector retType arguments index majorVersion minorVersion requiresAlignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NativeBoost-Core'!

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:14'!
= object
	^ self class == object class and: [ selector == object selector ]! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 03:34'!
address
	self assert: (index < NBInterpreterProxy functions size).
	
	self checkVersion.
	^ NBInterpreterProxy fnAddressAt: index! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
arguments

	^arguments! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
arguments: anObject

	arguments := anObject! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/29/2010 07:36'!
checkVersion

	"exclude basic functions, otherwise we enter an endless chicken and egg loop"
	minorVersion = 0 ifTrue:  [ ^ self ].
		
	self assert: (NBInterpreterProxy majorVersion = majorVersion
		and: [ NBInterpreterProxy minorVersion >= minorVersion]).
! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:13'!
hash
	^ selector hash! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:35'!
index
	^ index! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:34'!
index: anIndex
	index := anIndex! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
majorVersion

	^majorVersion! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
majorVersion: anObject

	majorVersion := anObject! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
minorVersion

	^minorVersion! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
minorVersion: anObject

	minorVersion := anObject! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'IgorStasenko 5/11/2011 16:50'!
name
	^ selector ! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 9/29/2010 09:24'!
parseArguments: args 
	" not userful, lets ignore it"

"	(args size = 1 and: [ args first == #void ]) ifTrue: [ arguments := #(). ^ self ].
	
	arguments := args collect: [:type |
		( #(sqInt sqIntPtr sqLong double charPtr voidPtr) includes: type ) ifFalse: [
			self error: 'invalid argument type'
		].
	
		type
	]"! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/11/2011 16:47'!
printOn: aStream

	aStream print: selector.
	arguments ifNotNil: [ 
		aStream  
		space;
		print: arguments ]! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 07:32'!
requiresAlignment 
	^ requiresAlignment ~~ false! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'IgorStasenko 8/3/2011 07:36'!
requiresAlignment: aBool
	requiresAlignment := aBool! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
retType

	^retType! !

!NBProxyFunction methodsFor: 'accessing' stamp: 'Igor.Stasenko 4/29/2010 03:29'!
retType: anObject

	retType := anObject! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:14'!
selector
	^ selector! !

!NBProxyFunction methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 4/9/2010 07:22'!
selector: aSelector

	selector := aSelector! !

Object subclass: #NativeBoost
	instanceVariableNames: 'bootstrapping insideCallback callbackCounterAddr extraRootsRegistry rootsCell gateFunction'
	classVariableNames: 'Current NBAnnouncer'
	poolDictionaries: 'AJx86Registers NativeBoostConstants'
	category: 'NativeBoost-Core'!

!NativeBoost commentStamp: '<historical>' prior: 0!
i am a core class, which provides a common functionality, 
required by many NativeBoost facilities to function, including:

- basic memory operations
- external roots registry
- call gate function
- session management

Every new session, i using an unique instance,
which is platform specific (see my subclasses).

To access a current session instance, you can issue:

NativeBoost forCurrentPlatform

!

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 9/26/2010 04:58'!
CLibrary
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	^ self forCurrentPlatform CLibrary! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'JavierPimas 9/27/2011 14:48'!
VMModule
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	^ self forCurrentPlatform VMModule! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/5/2010 14:55'!
allocate: size
	^ self forCurrentPlatform allocate: size! !

!NativeBoost class methodsFor: 'accessing' stamp: 'IgorStasenko 3/28/2012 17:44'!
announcer
	^ NBAnnouncer ifNil: [ NBAnnouncer := Announcer new ].! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 19:10'!
callgateFunctionAddress
	^ self forCurrentPlatform callgateFunctionAddress! !

!NativeBoost class methodsFor: 'accessing' stamp: 'IgorStasenko 5/10/2011 15:27'!
clearNativeCode

	"Unconditionally clear all method's native code trailers using a single bulk-become"
	| old new |

	self isEnabled ifFalse: [ Current := nil ].
	
	Current ifNotNil: [
		Current insideCallback ifTrue: [
			self error: 'Clearing a native code while inside a callback' ]].
	
	old := OrderedCollection new.
	new := OrderedCollection new.
	
	CompiledMethod allInstancesDo: [:method | | trailer |
		trailer := method trailer.
		trailer kind == #NativeCodeTrailer ifTrue: [
			old add: method.
			new add: (method copyWithTrailerBytes: 
				(CompiledMethodTrailer new sourcePointer: trailer sourcePointer))
			]
	]. 
	
	old asArray elementsForwardIdentityTo: new asArray

! !

!NativeBoost class methodsFor: 'system startup' stamp: 'IgorStasenko 5/11/2011 00:55'!
discoverPlatformId
	
	| platId |
	
	"should not use it, if Current already set"
	self assert: (Current isNil). 

	platId := self platformId. 

	self allSubclassesDo: [:class |
		class targetPlatformId = platId ifTrue: [ 
			class new  " should set Current during initialization"
	]].

	Current isNil ifTrue: [ self unsupportedPlatform ].
	
	^ Current ! !

!NativeBoost class methodsFor: 'system startup' stamp: 'IgorStasenko 5/11/2011 00:50'!
enableNativeCode
	"Enable the native code,
	answer true if operation was successfull or false if not"
	
	self isEnabled ifFalse: [
		"If native code is disable in plugin, this means 
		that a system is just started.
		Create a fresh instance of receiver "

		Current := nil. 
	].
	self forCurrentPlatform. 

	^ Current notNil! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/2/2010 13:04'!
extraRootsRegistry

	^ self forCurrentPlatform extraRootsRegistry! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/18/2010 23:14'!
forCurrentPlatform

	"answer my subclass instance, suitable for use on current platform"
	self isEnabled ifFalse: [ Current := nil ].
	
	^ Current ifNil: [ self discoverPlatformId ]! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/5/2010 14:55'!
free: address
	^ self forCurrentPlatform free: address! !

!NativeBoost class methodsFor: 'class initialization' stamp: 'IgorStasenko 3/19/2012 12:43'!
initialize 
"self initialize"

	self registerPrimitiveSimulators! !

!NativeBoost class methodsFor: 'testing' stamp: 'Igor.Stasenko 9/26/2010 06:28'!
insideCallback
	^ self forCurrentPlatform insideCallback! !

!NativeBoost class methodsFor: 'testing' stamp: 'Igor.Stasenko 5/2/2010 11:00'!
isEnabled
	"Answer flag indicating whether running a native code enabled by plugin"
	
	<primitive: #primitiveIsEnabled module: #NativeBoostPlugin>
	
	^ self primitiveFailed! !

!NativeBoost class methodsFor: 'testing' stamp: 'IgorStasenko 5/28/2012 03:49'!
isEnabledOrNil
	"Answer flag indicating whether running a native code enabled by plugin"
	
	<primitive: #primitiveIsEnabled module: #NativeBoostPlugin>
	
	^ nil! !

!NativeBoost class methodsFor: 'debugger support' stamp: 'Igor.Stasenko 5/17/2010 22:01'!
isNativeMethod: aCompiledMethod
	| lit |
	
	lit := aCompiledMethod literalAt: 1.
	^ aCompiledMethod trailer kind == #NativeCodeTrailer 
		and: [ lit first == #NativeBoostPlugin and: [ lit second == #primitiveNativeCall]]! !

!NativeBoost class methodsFor: 'errors' stamp: 'IgorStasenko 8/6/2011 17:42'!
lastError
	<primitive: #primitiveLastNativeCodeError module: #NativeBoostPlugin>
	^ self error: 'NativeBoost plugin is not installed?'! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'CamilloBruni 7/19/2012 11:50'!
loadFunction: fnName

	^ self loadFunction: fnName from: ''! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'CamilloBruni 7/19/2012 11:50'!
loadFunction: fnName from: aModuleName

	^ self forCurrentPlatform 
		loadFunction: fnName from: aModuleName! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'CamilloBruni 7/19/2012 11:51'!
loadSymbol: aSymbolName
	^ self loadSymbol: aSymbolName fromModule: ''! !

!NativeBoost class methodsFor: 'retrieving symbols' stamp: 'CamilloBruni 7/19/2012 11:50'!
loadSymbol: aSymbolName fromModule: moduleName
	^ self forCurrentPlatform 
		loadSymbol: aSymbolName fromModule: moduleName! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/13/2010 23:06'!
memCopy: src to: dst size: numBytes
	^ self forCurrentPlatform memCopy: src to: dst size: numBytes! !

!NativeBoost class methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/5/2010 16:46'!
newAssembler
	^ self forCurrentPlatform  newAssembler! !

!NativeBoost class methodsFor: 'subscribing for session change' stamp: 'IgorStasenko 3/28/2012 17:48'!
notifyAboutSessionChange: anObject
	"register an object to be notified about session change"
	self announcer weak on: NBSessionChangeAnnouncement send: #nbSessionChanged  to: anObject
! !

!NativeBoost class methodsFor: 'platform id' stamp: 'Igor.Stasenko 5/2/2010 11:07'!
platformId

	<primitive: 'primitivePlatformId' module: 'NativeBoostPlugin'>
	
	" do not fail, answer nil instead"
	^ nil! !

!NativeBoost class methodsFor: 'testing' stamp: 'Igor.Stasenko 9/25/2010 05:16'!
primitiveLoadMainModule
	"Answer flag indicating whether running a native code enabled by plugin"
	
	<primitive: #primitiveLoadMainModule module: #NativeBoostPlugin>
	
	^ self primitiveFailed! !

!NativeBoost class methodsFor: 'debugger support' stamp: 'IgorStasenko 3/19/2012 12:42'!
registerPrimitiveSimulators

	ContextPart simulatePrimitive: #primitiveNativeCall module: #NativeBoostPlugin with: self! !

!NativeBoost class methodsFor: 'private' stamp: 'IgorStasenko 5/11/2011 00:48'!
resetInstance
	"!!!!!!!! Never use it !!!!!!!!
	It is here only for development purposes"

	Current := nil.! !

!NativeBoost class methodsFor: 'testing' stamp: 'IgorStasenko 5/28/2012 03:58'!
sessionChanged: anOldSession

	"Answer true if session has changed.
	Do a quick test if NB plugin is not enabled yet to prevent fails in
	resource finalization during image startup.
	
	anOldSession is object which retrieved before, using #uniqueSessionObject message.
	"
	self isEnabledOrNil == true ifTrue: [
		Current ifNil: [ ^ true ].
		^ (Current callgateFunctionAddress  == anOldSession) not
	].
	"plugin is not enabled, or prim failed, assume session changed"
	^ true
	
! !

!NativeBoost class methodsFor: 'debugger support' stamp: 'IgorStasenko 3/19/2012 13:17'!
simulatePrimitiveFor: aMethod receiver: recvr arguments: args context: ctx

	^ self tryRunNativeCode: aMethod for: recvr withArgs: args! !

!NativeBoost class methodsFor: 'platform id' stamp: 'Igor.Stasenko 4/29/2010 04:27'!
targetPlatformId

	"Should be implemented by subclasses to indicate a target platform.
	
	Answer zero - a non-existing platform id
	"
	
	^ 0! !

!NativeBoost class methodsFor: 'debugger support' stamp: 'IgorStasenko 3/19/2012 13:38'!
tryRunNativeCode: aCompiledMethod for: aReceiver withArgs: arguments
	"run only a native code of given method,
	and if it fails evaluate aFailBlock instead"
	| src node m |
	"self assert: (self isNativeMethod: aCompiledMethod)."
	
	src := String streamContents: [:str |
		str nextPutAll: 'NBDebug_stub'.
		1 to: aCompiledMethod numArgs do: [:i  |
			i = 1 
				ifTrue: [ str nextPutAll: ': ' ]
				ifFalse: [ str nextPutAll: ' with: ' ].
			str nextPutAll: 'arg'.
			i printOn: str.
		].
		str cr;
		nextPutAll: ' <primitive: #primitiveNativeCall module: #NativeBoostPlugin error: errorCode >'; cr;
		nextPutAll: ' ^ ContextPart primitiveFailTokenFor: errorCode'.
	].

	node := Compiler new 
		compile: src 
		in: aCompiledMethod methodClass
		classified: nil 
		notifying: nil 
		ifFail: [ ^ ContextPart primitiveFailTokenFor: nil ].

	m := node generate: aCompiledMethod trailer.
	m flushCache.
	m selector flushCache.
	
	^ m valueWithReceiver: aReceiver arguments: arguments.
	! !

!NativeBoost class methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/3/2010 10:27'!
ulongAt: ulongAddr
	^ self forCurrentPlatform ulongAt: ulongAddr! !

!NativeBoost class methodsFor: 'accessing' stamp: 'IgorStasenko 5/28/2012 08:13'!
uniqueSessionObject
	"Answer an unique session object, which changes between
	image restarts.
	A call gate function is a good candidate for this, since its generated each time
	when image first boots. "

	^ self forCurrentPlatform callgateFunctionAddress ! !

!NativeBoost class methodsFor: 'errors' stamp: 'IgorStasenko 5/11/2011 00:55'!
unsupportedPlatform 
	self error: 'You running on platform which not supported by NativeBoost'! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 9/26/2010 04:59'!
CLibrary
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'JavierPimas 9/27/2011 14:47'!
VMModule
	"answer a C library path, or module handle,
	use in FFI callouts as module: argument to call C run-time library function(s)"
	
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/25/2010 10:03'!
allocate: aSize
	"Allocate a memory block with given size in bytes,
	answer an NBExternalAddress instance - address to the beginning of memory block"
	
	" DO NOT OVERRIDE. Override #basicAllocate: instead"
	| addr |
	addr := self basicAllocate: aSize.
	addr ifNil: [ self allocationFailed ].
	^ addr! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 5/3/2010 11:03'!
allocationFailed

	self error: 'Memory allocation failed'! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 5/3/2010 10:58'!
basicAllocate: aSize
	"Allocate a memory block with given size in bytes,
	answer an NBExternalAddress instance - address to the beginning of memory block,
	or nil if allocation fails."
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'IgorStasenko 11/24/2012 15:52'!
bootstrapLoadFunction: fnName from: aModuleName into: returnValueBuffer
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	" call an interpreter proxy function 
		void* ioLoadFunctionFrom(char*, char*)
	to retrieve a function pointer of a registered module
	"
	^ self nbCallout 
		function: #( NBBootstrapUlong (String fnName,  String aModuleName) )
		emit: [:gen |	gen proxy callFn: #ioLoadFunction:From: ].
	! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'IgorStasenko 11/24/2012 15:55'!
bootstrapLoadModule: aModuleName ofLength: len into: returnValueBuffer
	" call an interpreter proxy function 
		void* ioLoadModuleOfLength(char*, int)
	to retrieve an external module handle
	
	Returning a long 32 bit value may trigger GC. So, we need a gate function for it,
	which we can't have without loading external stuff, so we store result into a byte array
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		options: #( - optDirectProxyFnAddress optAllowExternalAddressPtr);
		function: #( NBBootstrapUlong (byte * aModuleName , long len) )
		emit:  [:gen | 	gen proxy callFn: #ioLoadModule:OfLength: .  ] 
! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'IgorStasenko 11/24/2012 15:56'!
bootstrapLoadSymbol: symbolName ofLength: symbolLen fromModule: moduleHandle
into: returnValueBuffer

	" call an interpreter proxy function 
void *ioLoadSymbolOfLengthFromModule(sqInt functionNameIndex, sqInt functionNameLength, void *moduleHandle)
		
	to retrieve an external module handle
	
	Returning a long 32 bit value may trigger GC which can move native code.
	In order to avoid that, we don't use any proxy function, which may lead to memory allocation.
	Thus, we store result into a byte array.
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout 
		options: #( - optDirectProxyFnAddress optAllowExternalAddressPtr);
		function: #( NBBootstrapUlong (byte * symbolName , long symbolLen, ulong moduleHandle) )
		emit:  [:gen |
			gen proxy callFn: #ioLoadSymbol:OfLength:FromModule: 
		] ! !

!NativeBoost methodsFor: 'callback support' stamp: 'Igor.Stasenko 9/26/2010 04:37'!
callbackCounterAddress
	^ callbackCounterAddr! !

!NativeBoost methodsFor: 'accessing' stamp: 'IgorStasenko 5/28/2012 07:00'!
callgateFunctionAddress
	
	^ gateFunction ifNil: [
		| bytes addr |

		NBRecursionDetect 
			in: #callgateFunctionAddress during: [		

			bytes := self generateCallgateCode.
			self assert: (bytes class isBytes).
		
			addr := self allocate: bytes size.
			"copy generated bytes to external memory"
			self memCopy: bytes to: addr size: bytes size.

		].
	  
		"finally set the function address"
		gateFunction := addr. 
		bootstrapping := false.
		gateFunction 
	]
! !

!NativeBoost methodsFor: 'accessing' stamp: 'Igor.Stasenko 9/25/2010 10:12'!
extraRootsRegistry

	^ extraRootsRegistry ifNil: [
	
		rootsCell := self allocate: (self pointerSize).
		extraRootsRegistry := NBExtraRootsRegistry newWithCell: rootsCell
	]! !

!NativeBoost methodsFor: 'memory operations' stamp: 'Igor.Stasenko 9/26/2010 04:12'!
free: address

	"Free the external memory, allocated using #allocate: message.
	Note: never pass pointers, which you allocated by other means"
	
	self subclassResponsibility ! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'IgorStasenko 8/3/2011 09:22'!
generateCallgateCode
		
	"Answer a byte array of generated native code for gate function.
	We assume that caller reserves two temporaries on his stack frame
	[EBP-4], [EBP-8] for saving return address and pritimiveMethod oop"

	| asm primitiveMethod savedMethodOop returnAddr |

	asm :=  self newAssembler noStackFrame.

	savedMethodOop := EBP ptr - 4. 
	returnAddr := EBP ptr - 8.
	
	primitiveMethod := NBInterpreterProxy fnAddressAt: #primitiveMethod.
	
	asm
		mov: primitiveMethod to: EAX;
		call: EAX;  " retrieve a primitive method oop "
		mov: EAX to: savedMethodOop;
		pop: returnAddr; "store return address"
		pop: EAX; "function to call"
		call: EAX;  " call the function "
		push: returnAddr; "push return addr back on stack"
		push: EAX; " save return value "
		push: EDX;
		mov: primitiveMethod to: EAX;
		call: EAX;  " retrieve a primitive method oop "
		sub: EAX with: savedMethodOop;
		add: ESP ptr+8 with: EAX;  " current - old + returnAddress "
		pop: EDX;
		pop: EAX;
		ret.
		
	^ asm bytes
! !

!NativeBoost methodsFor: 'initialize-release' stamp: 'cipt 11/3/2012 18:28'!
initialize
	"once we have call gate function, we can turn bootstrapping mode off"
	bootstrapping := true.
	
	"first, wipe out all native code from image"
	self class clearNativeCode.
	
	"now, we can enable the native code"
	self primEnableNativeCode.
	
	Current := self.   "set the class var"

	"Init basic stuff"
	self initializeExternalHeap.
		
	"callback counter"
	callbackCounterAddr := self allocate: 4.
	callbackCounterAddr nbInt32AtOffset: 0 put:  0.

	" finally, generate callgate function to finish bootstrap procedure"
	self callgateFunctionAddress.

	"notify any observers about session change"
	self class announcer announce: NBSessionChangeAnnouncement ! !

!NativeBoost methodsFor: 'bootstrapping' stamp: 'Igor.Stasenko 5/2/2010 14:01'!
initializeExternalHeap
	
	"create and initialize a new instance of external memory heap"
	self subclassResponsibility! !

!NativeBoost methodsFor: 'callback support' stamp: 'cipt 11/3/2012 18:28'!
insideCallback
	bootstrapping ifTrue: [ ^ false ].
	^ (callbackCounterAddr nbInt32AtOffset:  0) ~= 0! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 11/24/2012 15:56'!
ioLoadFunction: fnName from: aModuleName
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	" call an interpreter proxy function 
		void* ioLoadFunctionFrom(char*, char*)
	to retrieve a function pointer of a registered module
	"
	^ self nbCallout
		function: #( ulong (String fnName,  String aModuleName) )
		emit: [:gen |	gen proxy callFn: #ioLoadFunction:From: ].
	! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'Igor.Stasenko 5/2/2010 16:35'!
ioLoadModule: aModuleName
	" call an interpreter proxy function 
		void* ioLoadModuleOfLength(char*, int)
	to retrieve an external module handle
	
	if module can't be loaded, or not found , answer nil
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ NBNativeCodeGen methodAssembly: [:gen |
		| fail retHandle proxy asm moduleNameOop end |
		moduleNameOop := gen reserveTemp.
		asm := gen asm.
		proxy := gen proxy.
		fail := asm uniqueLabelName: 'failed'.
		retHandle := asm uniqueLabelName: 'retHandle'.
		end := asm uniqueLabelName: 'end'.
		
		proxy stackValue: 0.
		asm mov: EAX to: moduleNameOop.
		proxy isBytes: EAX.
		asm or: EAX with: EAX.
		asm jz: fail.
		proxy byteSizeOf: moduleNameOop.
		asm push: EAX.   " push length "
	
		proxy firstIndexableField: moduleNameOop.
		asm push: EAX. "push first indexable field address"
		
		proxy callFn: #ioLoadModule:OfLength: .
		asm 
			or: EAX with: EAX;
			jnz: retHandle.
			
		proxy nilObject.
		asm jmp: end.
		
	asm label: retHandle.
		proxy signed32BitIntegerFor: EAX.
		asm jmp: end.
		
	asm label: fail.
		proxy primitiveFail.
	asm label: end.
		gen epilogue
	]
! !

!NativeBoost methodsFor: 'testing' stamp: 'Igor.Stasenko 9/25/2010 07:32'!
isBootstrapping
	^ bootstrapping! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 11/24/2012 15:57'!
loadFunction: fnName from: aModuleName
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>
	" call an interpreter proxy function 
		void* ioLoadFunctionFrom(char*, char*)
	to retrieve a function pointer of a registered module
	"
	^ self nbCallout 
		function: #( void* (String fnName,  String aModuleName) )
		emit: [:gen |	gen proxy callFn: #ioLoadFunction:From: ].
	! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 11/24/2012 15:58'!
loadModule: aModuleName
	" call an interpreter proxy function 
		void* ioLoadModuleOfLength(char*, int)
	to retrieve an external module handle
	
	if module can't be loaded, or not found , answer 0
	"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout
			options: #(- optAllowExternalAddressPtr);
			function: #( ulong (char* aModuleName, NBByteArraySize aModuleName ))
			emit: [:gen |
				gen proxy callFn: #ioLoadModule:OfLength: .
			] 
! !

!NativeBoost methodsFor: 'retrieving symbols' stamp: 'IgorStasenko 11/18/2012 17:05'!
loadSymbol: aSymbolName fromModule: moduleName
	"module could be a string (name) or handle "

	| bytes module handle |
	
	bytes := ByteArray new: 8.
	moduleName isString ifTrue: [
		
		self 
			bootstrapLoadModule: moduleName 
			ofLength: moduleName size 
			into: bytes.
	
		module := bytes unsignedLongAt: 1 bigEndian: false.
		module = 0 ifTrue: [ ^ nil ].
	] ifFalse: [
		"if value is negative, use 32-bit complement"
		module := moduleName bitAnd: 16rFFFFFFFF.
	].
	self bootstrapLoadSymbol: aSymbolName 
		ofLength: aSymbolName size fromModule: module into: bytes.

	handle := bytes unsignedLongAt: 1 bigEndian: false.
	handle = 0 ifTrue: [ ^ nil ].

	^ NBExternalAddress value: handle
! !

!NativeBoost methodsFor: 'memory operations' stamp: 'IgorStasenko 12/6/2012 14:43'!
memCopy: src to: dst size: numBytes
	"Copy the numBytes from src to dst memory buffer.

	src & dst can be either a variable-byte oop or NBExternalAddress instance.
	
	Warning!!!! Warning!!!! Warning!!!! 
	This is a direct memory accees!!!!!! No range checking!!!!!!
	"
	
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCallout
		options: #( + optAllowByteArraysPtr optAllowExternalAddressPtr);
	 	function: #( void (byte * src, byte * dst, ulong numBytes))
		emit: [:gen |
			| asm temp1 temp2 |
			asm := gen asm.
			temp1 := gen reserveTemp.
			temp2 := gen reserveTemp.

			asm
				cld;
				mov: ESI to: temp1;
				mov: EDI to: temp2;
			
				pop: ESI; " src"
				pop: EDI; "dst"
				pop: ECX; "numBytes"
				rep; movsb;
				mov: temp1 to: ESI;
				mov: temp2 to: EDI
		]! !

!NativeBoost methodsFor: 'accessing' stamp: 'Igor.Stasenko 5/5/2010 16:47'!
newAssembler

	self subclassResponsibility ! !

!NativeBoost methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 13:52'!
pointerSize

	self subclassResponsibility ! !

!NativeBoost methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 5/2/2010 13:36'!
primEnableNativeCode
	"Primitive.
	Enables the execution of native code, which initially disabled during fresh image boot "
	<primitive: #primitiveEnable module: #NativeBoostPlugin> 

! !

!NativeBoost methodsFor: 'memory access' stamp: 'Igor.Stasenko 5/3/2010 10:31'!
ulongAt: ulongAddr

	| buf |
	
	buf := ByteArray new: 8.
	
	self ulongAt: ulongAddr into: buf.
	
	^ buf unsignedLongAt: 1 bigEndian: false! !

!NativeBoost methodsFor: 'memory access' stamp: 'IgorStasenko 11/24/2012 16:01'!
ulongAt: addr into: returnValueBuffer

	"read uint from given address"
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>

	^ self nbCallout
		" do not use optimizations, since it may lead to infinite resursion"
		options: #( - optDirectProxyFnAddress optUseStackPointer + optNoAlignment);
		function: #( NBBootstrapUlong (ulong addr))
		emit: [:gen | |asm|
			asm := gen asm.
			asm pop: asm EAX.
			asm mov: asm EAX ptr to: asm EAX
			]
! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/22/2012 18:32'!
nbAddress
	"Return the native address"
	<primitive: 'primitiveNativeCall' module: 'NativeBoostPlugin'>

	^ self nbCallout  
		function: #( int ( void ) )  
		emit: [:gen :proxy :asm | proxy receiver ]! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/24/2012 16:07'!
nbCall: fnSpec
	" you can override this method if you need to"
	
	^ (self nbCalloutIn: thisContext sender)
		convention: self nbCallingConvention;
		function: fnSpec module: self nbLibraryNameOrHandle ! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/24/2012 16:07'!
nbCall: fnSpec module: aModuleNameOrHandle
	" you can override this method if you need to"

	^ (self nbCalloutIn: thisContext sender)
		convention: self nbCallingConvention;
		function: fnSpec module: aModuleNameOrHandle ! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/24/2012 16:07'!
nbCall: fnSpec module: aModuleNameOrHandle options: callOptions
	" you can override this method if you need to"

	^ (self nbCalloutIn: thisContext sender)
		convention: self nbCallingConvention;
		options: callOptions;
		function: fnSpec module: aModuleNameOrHandle ! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/24/2012 16:07'!
nbCall: fnSpec options: callOptions
	" you can override this method if you need to"

	^ (self nbCalloutIn: thisContext sender)
		convention: self nbCallingConvention;
		options: callOptions;
		function: fnSpec module: self nbLibraryNameOrHandle ! !

!Object methodsFor: '*NativeBoost-core' stamp: 'JavierPimas 11/17/2011 11:12'!
nbCallingConvention
	^#cdecl
! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/22/2012 14:25'!
nbCallout

	^ NBFFICalloutAPI inContext: thisContext sender! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 11/22/2012 14:25'!
nbCalloutIn: aContext

	^ NBFFICalloutAPI inContext: aContext! !

!Object methodsFor: '*NativeBoost-core' stamp: 'IgorStasenko 1/17/2012 16:04'!
nbGetSymbolAddress: aName module: aModuleNameOrHandle
	"Lookup for given symbol in external module and answer its address
	(an instance of NBExternalAddress), or nil if not found.
	
	A default implementation,
	first we try to use OS-specific symbol lookup mechanism,
	and if not found, we try to lookup a symbol from VM registered plugin(s)"
	
	| addr |
	
	addr := NativeBoost loadSymbol: aName fromModule: aModuleNameOrHandle.

	^ addr ifNil: [ 
		"loadfunction takes only names, not handles"
		aModuleNameOrHandle isString 
			ifFalse: [ nil ] 
			ifTrue: [ NativeBoost loadFunction: aName from: aModuleNameOrHandle ]]! !

!Object methodsFor: '*NativeBoost-core' stamp: 'CamilloBruni 1/13/2013 18:20'!
nbLibraryNameOrHandle
	self flag: 'HACK: avoid direct subclassResponsibility to not break RB test cases..'.
	^ SubclassResponsibility signalFor: thisContext selector
! !
NBExternalEnumeration initialize!
NBInterpreterProxy initialize!
NBFFICallout initialize!
NativeBoost initialize!
